<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/resTree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/inc/usermenu.inc" -->
<%
  var lastFile = restree.getResourceValue( "services.store.lastFile" );
  var imgDir = restree.getResourceValue( "services.volumes.0.directory" );
  var lastImage = "/Card/images/" + imgDir + "/" + lastFile;

  var mode = Request.QueryString( "mode" );
  if( mode == "" )
    mode = "Live";

  var radiometric;
  if( Request.QueryString( "radiometric" ) == "on" )
    radiometric = "on";
  else
    radiometric = "off";

  var refreshMode = Request.QueryString( "refreshMode" );
%>
<html>
  <head>
    <script>
      var presMode;
      var timeOut;
      var refreshMode = <% if( refreshMode == "on" ) Response.Write( "true" ); else Response.Write( "false" ); %>;

      function selectMode()
      {
        var RandomVal = Math.random();
        var RandomString = new String( RandomVal.toString( 16 ) );
        var f = parent.frames[ 0 ];

        document.getElementById( "selValue" ).value = document.getElementById( "mode" ).value;
        if( document.getElementById( "mode" ).value == "LastStored" )
        {
          f.document.images[ "webimg" ].src = "<% Response.Write( lastImage ); %>";
        }
        else if( document.getElementById( "mode" ).value == "Freeze" )
        {
          f.document.images[ "webimg" ].src = "/Ram/web.jpg?" + RandomString;
        }
        else if( document.getElementById( "mode" ).value == "Live" )
        {
          f.winRefresh();
        }
      }

      function reloadDocument()
      {
        var s = new String( window.location.protocol );
        s += "//";
        s += window.location.host;
        s += window.location.pathname;
        s += "?mode=";
        s += document.getElementById( "selValue" ).value;
        if( document.getElementById( "radiometric" ).checked )
          s += "&radiometric=on";
        else
          s += "&radiometric=off";

        s += "&refreshMode=on";
        window.location.href = s;
      }

      function bkgProcess()
      {
        newMode = document.getElementById( "selValue" ).value;
        if( newMode == presMode && newMode == "LastStored" )
        {
          timeOut--;
          if( timeOut <= 0 )
            reloadDocument();
          else
            window.setTimeout( "bkgProcess()", 1000 );
        }
        else
        {
          timeOut = 10;
          presMode = newMode;
          window.setTimeout( "bkgProcess()", 1000 );
        }
      }

      function startBkg()
      {
        if( refreshMode )
        {
          var f = parent.frames[ 0 ];

          if( document.getElementById( "mode" ).value == "LastStored" )
          {
            f.document.images[ "webimg" ].src = "<% Response.Write( lastImage ); %>";
          }
        }
        presMode = document.getElementById( "selValue" ).value;
        timeOut = 10;
        window.setTimeout( "bkgProcess()", 1000 );
      }
    </script>
  </head>
  <body onload="startBkg()">
    <form name="ctrlform" action="#" method="GET" onsubmit="return false">
      <table>
        <tr>
          <td>
            <input type="hidden" name="selValue" id="selValue" value="<% Response.Write( mode ); %>">
            <select name="mode" id="mode" size="1"  onChange="selectMode()">
              <option value="Live"<% if( mode == "Live" ) Response.Write( " selected" ); %>>Live</option>
              <option value="Freeze"<% if( mode == "Freeze" ) Response.Write( " selected" ); %>>Freeze</option>
<% if( CamType == "A" || CamType == "A2" ) Response.Write( "<!--\n" ); %>
              <option value="LastStored"<% if( mode == "LastStored" ) Response.Write( " selected" ); %>>Last stored</option>
<% if( CamType == "A"  || CamType == "A2" ) Response.Write( "-->\n" ); %>
            </select>
          </td>
          <td>
            <input type="checkbox" id="radiometric" name="radiometric"<% if( radiometric == "on" ) Response.Write( " checked" ); %>>&nbsp;Radiometric image<br>
          </td>
        </tr>
      </table>
    </form>
  </body>
</html>
