<%
	function printHWVersions()
	{
		var hwItem = "";
		
		restree.path = "version.hw";
		hwItem = restree.getFirst();
		
		while (hwItem != "")
		{
			Response.Write('<tr><td>' + hwItem + '</td>');
			Response.Write('<td>' + restree.getResourceValue(hwItem + ".article") + '</td>');
			Response.Write('<td>' + restree.getResourceValue(hwItem + ".revision") + '</td>');
			Response.Write('<td>' + restree.getResourceValue(hwItem + ".serial") + '</td></tr>');		
			hwItem = restree.getNext();
		}
	}
	
	function printKitVersions()
	{
		var hwItem = "";
		var tmpValue = "";
		restree.path = "";
		tmpValue = restree.getResourceValue("version.swcombination.ver");
		if (tmpValue != "FAILED")
		{
			Response.Write('<tr><td>SW combination</td>');
			Response.Write('<td colspan="2" align="left">' + tmpValue + '</td></tr>');
		}
		restree.path = "version.kits";
		hwItem = restree.getFirst();

		while (hwItem != "")
		{
			Response.Write('<tr><td>' + restree.getResourceValue(hwItem + ".name") + '</td>');
			Response.Write('<td>' + restree.getResourceValue(hwItem + ".ver") + '</td>');
			Response.Write('<td>' + restree.getResourceValue(hwItem + ".date") + '</td></tr>');

			hwItem = restree.getNext();
		}
	}
	
	function stripFailed(str)
	{
		var res;
		if (str == "FAILED")
		{
			res = "-";
		}
		else
		{
			res =str;
		}
		return res;
	}
	
	function printSWVersions( versionNode )
	{
		var hwItem = "";
		var tmpValue = "";
		restree.path = versionNode;
		hwItem = restree.getFirst();
		
		while (hwItem != "")
		{
			Response.Write('<tr><td>' + hwItem + '</td>');
			Response.Write('<td>' + stripFailed(restree.getResourceValue(hwItem + ".ver")) + '</td>');
			Response.Write('<td>' + stripFailed(restree.getResourceValue(hwItem + ".date")) + '</td>');

			tmpValue = restree.getResourceValue(hwItem + ".maker");
			if (tmpValue != "FAILED")
			{
				Response.Write('<td>' + tmpValue + '</td></tr>');
			}
			else
			{
				Response.Write('<td>-</td></tr>');
			}
			hwItem = restree.getNext();
		}
	}
%>
