<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<%
  if( Request.Form.Count > 0 ) {
    m_val = new Number( toDecPoint( Request.Form( "ambTemp" ) ) );
    m_val += 273.15;
    restree.setResourceValue( "image.sysimg.basicImgData.objectParams.ambTemp", m_val.toString( 10 ) );
    m_val = new Number( toDecPoint( Request.Form( "atmTemp" ) ) );
    m_val += 273.15;
    restree.setResourceValue( "image.sysimg.basicImgData.objectParams.atmTemp", m_val.toString( 10 ) );
    restree.setResourceValue( "image.sysimg.basicImgData.objectParams.objectDistance", toDecPoint( Request.Form( "distance" ) ) );
    restree.setResourceValue( "image.sysimg.basicImgData.objectParams.emissivity", toDecPoint( Request.Form( "emissivity" ) ) );
    if( CamType != "Z" && CamType != "Z3" ) {
      m_val = new Number( toDecPoint( Request.Form( "extOptTemp" ) ) );
      m_val += 273.15;
      restree.setResourceValue( "image.sysimg.basicImgData.objectParams.extOptTemp", m_val.toString( 10 ) );
      restree.setResourceValue( "image.sysimg.basicImgData.objectParams.extOptTransm", toDecPoint( Request.Form( "extOptTrans" ) ) );
    }
    m_val = new Number( toDecPoint( Request.Form( "relHum" ) ) );
    m_val /= 100;
    restree.setResourceValue( "image.sysimg.basicImgData.objectParams.relHum", m_val );
  }
  m_val = new Number( restree.getResourceValue( "image.sysimg.basicImgData.objectParams.ambTemp" ) );
  m_val -= 273.15;
  pres_ambTemp = m_val.toFixed( 1 );
  m_val = new Number( restree.getResourceValue( "image.sysimg.basicImgData.objectParams.atmTemp" ) );
  m_val -= 273.15;
  pres_atmTemp = m_val.toFixed( 1 );
  m_val = new Number( restree.getResourceValue( "image.sysimg.basicImgData.objectParams.objectDistance" ) );
  if( m_val >= 10 )
    pres_distance = m_val.toFixed( 0 );
  else
    pres_distance = m_val.toFixed( 1 );
  m_val = new Number( restree.getResourceValue( "image.sysimg.basicImgData.objectParams.emissivity" ) );
  pres_emissivity = m_val.toFixed( 3 );
  m_val = new Number( restree.getResourceValue( "image.sysimg.basicImgData.objectParams.extOptTemp" ) );
  m_val -= 273.15;
  pres_extOptTemp = m_val.toFixed( 1 );
  m_val = new Number( restree.getResourceValue( "image.sysimg.basicImgData.objectParams.extOptTransm" ) );
  pres_extOptTrans = m_val.toFixed( 3 );
  m_val = new Number( restree.getResourceValue( "image.sysimg.basicImgData.objectParams.relHum" ) );
  m_val *= 100;
  pres_relHum = m_val.toFixed( 0 );

  var strTitle = "Set Object Parameters";
%>
<HTML>
  <HEAD>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
  </HEAD>
    <body id="pgCalibAccMeasSetObjpar">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuCalib", "mnuCalibAccMeasSetObjpar" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE ="Table1">
                    <TR>
                        <TD>
                            <FORM METHOD="post" ACTION="AccMeasSetObjpar.asp" ID="Form1">
                                <TABLE ID="Table2">
                                    <TR>
                                        <TD>
                                            Ambient Temperature:
                                        </TD>
                                        <TD>
                                            <INPUT TYPE="input" NAME="ambTemp" SIZE="5" maxlength="6"
                                                  ID="Input1" VALUE="<%Response.Write( pres_ambTemp );%>">[C]
                                        </TD>
                                    </TR>
                                    <TR>
                                        <TD>
                                            Atmosphere Temperature:
                                        </TD>
                                        <TD>
                                            <INPUT TYPE="input" NAME="atmTemp" SIZE="5" maxlength="6"
                                                  ID="Input2" VALUE="<%Response.Write( pres_atmTemp );%>">[C]
                                        </TD>
                                    </TR>
                                    <TR>
                                        <TD>
                                            Distance:
                                        </TD>
                                        <TD>
                                            <INPUT TYPE="input" NAME="distance" SIZE="5" maxlength="5"
                                                 ID="Input3" VALUE="<%Response.Write( pres_distance );%>">[m]
                                        </TD>
                                    </TR>
                                    <TR>
                                        <TD>
                                            Emissivity:
                                        </TD>
                                        <TD>
                                            <INPUT TYPE="input" NAME="emissivity" SIZE="5" maxlength="5"
                                                 ID="Input4" VALUE="<%Response.Write( pres_emissivity );%>">
                                        </TD>
                                    </TR>
<% if( CamType == "Z" || CamType == "Z3" ) Response.Write( "<!--\n" ); %>
                                    <TR>
                                        <TD>
                                            External Optics Temperature:
                                        </TD>
                                        <TD>
                                            <INPUT TYPE="input" NAME="extOptTemp" SIZE="5" maxlength="6"
                                               ID="Input5" VALUE="<%Response.Write( pres_extOptTemp );%>">[C]
                                        </TD>
                                    </TR>
                                    <TR>
                                        <TD>
                                            External Optics Transmission:
                                        </TD>
                                        <TD>
                                            <INPUT TYPE="input" NAME="extOptTrans" SIZE="5" maxlength="6"
                                                 ID="Input6" VALUE="<%Response.Write( pres_extOptTrans );%>">
                                        </TD>
                                    </TR>
<% if( CamType == "Z" || CamType == "Z3" ) Response.Write( "-->\n" ); %>
                                    <TR>
                                        <TD>
                                            Relative Humidity:
                                        </TD>
                                        <TD>
                                            <INPUT TYPE="input" NAME="relHum" SIZE="5" maxlength="6"
                                                  ID="Input7" VALUE="<%Response.Write( pres_relHum );%>">[%]
                                        </TD>
                                    </TR>
                                    <TR>
                                        <TD>
                                            <INPUT TYPE="submit" VALUE="Apply" ID="Submit1" NAME="Submit1"> &nbsp;
                                        </TD>
                                        <TD>
                                            &nbsp;
                                        </TD>
                                    </TR>
                                </TABLE>
                            </FORM>
                        </TD>
                    </TR>
                </TABLE>
            </div>
            <%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</HTML>
