<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/serviceutils.inc" -->
<%

  /* Create proper working conditions in the camera  */
  var bAppStarted = isAppStarted("prodapp", "prod.syscalib.ecode");
  var bEnabled = bAppStarted;
	var strDisabled = "disabled ";
  var strStateName;
  var nEcode = -1;
  var debug = false
  if (bAppStarted)
  {
    strStateName = restree.getResourceValue("prod.syscalib.accStateName");
    if ( strStateName == "Idle" )
    {
      restree.setResourceValue("prod.syscalib.command", "accInit");
      bEnabled = waitWhileBusy("prod.syscalib.status");
    }
    nEcode = restree.getResourceValue("prod.syscalib.ecode");
  }
	if ( bEnabled ) 
	  strDisabled = "";


  /* Dummy initiations of our form content variables  */
  
	var CCaseSelector = new SelectTag("caseList", 0, "multiple " + strDisabled);
	var strCaseID = "";
    var strSN="";
  if (bEnabled)
  {
    /* Check that we have a legal strStateName  */
    
    /* Go through the submitted form , if it is our own one. */
    
    if ( Request.Form.Count > 0 && Request.Form ( "SubmitAddLensCase" ) != "" ) 
    {
	    if (CamType=="E2")
		{
			strSN=Request.Form("Serial");
			
			if (strSN !="")
			{
				 restree.setResourceValue("image.flow.lensExt.lensConnected", false);
				 restree.sleep(1500);
				restree.setResourceValue("image.flow.lensExt.SN", strSN);
				
				restree.setResourceValue("prod.syscalib.command", "addLensData");
				if ( !waitWhileBusy("prod.syscalib.status") )
				  nEcode = -1;
				else
				{
				nEcode = restree.getResourceValue("prod.syscalib.ecode");
				}
				
				 restree.setResourceValue("image.flow.lensExt.lensConnected", true);
				 restree.sleep(1500);
			}

		}
		strCaseID = Request.Form("caseList");
	    restree.setResourceValue("prod.syscalib.caseID", convFromSelSepToTab( strCaseID ));
	    restree.setResourceValue("prod.syscalib.command", "addLensCases");

	    if ( !waitWhileBusy("prod.syscalib.status") )
	      nEcode = -1;
	    else
	    {
        nEcode = restree.getResourceValue("prod.syscalib.ecode");
	    }
    }

    /* We are about to show our own form now. Fetch proper data for it */
    
	    var restreeImgFlowLens = new ResTree();
		var bExternalLens=false;
        if ( restreeImgFlowLens.valueType("image.flow.lensExt.lensConnected") == "bool" ) // E camera with external lens
        {
           if ( restreeImgFlowLens.getResourceValue("image.flow.lensExt.lensConnected") == true )
               {
			   restreeImgFlowLens.path = "image.flow.lensExt";
			   bExternalLens=true;
			   }
			
           else
            restreeImgFlowLens.path = "image.flow.lensInt";
        }
        else
            restreeImgFlowLens.path = "image.flow.lens";

	    
		var strCaseDescr = "";
		var strCaseID = "";
		var strCaseLensID = "";
		var strLensID = restreeImgFlowLens.getResourceValue("name");
		var n = 0;
		restree.path = "calib.ccase";

		var CCaseItem = restree.getFirst();
  	
		while (CCaseItem != "")
		{
		  strCaseDescr = restree.getResourceValue(CCaseItem + ".descr");
		  strCaseID = restree.getResourceValue(CCaseItem + ".ID");

		  n = strCaseID.indexOf("_le");
		  if ( n >= 0 )
		     strCaseLensID = strCaseID.substr( n + 3 );
		  else
		     strCaseLensID = strCaseID;
		     
		  n = strCaseLensID.indexOf("$");
		  if ( n >= 0 )
		    strCaseLensID = strCaseLensID.substr(0,n);
		  
		  if ( strCaseLensID == strLensID )
		    CCaseSelector.option( strCaseID, strCaseDescr, false );
  		  
			CCaseItem = restree.getNext();
		}
		restree.path = "";
  }
  var strTitle = "Add Cases for one lens";
  var strLensSerial = restreeImgFlowLens.getResourceValue("SN");
  var bLensWithSerial = (strLensSerial != "");
    
  var strCurrentLens = restreeImgFlowLens.getResourceValue("descr");
  if ( bLensWithSerial )  
     strCurrentLens += " #" + strLensSerial;
%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    </head>
    <body id="pgCalibSysCalibAddLensCases">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuCalib", "mnuCalibSysCalibAddLensCase" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE>
                <TR>
                    <TD VALIGN="TOP" colspan=2>
                        This page adds special calibration cases for the current lens only.<br>
                        They will not be used with any other lens individuals.<BR><BR>
                        The current lens is:&nbsp;
                        <%
                          Response.Write( strCurrentLens + "<BR><BR>");
                          if ( bEnabled == false )
                              Response.Write("<span id=errstatus> Production Application not available! </span>");
                          else if (bLensWithSerial)
                              Response.Write("<span id=OKstatus> Select the cases you want to copy from, and press copy. </span>");
                          else
                              Response.Write("<span id=errstatus> No lens serial number available! </span>");
						 
                        %>
                        <BR>
                    </td>
                </TR>
                <TR>
                    <TD VALIGN="TOP">
                    <FORM ACTION="#" METHOD="post" NAME=selcase ID="Form1">
                        <%CCaseSelector.print();%><br><br>
						<% if ( CamType == "E2" &&( (bEnabled && !bLensWithSerial && bExternalLens)) )
						{
                        Response.Write("<p>Enter Lens Serial:</p>");
						Response.Write("<INPUT TYPE=\"input\" NAME=\"Serial\" SIZE =\"40\" ID=\"Serial\"") 	  
					    } %>
						<BR>
                        <BR>
                        <BR>
                        <INPUT TYPE="submit" VALUE="Copy" ID="Copy" NAME="SubmitAddLensCase"  <%if ( !(bEnabled && (bLensWithSerial|| (CamType=="E2" && bExternalLens))) ) Response.Write("disabled");%>>
						 

         
                    </FORM>
                    </TD>
                </TR>
                </TABLE>
            </div>
            <div>
			      <%printStandardFooter();%>
            </div>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
