<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/serviceutils.inc" -->
<%
  /* Create proper working conditions in the camera  */

  var bAppStarted = isAppStarted("prodapp", "prod.syscalib.ecode");
  var bEnabled = bAppStarted;
	var strDisabled = "disabled ";
  var strStateName;
  var strPrompt;
  var nEcode = -1;
  
  if (bAppStarted)
  {
    strStateName = restree.getResourceValue("prod.syscalib.stateName");
    if ( strStateName == "Idle" )
    {
      restree.setResourceValue("prod.syscalib.command", "init");
      bEnabled = waitWhileBusy("prod.syscalib.status");
    }
    strPrompt = restree.getResourceValue("prod.syscalib.prompt");
    nEcode = restree.getResourceValue("prod.syscalib.ecode");
  }
	if ( bEnabled ) 
	  strDisabled = "";

  /* Dummy initiations of our form content variables  */
	var CCaseSelector = new SelectTag("caseList", 0, "multiple " + strDisabled);
	var strCCaseID = "";
	var strClearCheck = "checked";
	var strAddOneCheck = "";
	var strDelOneCheck = "";
	var strRemeasureCheck = "";
	
	var BBSelector = new SelectTag("BBList", 0, strDisabled);
	BBSelector.option("*","All",false);

  if (bEnabled)
  {
    /* Check that we have a legal strStateName  */
    
    if (strStateName != "Measure" && strStateName != "Calculate")
    {
      if (strStateName == "Empty" || strStateName == "Idle")
         strStateName = "Select";
         
	    var strRedirectTo1 = "/service/calib/SysCalib" + strStateName + ".asp";
  	  
	    Response.Redirect(strRedirectTo1);
	    // This point should never be reached.....
	  }
	  
    /* Go through the submitted form , if it is our own one. */
    
    if ( Request.Form.Count > 0 && Request.Form( "SubmitEditMeas" ) != "" ) 
    {
	    strBBname = Request.Form("BBList");
	    restree.setResourceValue("prod.syscalib.BBname", strBBname);
	    strCCaseID = Request.Form("caseList");
	    restree.setResourceValue("prod.syscalib.caseID", convFromSelSepToTab(strCCaseID));
	    if ( Request.Form("remeasure") != "" )
	      strRemeasureCheck = "checked";
	      
	    restree.setResourceValue("prod.syscalib.command", Request.Form("action"));

	    if ( !waitWhileBusy("prod.syscalib.status") )
	      nEcode = -1;
	    else
	    {
        nEcode = restree.getResourceValue("prod.syscalib.ecode");
        strPrompt = restree.getResourceValue("prod.syscalib.prompt");
	    }
	    
	    if ( nEcode == 0 && strRemeasureCheck != "" )
	    {
        /* Submitted form OK, lets go to the next page. */
        
        strStateName = restree.getResourceValue("prod.syscalib.stateName");
        
        if (strStateName == "Empty" || strStateName == "Idle")
          strStateName = "Select";
           
	      var strRedirectTo2 = "/service/calib/SysCalib" + strStateName + ".asp";
  	  
	      Response.Redirect(strRedirectTo2);
	      // This point should never be reached.....
	    }
    }
	  
    /* Error in submitted form, or no submitted form. */
    /* We are about to show our own form now. Fetch proper data for it */

		var strCaseDescr = "";
		var bCaseSelected = false;
		var bCaseEnabled = false;
		var strFlagsResName = "";
		var nFlags = 0;
		var strRvalResName = "";
		var fRval = 1.0;
		var strRBFInfo = "";
		var strCurrentSel = restree.getResourceValue("prod.syscalib.caseID");
  	
		restree.path = "calib.ccase";
	  var restreeRBFCache = new ResTree();
		restreeRBFCache.path = "calib.extRBFCalc.recalData.RBFCache";

		var CCaseItem = restree.getFirst();
  	
		while (CCaseItem != "")
		{
		  strCaseDescr = restree.getResourceValue(CCaseItem + ".descr");
		  strCaseID = restree.getResourceValue(CCaseItem + ".ID");
		  bCaseSelected = restree.getResourceValue(CCaseItem + ".recalibSel");
		  if (bCaseSelected)
		  {
		    bCaseEnabled = restree.getResourceValue(CCaseItem + ".enabled");
		    if ( bCaseEnabled )
		    {
		      strFlagsResName = strCaseID + ".RBFflags";
		      strRvalResName = strCaseID + ".R";
		      if ( restreeRBFCache.valueType(strFlagsResName) != "N/A" )
		      {
		        nFlags = restreeRBFCache.getResourceValue(strFlagsResName);
		        fRval = restreeRBFCache.getResourceValue(strRvalResName)
		      }
		      else
		        nFlags = -1;
  		      
		      strRBFInfo = evalRBFFlags(fRval,nFlags);
		    }
		    else
		        strRBFInfo = "(Disabled)";

		    bCaseSelected = false;
		    if (splitSearch(strCurrentSel, strCaseID) >= 0)
		       bCaseSelected = true;
  		         		
		    CCaseSelector.option( strCaseID, strCaseDescr + " " + strRBFInfo, bCaseSelected );
		  }
			CCaseItem = restree.getNext();
		}

		var strBBName = "";

		restree.path = "prod.prodSpec.calib.config.blackBodies";

		var BBItem = restree.getFirst();
  	
		while (BBItem != "")
		{
		  strBBName = restree.getResourceValue(BBItem + ".descr");
		  BBSelector.option( strBBName, strBBName, 0 );
			BBItem = restree.getNext();
		}
		restree.path = "";
}
var strTitle = "Edit Measurements";
  
%>

<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
  <!--- Browser scripts --->
            <script>
            function AreYouSure()
            {
              if(document.forms[0].action[0].checked)
              {
                  return confirm("Clearing measurement!!\n     Are you sure?");
              }
              else if(document.forms[0].action[2].checked)
              {
                  return confirm("Deleting measurement!!\n     Are you sure?");
              }
              return true;
            }
            </script>
  <!--- End of browser scripts --->
    </head>
    <body id="pgCalibSysCalibEditMeas">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuCalib", "mnuCalibSysCalibEditMeas" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE>
                    <TR>
                        <TD VALIGN="top" colspan="2">
                        <%
                          if ( bEnabled == false )
                              Response.Write("<span id=errstatus> Production Application not available! </span>");
                          else if ( nEcode == 0 )
                              Response.Write("<span id=OKstatus> Select measurements by case and by blackbody and choose an action </span>");
                          else
                              Response.Write("<span id=errstatus>" + strPrompt + "</span>");
                        %>
                        </TD>
                    </TR>
                    <TR>
                        <TD VALIGN="top">
                            <FORM ACTION="#" METHOD="post" NAME="measedit" ID="Form1" onSubmit="return AreYouSure();">
                                By case<br>
                                <%CCaseSelector.print();%><br>
                                <BR>
                                By blackbody<br>
                                <%BBSelector.print();%><br>
                                <BR>
                                <BR>
                                Action<BR>
                                &nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE="radio" NAME="action" VALUE="clearAllSel" ID="Radio2" <% Response.Write(strClearCheck);  if ( !bEnabled ) Response.Write("disabled");%>></INPUT>&nbsp;&nbsp;Clear&nbsp;&nbsp;&nbsp;&nbsp;<BR>
                                &nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE="radio" NAME="action" VALUE="addOneBB" ID="Radio3"  <% Response.Write(strAddOneCheck); if ( !bEnabled ) Response.Write("disabled");%>></INPUT>&nbsp;&nbsp;Add 
                                one&nbsp;&nbsp;&nbsp;&nbsp;<BR>
                                &nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE="radio" NAME="action" VALUE="delOneBB" ID="Radio4"  <% Response.Write(strDelOneCheck); if ( !bEnabled ) Response.Write("disabled");%>></INPUT>&nbsp;&nbsp;Delete 
                                one&nbsp;&nbsp;&nbsp;&nbsp;<BR>
                                &nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE="checkbox" NAME="remeasure" ID="Checkbox1"  <% Response.Write(strRemeasureCheck); if ( !bEnabled ) Response.Write("disabled");%>>&nbsp;&nbsp;Remeasure now&nbsp;&nbsp;&nbsp;&nbsp;</INPUT><BR>
                                <br>
                                <INPUT TYPE="submit" VALUE="Edit" ID="Button2" NAME="SubmitEditMeas"  <%if ( !bEnabled ) Response.Write("disabled");%>>
                            </FORM>
                        </TD>
                        <TD VALIGN="top">
                            <% PrintCalibStatusInfo(false, true); %>
                        </TD>
                    </TR>
                </TABLE>
            </div>
			<%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
