<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/serviceutils.inc" -->
<%

	restree.path = ".calib.visual.fusion";
	if (Request.Form( "setfarfocus" ) != "" )
	{
		/* read the new far focus values */
		var strLensId = restree.getFirst();
  	
		while( strLensId != "" )
		{
			var FarFocus = new Number( 0 );
      FarFocus = Request.Form( strLensId );
      restree.setResourceValue( strLensId + ".C3X", FarFocus );
			strLensId = restree.getNext();
		}

		/* save calib.rsc */
		restree.path = "dump";
		restree.setResourceValue( "file", "/flashfs/system/calib.rsc" );
    restree.setResourceValue( "forcePersistent", "on" );
    restree.setResourceValue( "node", "calib" );
    restree.setResourceValue( "includeDefault", "on" );
    restree.setResourceValue( "relativePaths", "off" );
		restree.setResourceValue( "commit", "on");

  }
	else {
		/* create fusion calib branches */
		var Lens = "";
		restree.path = "";
		Lens = restree.getResourceValue( ".image.flow.lensInt.name" );
		if( Lens != "" )  {
			Lens = restree.getResourceValue( ".image.flow.lensInt.name" );
			Lens = "le" + Lens;
			var Temp = restree.getResourceValue( ".calib.visual.fusion." + Lens );			
			if( Temp == "FAILED" ) {
				restree.setResourceValueWait( ".appl.supv.exec", "rcreate -n " + Lens + " .calib.visual.fusion" );
				restree.setResourceValueWait( ".calib.visual.fusion." + Lens + ".C3X", 3200.0 );
			}
		}
		Lens = restree.getResourceValue( ".image.flow.lensExt.name" );
		if( Lens != "" ) {
			Lens = "le" + Lens;
			var Temp = restree.getResourceValue( ".calib.visual.fusion." + Lens );			
			if( Temp == "FAILED" ) {
				restree.setResourceValueWait( ".appl.supv.exec", "rcreate -n " + Lens + " .calib.visual.fusion" );
				restree.setResourceValueWait( ".calib.visual.fusion." + Lens + ".C3X", 3200.0 );
				
			}
		}
	}

  var strTitle = "Set Far focus for Lens";


%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    </head>
    <body id="pgCalibSysCalibFarFocus">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuCalib", "mnuCalibSysCalibFarFocus" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
        <div id="content">
        <TABLE>


        <TR>
            <TD VALIGN="TOP" colspan=2>
                <%
                      Response.Write("<span id=OKstatus> Enter new far focus positions and press apply. </span>");
                %>
                <BR>
                <BR>
            </td>
        </TR>


        <FORM ACTION="#" METHOD="post" NAME=selcase ID="Form1">

<%		
		restree.path = ".calib.visual.fusion";
		var strLensId = restree.getFirst();
		Response.Write( "<TR><TD><B>Lens</B></TD><TD><B>Far Focus</B></TD></TR>" );
		while (strLensId != "")
		{
			/* Display the old far focus values */
      var FarFocus = restree.getResourceValue( strLensId + ".C3X", FarFocus );
			Response.Write( "<TR><TD><B>" + strLensId + "</B></TD>" );
			Response.Write( '<TD><INPUT TYPE="input" SIZE="10" maxlength="10" ID=strLensId VALUE =' );
			Response.Write( FarFocus ); 
			Response.Write( "  NAME=" ); 
			Response.Write( strLensId ); 
			Response.Write( "> </TD></TR>" ); 
			strLensId = restree.getNext();
		}
%>
					<TR>
						<TD>
							<input type=submit id=button1 name=setfarfocus value="Apply">
						</TD>
					</TR>
				</FORM>

      </TABLE>

			</div>
				<div>
					<%printStandardFooter();%>
				</div>
			</div>
        <!-- End of actual contents -->
    </body>
</html>
