<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/serviceutils.inc" -->
<%
  /* Create proper working conditions in the camera  */

  var bAppStarted = isAppStarted("prodapp", "prod.syscalib.ecode");
  var bEnabled = bAppStarted;
	var strDisabled = "disabled ";
  var strStateName;
  var strPrompt;
  var nEcode = -1;
  
  if (bAppStarted)
  {
    strStateName = restree.getResourceValue("prod.syscalib.stateName");
    if ( strStateName == "Idle" )
    {
      restree.setResourceValue("prod.syscalib.command", "init");
      bEnabled = waitWhileBusy("prod.syscalib.status");
    }
    strPrompt = restree.getResourceValue("prod.syscalib.prompt");
    nEcode = restree.getResourceValue("prod.syscalib.ecode");
  }
	if ( bEnabled ) 
	  strDisabled = "";

  /* Dummy initiations of our form content variables  */
  
	var BBSelector = new SelectTag("BBList", 0, strDisabled);
	var strTrueT = "";
	var strEmiss = "";
	var strBBname = "";

  if (bEnabled)
  {
    /* Check that we have a legal strStateName  */
    
    if (strStateName != "Measure")
    {
      if (strStateName == "Empty" || strStateName == "Idle")
         strStateName = "Select";
         
	    var strRedirectTo1 = "/service/calib/SysCalib" + strStateName + ".asp";
  	  
	    Response.Redirect(strRedirectTo1);
	    // This point should never be reached.....
	  }

    /* Go through the submitted form , if it is our own one. */
    
    if ( Request.Form.Count > 0 && Request.Form ( "SubmitMeasureBB" ) != "" ) 
    {
	    strBBname = Request.Form("BBList");
	    restree.setResourceValue("prod.syscalib.BBname", strBBname);
	    strTrueT = toDecPoint(Request.Form("truet"));
	    restree.setResourceValue("prod.syscalib.cmdargMeas.BBtemp", 1.0*strTrueT + 273.15);
	    strEmiss = toDecPoint(Request.Form("emiss"));
	    restree.setResourceValue("prod.syscalib.cmdargMeas.BBemiss", 1.0*strEmiss);

      restree.setResourceValue("prod.syscalib.command", "measure");

	    if ( !waitWhileBusy("prod.syscalib.status") )
	      nEcode = -1;
	    else
	    {
        nEcode = restree.getResourceValue("prod.syscalib.ecode");
        strPrompt = restree.getResourceValue("prod.syscalib.prompt");
	    }
	    
	    if ( nEcode == 0 )
	    {
        /* Submitted form OK, lets go to the next page. */
        
        strStateName = restree.getResourceValue("prod.syscalib.stateName");
        
        if (strStateName != "Measure")
        {
	        var strRedirectTo2 = "/service/calib/SysCalib" + strStateName + ".asp";
  	      
	        Response.Redirect(strRedirectTo2);
	        // This point should never be reached.....
	      }
	    }
    }
    /* Error in submitted form, or no submitted form */
   

    /* We are about to show our own form now. Fetch proper data for it */

	  strTrueT = 1.0*restree.getResourceValue("prod.syscalib.cmdargMeas.BBtemp") - 273.15;
	  strEmiss = restree.getResourceValue("prod.syscalib.cmdargMeas.BBemiss");
	  var strBBnames = restree.getResourceValue("prod.syscalib.cmdargMeas.selBBnames");
	  if (strBBnames == "")
	    BBSelector.option( "None", "None", false);
	  else
	  {
	    var arrBBnames = strBBnames.split("\t");
	    var j = 0;
  	  
	    while ( j < arrBBnames.length )
	    {
	      BBSelector.option( arrBBnames[j], arrBBnames[j], j == 0);
	      j++;
	    }
	  }
  }
  var strTitle = "Measure Signal";
%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
  <!--- Browser scripts --->
        <SCRIPT>
            function setfocus()
            {
                document.measureBB.truet.focus();
            }
        </SCRIPT>
  <!--- End of browser scripts --->
    </head>
    <body id="pgCalibSysCalibMeasure" onload="setfocus()">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuCalib", "mnuCalibSysCalibMeasure" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE>
                <TR>
                    <TD VALIGN="TOP" colspan=2>
                    <%
                      if ( bEnabled == false )
                          Response.Write("<span id=errstatus> Production Application not available! </span>");
                      else if ( nEcode == 0 )
                          Response.Write("<span id=OKstatus>" + strPrompt + "</span>");
                      else
                          Response.Write("<span id=errstatus>" + strPrompt + "</span>");
                      
                    %>
                    <br><br>
                    <%
                       // We can't use the current lens here, due to the possiblity of a lens change
                       var strLensID   = restree.getResourceValue("prod.syscalib.cmdargMeas.calLensID");
                       if ( strLensID != "" && CamType != "X" && CamType != "Z" && CamType != "Z3" )
                       {
                          var strLensPath = "calib.lens." + strLensID;
                          var strLensName = restree.getResourceValue(strLensPath + ".descr");
                          var strLensSerial = restree.getResourceValue(strLensPath + ".SN");
                          var fCalibDistance = restree.getResourceValue(strLensPath + ".calib.distance");
                          var strAdapterName = restree.getResourceValue(strLensPath + ".calib.adapter");
                          var strMessage = "Use lens " + strLensName + " #" + strLensSerial;
                          if ( strAdapterName != "" )
                            strMessage += " with adapter " + strAdapterName;
                          if ( 1*fCalibDistance < 3 )
                             strMessage += " at " + fCalibDistance.toFixed(2) + " m";
                          else
                             strMessage += " and a collimator mirror";
                          strMessage += "<br><br>";
                          Response.Write(strMessage);
                       }
                       else if( CamType == "Z" || CamType == "Z3" )
                       {
                          var strLensPath = restree.getResourceValue( "image.ccase.lens" );
                          var fCalibDistance = restree.getResourceValue(strLensPath + ".calib.distance");
                          var strMessage = "Use distance " + fCalibDistance.toFixed(2) + " m<br><br>";
                          Response.Write(strMessage);
                       }
                    %>
                    </td>
                
                </TR>
                <TR>
                    <TD VALIGN="TOP">
                    <FORM ACTION="#" METHOD="post" NAME="measureBB" ID="Form1">
                        Blackbody<br>
                        <%BBSelector.print();%><br>
                        <BR>
                        <BR>
                        True temperature [&deg;C]&nbsp;&nbsp;&nbsp;<BR>
                        <INPUT TYPE="text" NAME="truet" MAXLENGTH="8" VALUE="<%Response.Write(strTrueT.toFixed(2));%>"  <%if ( !bEnabled ) Response.Write("disabled");%>><BR>
                        <BR>
                        Emissivity<BR>
                        <INPUT TYPE="text" NAME="emiss" MAXLENGTH="8" VALUE="<%Response.Write(strEmiss.toFixed(3));%>"  <%if ( !bEnabled ) Response.Write("disabled");%>><BR>
                        <BR>
                        <BR>
                        <INPUT TYPE="submit" VALUE="Measure now" ID="Submit1" NAME="SubmitMeasureBB" <%if ( !bEnabled ) Response.Write("disabled")%>>
                    </FORM>
                    </TD>
                    <TD VALIGN="TOP">
                        <% PrintCalibStatusInfo(false, true); %>
                    </TD>
                </TR>    
                </TABLE>
            </div>
			      <%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
