<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/serviceutils.inc" -->
<%
  /* Create proper working conditions in the camera  */

  var bAppStarted = isAppStarted("prodapp", "prod.syscalib.ecode");
  var bEnabled = bAppStarted;
	var strDisabled = "disabled ";
  var strStateName;
  var strPrompt;
  var nEcode = -1;
  
  if (bAppStarted)
  {
    strStateName = restree.getResourceValue("prod.syscalib.stateName");
    if ( strStateName == "Idle" )
    {
      restree.setResourceValue("prod.syscalib.command", "init");
      bEnabled = waitWhileBusy("prod.syscalib.status");
    }
    strPrompt = restree.getResourceValue("prod.syscalib.prompt");
    nEcode = restree.getResourceValue("prod.syscalib.ecode");
  }
	if ( bEnabled ) 
	  strDisabled = "";

  /* Dummy initiations of our form content variables  */
  
	var CCaseSelector = new SelectTag("caseList", 0, "multiple " + strDisabled);
	var strCaseID = "";
	var strSignature = "";
	var strLocation = "";
	var strRelHum = "";
	var strAmbTemp = "";
	var strClearOldCheck = "";
	var strEnaDefCheck = "checked";
    
  if (bEnabled)
  {
    /* Check that we have a legal strStateName  */
    
    /* Go through the submitted form , if it is our own one. */
    
    if ( Request.Form.Count > 0 && Request.Form ( "SubmitSelCase" ) != "" ) 
    {
	    strCaseID = Request.Form("caseList");
	    restree.setResourceValue("prod.syscalib.caseID", convFromSelSepToTab( strCaseID ));
	    strSignature = Request.Form("sign");
	    restree.setResourceValue("prod.syscalib.cmdargSel.signature", strSignature);
	    strLocation = Request.Form("loc");
	    restree.setResourceValue("prod.syscalib.cmdargSel.location", strLocation);
	    strRelHum = toDecPoint(Request.Form("hum"));
	    restree.setResourceValue("prod.syscalib.cmdargSel.relHum", strRelHum);

			if( CamType  == "G" ) {
				strAmbTemp = toDecPoint( Request.Form( "AmbTemp" ));
				restree.setResourceValue( "prod.syscalib.cmdargMeas.ambtemp", strAmbTemp );
			}

	    if ( Request.Form("ClearOld") != "" )
	      restree.setResourceValue("prod.syscalib.cmdargSel.clrOld", true);
	    else
	      restree.setResourceValue("prod.syscalib.cmdargSel.clrOld", false);
	    if ( Request.Form("EnaDef") != "" )
	      restree.setResourceValue("prod.syscalib.cmdargSel.enaDef", true);
	    else
	      restree.setResourceValue("prod.syscalib.cmdargSel.enaDef", false);
	    
	    restree.setResourceValue("prod.syscalib.command", "selCases");

	    if ( !waitWhileBusy("prod.syscalib.status") )
	      nEcode = -1;
	    else
	    {
        nEcode = restree.getResourceValue("prod.syscalib.ecode");
        strPrompt = restree.getResourceValue("prod.syscalib.prompt");
	    }
	    
	    if ( nEcode == 0 )
	    {
        /* Submitted form OK, lets go to the next page. */
        
        strStateName = restree.getResourceValue("prod.syscalib.stateName");
        
        if (strStateName != "Select" && strStateName != "Empty" && strStateName != "Idle")
        {
	        var strRedirectTo2 = "/service/calib/SysCalib" + strStateName + ".asp";
  	      
	        Response.Redirect(strRedirectTo2);
	        // This point should never be reached.....
	      }
	    }
    }

    /* Error in submitted form, or no submitted form. */
    /* We are about to show our own form now. Fetch proper data for it */

	  restree.setResourceValue( "image.settings.satLimits", "none" );
	  strLocation = restree.getResourceValue("prod.syscalib.cmdargSel.location");
	  strSignature = restree.getResourceValue("prod.syscalib.cmdargSel.signature");
		  strRelHum = restree.getResourceValue("prod.syscalib.cmdargSel.relHum");

		if( CamType  == "G" ) {
			strAmbTemp = restree.getResourceValue( "prod.syscalib.cmdargMeas.ambtemp" );
		}

	  //strClearOldCheck = ""; Never checked by default
	  var b = restree.getResourceValue("prod.syscalib.cmdargSel.enaDef")
	  if (!b) strEnaDefCheck = "";
	  
		strCaseID = "";
		var strCaseDescr = "";
		var bCaseSelected = false;
		var bCaseEnabled = false;
		var strFlagsResName = "";
		var nFlags = 0;
		var strRvalResName = "";
		var fRval = 1.0;
		var strRBFInfo = "";
  	
		restree.path = "calib.ccase";
	  var restreeRBFCache = new ResTree();
		restreeRBFCache.path = "calib.extRBFCalc.recalData.RBFCache";
	  var restreeRBF = new ResTree();
		restreeRBF.path = "calib.extRBF";

		var CCaseItem = restree.getFirst();
  	
		while (CCaseItem != "")
		{
		  strCaseDescr = restree.getResourceValue(CCaseItem + ".descr");
		  strCaseID = restree.getResourceValue(CCaseItem + ".ID");
		  bCaseSelected = restree.getResourceValue(CCaseItem + ".recalibSel");
		  bCaseEnabled = restree.getResourceValue(CCaseItem + ".enabled");
		  if ( bCaseEnabled )
		  {
		    strFlagsResName = strCaseID + ".RBFflags";
		    strRvalResName = strCaseID + ".R";
		    if ( restreeRBFCache.valueType(strFlagsResName) != "N/A" )
		    {
		      nFlags = restreeRBFCache.getResourceValue(strFlagsResName);
		      fRval = restreeRBFCache.getResourceValue(strRvalResName)
		    }
		    else if ( restreeRBF.valueType(strFlagsResName) != "N/A" )
		    {
		      nFlags = restreeRBF.getResourceValue(strFlagsResName);
		      fRval = restreeRBF.getResourceValue(strRvalResName)
		    }
		    else
		      nFlags = -1;
		      
		    strRBFInfo = evalRBFFlags(fRval,nFlags);
		  }
		  else
		      strRBFInfo = "(Disabled)";
		         		
		  CCaseSelector.option( strCaseID, strCaseDescr + " " + strRBFInfo, bCaseSelected && bCaseEnabled );
  		  
			CCaseItem = restree.getNext();
		}
		restree.path = "";
  }
  var strTitle = "Select Cases";
%>

<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
  <!--- Browser scripts --->
        <SCRIPT>
            function setfocus()
            {
                document.selcase.hum.focus();
            }
        </SCRIPT>
  <!--- End of browser scripts --->
    </head>
    <body id="pgCalibSysCalibSelect" onLoad="setfocus()">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuCalib", "mnuCalibSysCalibSelect" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE>
                    <TR>
                        <TD VALIGN="top" colspan="2">
                            <%
                              if ( bEnabled == false )
                                  Response.Write("<span id=errstatus> Production Application not available! </span>");
                              else if ( nEcode == 0 )
                                  Response.Write("<span id=OKstatus> Please select cases for calibration </span>");
                              else
                                  Response.Write("<span id=errstatus>" + strPrompt + "</span>");
                            %>
                        </TD>
                    </TR>
                    <TR>
                        <TD VALIGN="top">
                                    
                            <FORM ACTION="#" METHOD="post" NAME="selcase" ID="Form1">
                                Case<br>
                                <%CCaseSelector.print();%><br>
                                <BR>
                                Humidity (in percent)
                                <BR>
                                <INPUT TYPE="text" MAXLENGTH="10" NAME="hum" VALUE="<%Response.Write(strRelHum);%>"  <%if ( !bEnabled ) Response.Write("disabled");%>><BR>
               <%
																	 if( CamType  == "G" ) {
																  		Response.Write( "<BR> Ambient Temperature<BR>")
																			Response.Write("<INPUT TYPE=\"text\" MAXLENGTH=\"10\" NAME=\"ambTemp\" VALUE=\"");
																			Response.Write( strAmbTemp );
																			Response.Write( "\">" );
																			if ( !bEnabled ) Response.Write("disabled");
																	 }
%>
																<BR><BR>
                                Location<BR>
                                <INPUT TYPE="text" MAXLENGTH="10" NAME="loc" VALUE="<%Response.Write(strLocation);%>" <%if ( !bEnabled ) Response.Write("disabled");%>><BR>
                                <BR>
                                Signature<BR>
                                <INPUT TYPE="text" MAXLENGTH="10" NAME="sign" VALUE="<%Response.Write(strSignature);%>"  <%if ( !bEnabled ) Response.Write("disabled");%>><BR>
                                <BR>
                                <input TYPE="checkbox" id="ClearOld" name="ClearOld" <%Response.Write(strClearOldCheck); if ( !bEnabled ) Response.Write("disabled");%>>&nbsp;Clear old measurements
                                <BR>
                                <BR>
                                <input TYPE="checkbox" id="EnaDef" name="EnaDef" <% Response.Write(strEnaDefCheck); if ( !bEnabled ) Response.Write("disabled");%>>&nbsp;Enable default measurements
                                <BR>
                                <BR>
                                <INPUT TYPE="submit" VALUE="Start Calibration" ID="Submit1" NAME="SubmitSelCase" <%if ( !bEnabled ) Response.Write("disabled");%>>
                            </FORM>
                        </TD>
                        <TD VALIGN="top">
                            &nbsp;
                        </TD>
                    </TR>
                </TABLE>
            </div>
			      <%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
