<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<%
  /* Server side script */
  var date, timeInSeconds, intervalInDays, intervalInSeconds, state;
  var year, month, day;

  if ( Request.Form.Count > 0 ) 
  {
    year = new Number( Request.Form( "sdYear" ) );
    month = new Number( Request.Form( "sdMonth" ) );
    day = new Number( Request.Form( "sdDay" ) );
    if( day > 31 || day < 1 )
      day = 1;

    if( month > 12 || month < 1 )
      month = 1;

    if( year > 2200 || year < 2000 )
      year = 2000;

    date = new Date( year, month - 1, day );
    timeInSeconds = new Number( date.getTime() / 1000 );
    restree.setResourceValue( "stats.serviceDueDate", timeInSeconds );
    restree.setResourceValue( "stats.serviceDueState", Request.Form( "sdState" ) );
    intervalInDays = new Number( Request.Form( "sdDelta" ) );
    intervalInSeconds = new Number( intervalInDays * 86400 );
    restree.setResourceValue( "stats.serviceRemindDelta", intervalInSeconds );
  }
  date = new Date( restree.getResourceValue( "stats.serviceDueDate" ) * 1000 );

  year = date.getFullYear();
  month = new String( date.getMonth() + 1 );
  if( month.length < 2 )
    month = "0" + month;

  day = new String( date.getDate() );
  if( day.length < 2 )
    day = "0" + day;

  state = restree.getResourceValue( "stats.serviceDueState" );
  timeInSeconds = new Number( restree.getResourceValue( "stats.serviceRemindDelta" ) );
  intervalInDays = timeInSeconds / 86400;
  var strTitle = "Service Due Setup";
%>
<HTML>
    <HEAD>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
            <script>
            function validate()
            {
              var year = new Number( document.getElementById( "year" ).value );
              var month = new Number( document.getElementById( "month" ).value );
              var day = new Number( document.getElementById( "day" ).value );
              var interval = new Number( document.getElementById( "interval" ).value );
              var eString = "OK";

              if( isNaN( year ) || year < 2000 || year > 2200 )
                eString = "Invalid year";
              else if( isNaN( month ) || month < 1 || month > 12 )
                eString = "Invalid month";
              else if( isNaN( day ) || day < 1 || day > 31 )
                eString = "Invalid day";
              else if( isNaN( interval ) || interval < 0 || interval > 365 )
                eString = "Invalid reminder interval";

              if( eString != "OK" )
              {
                alert( eString );
                return false;
              }
              return true;
            }
            </script>
    </HEAD>
    <body id="pgDiagServiceDue">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuDiag", "mnuDiagServiceDue" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
             <TABLE cellspacing=8">
              <TR>
               <TD VALIGN="top">
                <TABLE cellspacing=8">
                    <FORM ACTION="#" METHOD="post" NAME="ServiceDue" ID="Form2" onSubmit="return validate();">
                        <TR>
                            <TD VALIGN="top" colspan="3">
                                <u>Service due date</u>
                            </TD>
                        </TR>
                        <TR>
                            <TD>Year</TD>
                            <TD>Month</TD>
                            <TD>Day</TD>
                        </TR>
                        <TR>
                            <TD>
                                <INPUT id="year" type="text" size="6" name="sdYear" value="<%Response.Write( year );%>">
                            </TD>
                            <TD>
                                <INPUT id="month" type="text" size="6" name="sdMonth" value="<%Response.Write( month );%>">
                            </TD>
                            <TD>
                                <INPUT id="day" type="text" size="6" name="sdDay" value="<%Response.Write( day );%>">
                            </TD>
                        </TR>
                        <TR>
                            <TD VALIGN="top" colspan="3">&nbsp;</TD>
                        </TR>
                        <TR>
                            <TD VALIGN="top" colspan="3">
                                <u>Service due state</u>
                            </TD>
                        </TR>
                        <TR>
                            <TD>
                                <SELECT name="sdState" size="1">
                                    <OPTION value="enable"<%if( state == "enable" ) Response.Write( " selected" );%>>Enable</OPTION>
                                    <OPTION value="disable"<%if( state == "disable" ) Response.Write( " selected" );%>>Disable</OPTION>
                                </SELECT>
                            </TD>
                            <TD colspan="2">
                                Present state : <%Response.Write( state );%>
                            </TD>
                        </TR>
                        <TR>
                            <TD VALIGN="top" colspan="3">&nbsp;</TD>
                        </TR>
                        <TR>
                            <TD VALIGN="top" colspan="3">
                                <u>Reminder interval</u>
                            </TD>
                        </TR>
                        <TR>
                            <TD>
                                <INPUT id="interval" type="text" size=6" name="sdDelta" value="<%Response.Write( intervalInDays );%>">
                            </TD>
                            <TD VALIGN="top" colspan="2">
                                Days
                            </TD>
                        </TR>
                        <TR>
                            <TD VALIGN="top" colspan="3">&nbsp;</TD>
                        </TR>
                        <TR>
                            <TD>
                                <INPUT type="submit" value="Update" id="Button1" name="Update">
                            </TD>
                            <TD colspan="2">
                                &nbsp;
                            </TD>
                        </tr>
                    </FORM>
                </TABLE>
               </TD>
               <TD VALIGN="top">
                 <h2>Instruction</h2>
                 It is recommended that this IR camera is<BR>
                 sent to FLIR for regular maintenance.<BR>
                 For more information see camera user manual.<BR>
               </TD>
              </TR>
             </TABLE>
            </div>
            <%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</HTML>
