<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/eepromlock.inc" -->
<%
    /* Server side script */
    function inputHWVersions()
    {
	    var hwItem = "";
    	
	    restree.path = "version.hw";
	    hwItem = restree.getFirst();
    	
	    while (hwItem != "")
	    {
		    Response.Write('<tr><td>' + hwItem + '</td>');
	      if ( hwItem == "battery" )
	      {
		      Response.Write('<td>' + restree.getResourceValue(hwItem + ".article") + '</td>');
		      Response.Write('<td>' + restree.getResourceValue(hwItem + ".revision") + '</td>');
		      Response.Write('<td>' + restree.getResourceValue(hwItem + ".serial") + '</td></tr>');		
		    }
		    else
		    {
		      Response.Write('<td> <input type=text name=' + hwItem + '_article value="' + restree.getResourceValue(hwItem + ".article") + '"></td>');
		      Response.Write('<td> <input type=text name=' + hwItem + '_revision value="' + restree.getResourceValue(hwItem + ".revision") + '"></td>');
		      Response.Write('<td> <input type=text name=' + hwItem + '_serial value="' + restree.getResourceValue(hwItem + ".serial") + '"></td></tr>');
		    }
		    hwItem = restree.getNext();
	    }
	    restree.path = "";
    }

    function outputHWVersions()
    {
	    var hwItem = "";
	    var strItemName;
	    var strItemValue;
	    var strItemTag;
	    
    	
	    restree.path = "version.hw";
	    hwItem = restree.getFirst();
    	
	    while (hwItem != "")
	    {
	      if ( hwItem != "battery" )
		    {
		      strItemTag = 'article';
		      strItemName = hwItem + '_' + strItemTag;
		      strItemValue = Request.Form(strItemName);
		    
		      if ( strItemValue != "" )
		         restree.setResourceValue( hwItem + '.' + strItemTag, strItemValue);
		         
		      strItemTag = 'revision';
		      strItemName = hwItem + '_' + strItemTag;
		      strItemValue = Request.Form(strItemName);
		    
		      if ( strItemValue != "" )
		         restree.setResourceValue( hwItem + '.' + strItemTag, strItemValue);

		      strItemTag = 'serial';
		      strItemName = hwItem + '_' + strItemTag;
		      strItemValue = Request.Form(strItemName);
		    
		      if ( strItemValue != "" )
		         restree.setResourceValue( hwItem + '.' + strItemTag, strItemValue);
		    }
		    hwItem = restree.getNext();
	    }
	    restree.path = "";
    }

    if ( Request.Form.Count > 0 ) 
    {
        EEPromLockActions();
        
        if ( EEPromIsUnlocked() )
        {
            if (Request.Form( "submitEdcomp" ) != "")
            {
              outputHWVersions();
            }
        }
    }
  var strTitle = "Edit Components";
%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
        <script>
        /* client side script */
        function UnlockFirst()
        {
            alert("Please unlock the EEProm first.");
            return false;
        }
        </script>
    </head>
    <body id="pgEEPROMEdcomp">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuEEPROM", "mnuEEPROMEdcomp" );%>

        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <form action="#" method=post name=edcomp id=edcomp <%if( !EEPromIsUnlocked() ) Response.Write( ' onsubmit="return UnlockFirst();"' );%>>
				        <table ID="Table2">
					        <caption>Hardware</caption>
					        <tr class="caption">
						        <td>Name</td>
						        <td>Part #</td>
						        <td>Revision #</td>
						        <td>Serial #</td>
					        </tr>
					        <%inputHWVersions();%>
				        </table>
				        <br>
				        <input type=submit id=button1 name=submitEdcomp value="Apply">
                </form>
                <table><tr><td>
                <form action="#" method=post id="Form2" name=unlock>
                    <%PrintEEPromControls();%>
                </form>				
                </td></tr></table>
                <br><br>
            </div>
			      <%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
