<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/eepromlock.inc" -->
<%
    /* Server side script */

    var focLen;
    var fNumber;
    var clearDist;
    var minMeasRad;
    var C1;
    var C2;
    var theta;
    var tsensOffs;
    var refTemp;
    var refTTransm;
    var geThick;
    var mod2C1;
    var mod2C2;
    var adaptTransm;
    var calDist;
    var restreeLens = new ResTree();
    var bApplyAllowed = true;

    

    if ( restreeLens.valueType("image.flow.lensExt.lensConnected") == "bool" ) // E camera with external lens
    {
       if ( restreeLens.getResourceValue("image.flow.lensExt.lensConnected") == true )
           restreeLens.path = "image.flow.lensExt";
       else
       {
           restreeLens.path = "image.flow.lensInt";
           bApplyAllowed = false;
       }
    }
    else
        restreeLens.path = "image.flow.lens";

    if ( Request.Form.Count > 0 ) 
    {
        EEPromLockActions();
        
        if ( EEPromIsUnlocked() )
        {
            if (Request.Form( "edlens" ) != "")
            {
                //
                // Update lens resource branch.
                //
                restreeLens.setResourceValue( "version", Request.Form( "lensversion" ) );
                restreeLens.setResourceValue( "SN", Request.Form( "lensserial" ) );
                restreeLens.setResourceValue( "PN", Request.Form( "lenspart" ) );
                restreeLens.setResourceValue( "focLen", Request.Form( "lensfoclen" ) );
                restreeLens.setResourceValue( "fNumber", Request.Form( "lensfnumber" ) );
                restreeLens.setResourceValue( "clearanceDistance", Request.Form( "lenscleardist" ) );
                restreeLens.setResourceValue( "rotMirr", Request.Form( "lensrotmirr" ) );
                restreeLens.setResourceValue( "opticalMinMeasRadius", Request.Form( "lensminmeasrad" ) );
                if( Request.Form( "lensmeasCB" ) == "on" )
                  restreeLens.setResourceValue( "isMeasured", true );
                else
                  restreeLens.setResourceValue( "isMeasured", false );

                restreeLens.setResourceValue( "C1", Request.Form( "lensC1" ) );
                restreeLens.setResourceValue( "C2", Request.Form( "lensC2" ) );
                restreeLens.setResourceValue( "theta", Request.Form( "lenstheta" ) );
                restreeLens.setResourceValue( "TsensOffset", Request.Form( "lenstsensoffs" ) );
                restreeLens.setResourceValue( "refT", Request.Form( "lensreft" ) );
                restreeLens.setResourceValue( "refTTransmission", Request.Form( "lensrefttrans" ) );
                restreeLens.setResourceValue( "mod2.geThickness", Request.Form( "lensgethick" ) );
                restreeLens.setResourceValue( "mod2.C1", Request.Form( "lensm2C1" ) );
                restreeLens.setResourceValue( "mod2.C2", Request.Form( "lensm2C2" ) );
                if( Request.Form( "lensm2validCB" ) == "on" )
                  restreeLens.setResourceValue( "mod2.isValid", true );
                else
                  restreeLens.setResourceValue( "mod2.isValid", false );

                restreeLens.setResourceValue( "calib.adapter", Request.Form( "lensadapter" ) );
                restreeLens.setResourceValue( "calib.distance", Request.Form( "lenscaldist" ) );
                restreeLens.setResourceValue( "calib.adapterTransm", Request.Form( "lensadtrans" ) );
                //
                // Update the lens eeprom.
                //
                restreeLens.setResourceValueWait( "updateLens", 1 );
            }
        }
    }
    focLen = new Number( restreeLens.getResourceValue( "focLen" ) );
    fNumber = new Number( restreeLens.getResourceValue( "fNumber" ) );
    clearDist = new Number( restreeLens.getResourceValue( "clearanceDistance" ) );
    minMeasRad = new Number( restreeLens.getResourceValue( "opticalMinMeasRadius" ) );
    C1 = new Number( restreeLens.getResourceValue( "C1" ) );
    C2 = new Number( restreeLens.getResourceValue( "C2" ) );
    theta = new Number( restreeLens.getResourceValue( "theta" ) );
    tsensOffs = new Number( restreeLens.getResourceValue( "TsensOffset" ) );
    refTemp = new Number( restreeLens.getResourceValue( "refT" ) );
    refTTransm = new Number( restreeLens.getResourceValue( "refTTransmission" ) );
    geThick = new Number( restreeLens.getResourceValue( "mod2.geThickness" ) );
    mod2C1 = new Number( restreeLens.getResourceValue( "mod2.C1" ) );
    mod2C2 = new Number( restreeLens.getResourceValue( "mod2.C2" ) );
    adaptTransm = new Number( restreeLens.getResourceValue( "calib.adapterTransm" ) );
    calDist = new Number( restreeLens.getResourceValue( "calib.distance" ) );

    var strTitle = "Edit Lens";
%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
        <script>
        /* client side script */
        function checkData()
        {
          var vp = document.getElementById( "edlensf" )

          if( vp.lensserial.value == "" ) {
            alert("Serial number field is empty.");
            return false;
          }
          else if( vp.lenspart.value == "" ) {
            alert("Part number field is empty.");
            return false;
          }
          return true;
        }
        function UnlockFirst()
        {
          alert("Please unlock the EEProm first.");
          return false;
        }
        </script>
    </head>
    <body id="pgEEPROMEdLens">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuEEPROM", "mnuEEPROMEdLens" );%>

        <!-- This is the actual contents -->
        <div id="mainpane">
          <div id="content">
            <TABLE BORDER="1" RULES="all" FRAME="box" >
             <TR><TD>
             <FORM ACTION="#" METHOD=post NAME="edlensf" ID="edlensf"<%if( EEPromIsUnlocked() ) Response.Write( ' onsubmit="return checkData();"' ); else Response.Write( ' onsubmit="return UnlockFirst();"' );%>>
              <TABLE >
                <CAPTION>Id</CAPTION>
                <TR>
                  <TD WIDTH="25%"><B>Lens name</B></TD>
                  <TD WIDTH="25%"><%Response.Write(restreeLens.getResourceValue("name"))%></TD>
                  <TD WIDTH="25%"><B>Lens serial number</B></TD>
                  <TD WIDTH="25%">
                    <INPUT TYPE="text" ID=lensserial NAME=lensserial VALUE="<%Response.Write(restreeLens.getResourceValue("SN"))%>">&nbsp;
                  </TD>
                </TR>
                <TR>
                  <TD><B>Lens version</B></TD>
                  <TD>
                    <INPUT TYPE="text" ID=lensversion NAME=lensversion VALUE="<%Response.Write(restreeLens.getResourceValue("version"))%>">&nbsp;
                  </TD>
                  <TD><B>Lens part number</B></TD>
                  <TD>
                    <INPUT TYPE="text" ID=lenspart NAME=lenspart VALUE="<%Response.Write(restreeLens.getResourceValue("PN"))%>">&nbsp;
                  </TD>
                </TR>
              </TABLE>
        </TR></TD>
        <TR><TD>
              <TABLE >
                <CAPTION>Data</CAPTION>
                <TR>
                  <TD WIDTH="25%"><B>Focal length</B></TD>
                  <TD WIDTH="25%">
                    <INPUT TYPE="text" ID=lensfoclen NAME=lensfoclen VALUE="<%Response.Write( focLen.toFixed( 0 ) )%>">&nbsp;
                  </TD>
                  <TD WIDTH="25%"><B>C1</B></TD>
                  <TD WIDTH="25%">
                    <INPUT TYPE="text" ID=lensC1 NAME=lensC1 VALUE="<%Response.Write( C1.toFixed( 9 ) )%>">&nbsp;
                  </TD>
                </TR>
                <TR>
                  <TD><B>F-number</B></TD>
                  <TD>
                    <INPUT TYPE="text" ID=lensfnumber NAME=lensfnumber VALUE="<%Response.Write( fNumber.toFixed( 1 ) )%>">&nbsp;
                  </TD>
                  <TD><B>C2</B></TD>
                  <TD>
                    <INPUT TYPE="text" ID=lensC2 NAME=lensC2 VALUE="<%Response.Write( C2.toFixed( 9 ) )%>">
                  </TD>
                </TR>
                <TR>
                  <TD><B>Clear dist</B></TD>
                  <TD>
                    <INPUT TYPE="text" ID=lenscleardist NAME=lenscleardist VALUE="<%Response.Write( clearDist.toFixed( 3 ) )%>">&nbsp;
                  </TD>
                  <TD><B>Theta</B></TD>
                  <TD>
                    <INPUT TYPE="text" ID=lenstheta NAME=lenstheta VALUE="<%Response.Write( theta.toFixed( 9 ) )%>">&nbsp;
                  </TD>
                </TR>
                <TR>
                  <TD><B>Rot/Mirr</B></TD>
                  <TD>
                    <INPUT TYPE="text" ID=lensrotmirr NAME=lensrotmirr VALUE="<%Response.Write(restreeLens.getResourceValue("rotMirr"))%>">&nbsp;
                  </TD>
                  <TD><B>TsensOffs</B></TD>
                  <TD>
                    <INPUT TYPE="text" ID=lenstsensoffs NAME=lenstsensoffs VALUE="<%Response.Write( tsensOffs.toFixed( 3 ) )%>">&nbsp;
                  </TD>
                </TR>
                <TR>
                  <TD><B>Min Meas Rad</B></TD>
                  <TD>
                    <INPUT TYPE="text" ID=lensminmeasrad NAME=lensminmeasrad VALUE="<%Response.Write( minMeasRad.toFixed( 9 ) )%>">&nbsp;
                  </TD>
                  <TD><B>RefTemp</B></TD>
                  <TD>
                    <INPUT TYPE="text" ID=lensreft NAME=lensreft VALUE="<%Response.Write( refTemp.toFixed( 3 ) )%>">&nbsp;
                  </TD>
                </TR>
                <TR>
                  <TD><B>Measured</B></TD>
                  <TD>
                    <INPUT TYPE="checkbox" ID=lensmeasCB NAME=lensmeasCB <%if( restreeLens.getResourceValue("isMeasured") ) Response.Write( " checked" );%>>&nbsp;
                  </TD>
                  <TD><B>RefT transm</B></TD>
                  <TD>
                    <INPUT TYPE="text" ID=lensrefttrans NAME=lensrefttrans VALUE="<%Response.Write( refTTransm.toFixed( 9 ) )%>">&nbsp;
                  </TD>
                </TR>
              </TABLE>
        </TR></TD>
        <TR><TD>
              <TABLE >
                <CAPTION>Mod2</CAPTION>
                <TR>
                  <TD WIDTH="25%"><B>Ge thickness</B></TD>
                  <TD WIDTH="25%">
                    <INPUT TYPE="text" ID=lensgethick NAME=lensgethick VALUE="<%Response.Write( geThick.toFixed( 9 ) )%>">&nbsp;
                  </TD>
                  <TD WIDTH="25%"><B>C1</B></TD>
                  <TD WIDTH="25%">
                    <INPUT TYPE="text" ID=lensm2C1 NAME=lensm2C1 VALUE="<%Response.Write( mod2C1.toFixed( 9 ) )%>">&nbsp;
                  </TD>
                </TR>
                <TR>
                  <TD><B>Valid</B></TD>
                  <TD>
                    <INPUT TYPE="checkbox" ID=lensm2validCB NAME=lensm2validCB <%if( restreeLens.getResourceValue("mod2.isValid") ) Response.Write( " checked" );%>>&nbsp;
                  </TD>
                  <TD><B>C2</B></TD>
                  <TD>
                    <INPUT TYPE="text" ID=lensm2C2 NAME=lensm2C2 VALUE="<%Response.Write( mod2C2.toFixed( 9 ) )%>">&nbsp;
                  </TD>
                </TR>
              </TABLE>
        </TR></TD>
        <TR><TD>
              <TABLE >
                <CAPTION>Calib</CAPTION>
                <TR>
                  <TD WIDTH="25%"><B>Adapter</B></TD>
                  <TD WIDTH="25%">
                    <INPUT TYPE="text" ID=lensadapter NAME=lensadapter VALUE="<%Response.Write(restreeLens.getResourceValue("calib.adapter"))%>">&nbsp;
                  </TD>
                  <TD WIDTH="25%"><B>Distance</B></TD>
                  <TD WIDTH="25%">
                    <INPUT TYPE="text" ID=lenscaldist NAME=lenscaldist VALUE="<%Response.Write( calDist.toFixed( 2 ) )%>">&nbsp;
                  </TD>
                </TR>
                <TR>
                  <TD><B>Adapter transm</B></TD>
                  <TD>
                    <INPUT TYPE="text" ID=lensadtrans NAME=lensadtrans VALUE="<%Response.Write( adaptTransm.toFixed( 3 ) )%>">&nbsp;
                  </TD>
                  <TD>&nbsp;</TD>
                  <TD>&nbsp;</TD>
                </TR>
              </TABLE>
              </TD>
              </TR>
            </TABLE>
            <BR>
            <INPUT TYPE=submit ID=button1 NAME=edlens VALUE="Apply" <%if (!bApplyAllowed) Response.Write(" disabled "); %>>
           </FORM>
         <table><tr><td>
         <form action="#" method=post id="Form2" name=unlock>
           <%PrintEEPromControls();%>
         </form>				
         </td></tr></table>
        <br><br>
       </div>
       <%printStandardFooter();%>
      </div>
     <!-- End of actual contents -->
    </body>
</html>
