<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<%
  /* Server side script */
  
	var	noiseGenB;
	var	spatial_bilateralB;
	var	spatial_columnB;
	var	spatial_offsetPixelB;
	var	sprB;
	var	temporalB;
	var	temporalRowB;
	var	spatialRowB;

	var started = false;

  /*********************************************************
  * Start of main code body.
  *********************************************************/

  /* Start the production application, unless already done */
  var started = false;
      
  var ValueType = restree.valueType( "prod.map.status" );
  if( ValueType != "N/A") /* This works on all types of values */
  { 
    started = true;
  }
        
  if( started == false ) 
  {
    restree.setResourceValue( "appl.supv.exec",  "prodapp" );
    for( i = 0; i < 1000; i++ ) 
    {
      var ValueType = restree.valueType( "prod.map.status" );
      if( ValueType != "N/A") 
      {
        started = true;
        break;
      }
      restree.sleep( 200 );
    }
  }

/*   from prod_gain_common_map.cpp/hpp
         { 0x00000001, false, "noiseGen" },
         { 0x00000002, false, "spatial.bilateral" },
         { 0x00000004, false, "spatial.column" },
         { 0x00000008, false, "spatial.offsetPixel" },
         { 0x00000010, false, "spr" },
         { 0x00000020, false, "temporal" },
         { 0x00000040, false, "temporalRow" },
         { 0x00000080, false, "spatial.row" },
*/

  if( started )
  {
	
    if ( Request.Form.Count > 0 ) 
    {
		noiseGen = false;
		spatial_bilateral = false;
		spatial_column = false;
		spatial_offsetPixel = false;
		spr = false;
		temporal = false;
		temporalRow = false;

		DigFilterMask = restree.getResourceValue( "prod.map.digtalFilterOn" );
		
		var DigFilterMask = 0;
		
		if ( Request.Form ( "noiseGen" ) ==  "on" )
		{
			DigFilterMask |= 0x00000001
			noiseGenB = "checked";
		}
		if ( Request.Form ( "spatial_bilateral" ) ==  "on" )
		{
			DigFilterMask |= 0x00000002
			spatial_bilateralB = "checked";
		}
		if ( Request.Form ( "spatial_column" ) ==  "on" )
		{
			DigFilterMask |= 0x00000004
			spatial_columnB = "checked";
		}
		if ( Request.Form ( "spatial_offsetPixel" ) ==  "on" )
		{
			DigFilterMask |= 0x00000008
			spatial_offsetPixelB = "checked";
		}
		if ( Request.Form ( "spr" ) ==  "on" )
		{
			DigFilterMask |= 0x000000010
			sprB = "checked";
		}
		if ( Request.Form ( "temporal" ) ==  "on" )
		{
			DigFilterMask |= 0x00000020
			temporalB = "checked";
		}
		if ( Request.Form ( "temporalRow" ) ==  "on" )
		{
			DigFilterMask |= 0x000000040
			temporalRowB = "checked";
		}
		if ( Request.Form ( "spatialRow" ) ==  "on" )
		{
			DigFilterMask |= 0x000000080
			spatialRowB = "checked";
		}
		
		if ( Request.Form ( "SetDigFilter" ) != "" )
		{
			restree.setResourceValue( "prod.map.digtalFilterOn", DigFilterMask );
		}
	}
	
	DigFilterMask = restree.getResourceValue( "prod.map.digtalFilterOn" );

	if( DigFilterMask & 0x00000001 )
		noiseGenB = "checked";
	if(	DigFilterMask & 0x00000002 )
		spatial_bilateralB = "checked";
	if(	DigFilterMask & 0x00000004 )
		spatial_columnB = "checked";
	if(	DigFilterMask & 0x00000008 )
		spatial_offsetPixelB = "checked";
	if(	DigFilterMask & 0x000000010 )
		sprB = "checked";
	if(	DigFilterMask & 0x00000020 )
		temporalB = "checked";
	if(	DigFilterMask & 0x000000040 )
		temporalRowB = "checked";
	if(	DigFilterMask & 0x000000080 )
		spatialRowB = "checked";
  }

  var strTitle = "Activate digital filters during spatial pix kill";
%>
<HTML>
    <HEAD>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    </HEAD>
    <body id="pgDiagBITInteractive">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuDiag", "mnuDiagBITInteractive" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE ID="Table1">
                    <FORM ACTION="#" METHOD="post" NAME="InteractiveTest" ID="Form2">
						<TR>
							<TD VALIGN="top" colspan="2">
								<%if ( started == false )
									Response.Write("<span id=errstatus> Production Application not available! </span>")
								%>
								<BR>
							</TD>
						</TR>
						<TR>
							<TD VALIGN="top">
								<u>Digital filters</u><BR>
                                <INPUT id="Checkbox1" type="checkbox" name="noiseGen" <%Response.write( noiseGenB )%>>&nbsp;&nbsp;noiseGen&nbsp;&nbsp;<BR>
                                <INPUT id="Checkbox2" type="checkbox" name="spatial_bilateral" <%Response.write( spatial_bilateralB )%>>&nbsp;&nbsp;spatial.bilateral&nbsp;&nbsp;<BR>
                                <INPUT id="Checkbox3" type="checkbox" name="spatial_column" <%Response.write( spatial_columnB )%>>&nbsp;&nbsp;spatial.column&nbsp;&nbsp;<BR>
                                <INPUT id="Checkbox4" type="checkbox" name="spatial_offsetPixel" <%Response.write( spatial_offsetPixelB )%>>&nbsp;&nbsp;spatial.offsetPixel&nbsp;&nbsp;<BR>
                                <INPUT id="Checkbox5" type="checkbox" name="spr" <%Response.write( sprB )%>>&nbsp;&nbsp;spr&nbsp;&nbsp;<BR>
                                <INPUT id="Checkbox6" type="checkbox" name="temporal" <%Response.write( temporalB )%>>&nbsp;&nbsp;temporal&nbsp;&nbsp;<BR>
                                <INPUT id="Checkbox7" type="checkbox" name="temporalRow" <%Response.write( temporalRowB )%>>&nbsp;&nbsp;temporalRow&nbsp;&nbsp;<BR>
                                <INPUT id="Checkbox8" type="checkbox" name="spatilaRow" <%Response.write( spatialRowB )%>>&nbsp;&nbsp;spatialRow&nbsp;&nbsp;<BR>
							</TD>
						</TR>
						<tr>
							<td colspan="2">
								<INPUT TYPE="submit" VALUE="Activate digital filter" ID="Button1" NAME="SetDigFilter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
							</td>
                        </tr>
                    </FORM>

                    <p>	When spatial image kill function is used all digital filter are off as default.<BR> Under certain circumstances this is not optimal.<BR>
						To activate a digital filters when using spatial image kill function, check it and press the <b>Activate digital filter</b> button.<BR>
						Note: the specified filter settings are active for spatial image kill function ONLY.<BR>
						All other functions will run using default settings.
					<p>

					<FORM ACTION=PixKill.asp METHOD="POST">
					  <INPUT TYPE="hidden" NAME="mode" VALUE="PixKill">
					  <INPUT TYPE="submit" NAME="PixKill" VALUE="Return to pixkill page">
					</FORM>

                </TABLE>
            </div>
            <%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</HTML>
