<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<%  var strTitle = "Gain Mapping"; %>
<HTML>
    <HEAD>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    </HEAD>
    <body id="pgImgCorrGainMap">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuImgCorr", "mnuImgCorrGainMap" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE ID="Table1">
                    <TR>
                        <TD VALIGN="top">
                            <h2>Instruction</h2>
                            <p>These pages are used to create gain maps. 
                            Gain maps even out variations in sensitivity througout the detector, 
                            and variations in the transmission of the optical elements of the camera.</p>
                            <p>The camera can have many gain maps, so different calibration cases can use different maps.</p>
                            <p>On the <b>Select Case</b> page you shall select a case on which the new map shall be based.</p>
                            <p>You will then take images of two mapping blackbodies, preferably one in the upper and one in the lower part of the temperature range, using the <b>Warm Image</b> and <b>Cold Image</b> pages.</p>
                            <p>Popular mapping temperatures are 30&deg;C, 100&deg;C and 300&deg;C.</p>
                            <p>When both images are taken, you will on the <B>Calc Map</B> page be asked how the new map shall be applied.</p>
                            <p>The map can become more or less specific, ranging from a default map meant for all cases to a map only used for the selected case.</p>
                            <p>The dead pixel replacement codes in the gain map are normally lost during the gain map calculations, so the camera Operability can change for the worse. You had better use the Pixel Replacement web page to clean the image afterwards.</p>
							<%
								var  xRes = restree.getResourceValue( "image.framegrab.ir.geom.width" );
								if((( CamType == "X2" ) && ( xRes < 180 )) || (( CamType == "E" || CamType == "E2" ) && ( xRes < 320 )))
								     Response.Write( "<h3> NOTE: Camera not in service mode! </h3>");
							%>
                        </TD>
                    </TR>
                </TABLE>
            </div>
            <%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</HTML>
