<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<%
    /* Server side script */
    
    /* Start the production application, unless already done */
    var started = false;
      
    var ValueType = restree.valueType( "prod.map.status" );
    if( ValueType != "N/A") /* This works on all types of values */
    { 
        started = true;
    }
        
    if( started == false ) 
    {
        restree.setResourceValue( "appl.supv.exec",  "prodapp" );
        for( i = 0; i < 1000; i++ ) 
        {
            var ValueType = restree.valueType( "prod.map.status" );
            if( ValueType != "N/A") 
            {
                started = true;
                break;
            }
        }
    }
    
    var Status = "not started";
    var ECode = -1;
    var currentAction = "";

    if( started )
    {
        if ( Request.Form.Count > 0 )
        {
            if ( Request.Form("opercheck") != "" )
            {
                restree.setResourceValue( "prod.map.command", "init");
                var i = 100;
                while (restree.getResourceValue( "prod.map.status" ) == "busy" && i-- > 0 )
		           restree.sleep( 100 );
                    
                /* kolla om init var OK */
                restree.setResourceValue( "prod.map.command", "checkMap");
                currentAction = "operability";
            }
        }
        else 
        {
           currentAction = Request.QueryString("currentAction");
           Status = restree.getResourceValue( "prod.map.status" );
           
           if ( currentAction == "operability" )
           {
                if (Status == "ready")
                    Response.Redirect("OperabilityLog.asp");

                if (Status != "busy")
                   currentAction = "";
           }
        }
        Status = restree.getResourceValue( "prod.map.status" );
        ECode = restree.getResourceValue( "prod.map.ecode" );
    }
  var strTitle = "Operability check";
  var strCurrentCase = restree.getResourceValue(".image.ccase.ccase");
  var strCurrentCaseDescr = restree.getResourceValue( strCurrentCase + ".descr");
   
%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    </head>
    <%
    if( Status == "busy" ) {
        Response.Write( '<meta http-equiv="Refresh" content="2');
        if ( currentAction != "" )
            Response.Write( ";url=operability.asp?currentAction=" + currentAction);
        Response.Write('">\n' );
        Response.Write( '<meta http-equiv="pragma" content="no-cache">\n' );
    }
    %>
    <body id="pgImgCorrOperability">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuImgCorr", "mnuImgCorrOperability" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE>
                    <TR>
                        <TD VALIGN="top">
                            <%if ( Status == "busy" )
                                Response.Write("<span id=errstatus> Camera working, please wait! </span>")
                              else if ( ECode > 0 )
                                Response.Write("<span id=errstatus>" + ecodeString( ECode ) + "</span>")
                              else if ( ECode < 0 )
                                Response.Write("<span id=errstatus> Production Application not available!</span>")
                              else if ( Request.Form.Count > 0)
                                Response.Write("<span id=OKstatus> Command OK </span>")
                              else
                                Response.Write("&nbsp;")
                            %>
                        </TD>
                    </TR>
                    <TR>
                        <TD VALIGN="top">
                            <FORM ACTION="#" METHOD="post" NAME="opercheck" ID="opercheck">
                                <p>Current case: <%Response.Write(strCurrentCaseDescr);if ( CamType != "X" && CamType != "Z" && CamType != "Z3" ) Response.Write("&nbsp;(<a href='ImgCorrSelCase.asp'>Change</a>)");%></p>
                                This operability check tests if the number of non-operating pixels in the image
                                is too high or if the bad pixels form unacceptable clusters in the image.<br><br>
                                <BR>
                                <INPUT TYPE="submit" VALUE="Check" ID="opercheck" NAME="opercheck" <%if( Status == "busy" ) Response.Write( "disabled" ); %>>
                            </FORM>
                        </TD>
                    </TR>
                </TABLE>
            </div>
			<%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
