<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<%
    /* Server side scripts */

/*********************************************************
* Pick up killing methods from the prodspec tree
*********************************************************/

function addResTreeOptions( resPath, resDispName, dispNameFilter, selItem)
{
	restree.path = resPath;
	var item = restree.getFirst();
	var selStr;
	var dispName;
	var dispNameFilterLen = dispNameFilter.length;

	while (item != "")
	{
		if ( item == selItem )
			selStr = " SELECTED"; 
		else 
			selStr = ""; 

		dispName = restree.getResourceValue(item + "." + resDispName);

		if ( selStr != "" || dispNameFilterLen == 0 )
		{
			Response.Write("<option value =\"" + item + "\"" + selStr + ">");
			Response.Write(dispName);
			Response.Write("</option>\n"); 
		}
		else if (dispName.substr(0,dispNameFilterLen) == dispNameFilter)
		{
			Response.Write("<option value =\"" + item + "\"" + selStr + ">");
			Response.Write(dispName);
			Response.Write("</option>\n"); 
		}
		item = restree.getNext();
	}
	restree.path = "";
}
/*********************************************************
* Create a new jpeg ir image on the ram disk.
*********************************************************/
function getNewImage()
{
	var oLensCorr = false;
	if( oLensCorrInUse ) {
		oLensCorr = restree.getResourceValue( "image.flow.maps.lensCorr.active" );
		restree.setResourceValue( "image.flow.maps.lensCorr.active", false );
		restree.sleep( 500 );
	}

	if( CamType == "E2" || CamType == "E3" )
	{
		restree.setResourceValue( "ui.userSettings.overlayLogo", false );
		restree.setResourceValue( "ui.userSettings.hideGraphics", true);
	}
	if( CamType == "A" ) 
		// Of some strange reason usePogo must be true in A ( well...maybe not any more )
		restree.setResourceValue( "image.services.store.usePogo", true );
	else
		restree.setResourceValue( "image.services.store.usePogo", false );

	restree.sleep( 2000 );
	var fullPath = "/Temp/webimage.jpg";
	restree.setResourceValue( "image.services.store.bgActive", false );
	restree.setResourceValue( "image.services.store.format", "JPEG_no_IR" );
	restree.setResourceValue( "image.services.store.format", "JPEG" );
	restree.setResourceValue( "image.services.store.overlay", false );
	restree.setResourceValue( "image.services.store.overwrite", true );
	restree.setResourceValue( "image.services.store.quality", 95 );
	restree.setResourceValue( "image.services.store.filename", fullPath );
	restree.setResourceValueWait( "image.services.store.commit", true );
	var cnt = 100;
	while (restree.getResourceValue( "image.services.store.busy" ) != false && cnt-- > 0 )
		restree.sleep( 200 );
	if( CamType == "E2" || CamType == "E3" )
	{
		restree.setResourceValue( "ui.userSettings.overlayLogo", true );
		restree.setResourceValue( "ui.userSettings.hideGraphics", false);
	}
	if( oLensCorrInUse ) {
		restree.setResourceValue( "image.flow.maps.lensCorr.active", oLensCorr );
	}
}

/*********************************************************
* Start of main code body.
*********************************************************/

/* Start the production application, unless already done */
var started = false;

var ValueType = restree.valueType( "prod.map.status" );
if( ValueType != "N/A") /* This works on all types of values */
{ 
	started = true;
}

if( started == false ) 
{
	restree.setResourceValue( "appl.supv.exec",  "prodapp" );
	for( i = 0; i < 1000; i++ ) 
	{
		var ValueType = restree.valueType( "prod.map.status" );
		if( ValueType != "N/A") 
		{
			started = true;
			break;
		}
		restree.sleep( 200 );
	}
}    
var RandomVal = Math.random();
RandomString = new String( RandomVal.toString( 16 ) );
var Status = "not started";
var ECode = -1;
var currentAction = "";
var forceCommandOK = false;
var MapName = "?";
var detectorWidth = restree.getResourceValue( "image.framegrab.ir.geom.width" );    
var detectorHeight = restree.getResourceValue( "image.framegrab.ir.geom.height" );    
var iWidth;
var iHeigth;
var wWidth;
var wHeigth;
var iPixWidth;
var iNzPixWidth;
var iSmallDiv;
var wasZoomed = true;
var replaceOn = true;
var imageTop = 0;
var imageLeft = 0;
var hcXpos = 0;
var hcYpos = 0;
var bUnZoomable = false;
var iIEoffset = 0;
var iNoZoomComp = 0;
var methodItem = "";
var NKill = "";	
var iNKill = 0;
var strFilteron = "";
var iXSizeIR = 0;
var iYSizeIR = 0;
var  oLensCorrInUse = false;	// If lenscorr exists

/*
* Set geometries according to detector width.
* Z-cam has a detector with 80x80, 120x120 or 144x144 pixels.
* Z-cam i5 has a detector with 320z240 pixels.
* X-cam has a detector with 120x120 pixels.
* X2-cam has a detector with 180x180 pixels.
* E-cam has a detector with 320x240 pixels.
* A-cam has a detector with 320x240 pixels.
* P-cam has a detector with 640x480 pixels.
*/

var  xRes = restree.getResourceValue("image.framegrab.ir.geom.width");

if( CamType == "Z" || CamType == "Z3" ) {
	/*
	* Turn graphics off using the Gui on an Z-camera.
	*/
	if( !restree.getResourceValue( "gui.system.hideGraphics" ) )
		restree.setResourceValue( "gui.system.hideGraphics", true );

	iWidth = 480;       // Set image bitmap width and height.
	iHeight = 480;
	wWidth = 480;       // Set window width and height. 
	wHeight = 480;      // Height should be to 480 to preserve the layout.
	iPixWidth = 6;      // Number of graphic pixels per ir image pixel when zoomed.
	iNzPixWidth = 6;    // Number of graphic pixels per ir image pixel when not zoomed.
	iSmallDiv = 10;     // Small aiming window size compared to ir window size.
	iIEoffset = 2;      // Compensation to use with Internet Explorer.
	iZoomComp = 2;      // Compensation in unZoomable mode;
	wasZoomed = false;  // Default zoom mode.
	bUnZoomable = true; // Is zoom available at all ?

	iXSizeIR = restree.getResourceValue( "image.flow.detector.geom.width" );
	iYSizeIR = restree.getResourceValue( "image.flow.detector.geom.height" );

	if( iXSizeIR == 320 && iYSizeIR == 240 ) {		// If i5 ?? ( same dim as E ?? )
		iWidth = 1280;
		iHeight = 960;
		wWidth = 640; 
		wHeight = 480;
		iPixWidth = 4;     // = 1280x960
		iNzPixWidth = 2;   // = 640x480   
		iSmallDiv = 10;
		iIEoffset = 0;      // Compensation to use with Internet Explorer.
		iZoomComp = 1;     // Compensation in unZoomable mode;
		bUnZoomable = false;
		oLensCorrInUse = true;

	}
	else if( iXSizeIR != 80 ) {		// If not old Z
		iWidth = 480;       // Set image bitmap width and height.
		iHeight = 480;
		wWidth = 480;       // Set window width and height. 
		wHeight = 480;      // Height should be to 480 to preserve the layout.
		iPixWidth = 480 / iXSizeIR;		 // Number of graphic pixels per ir image pixel when zoomed.
		iNzPixWidth = 480 / iXSizeIR;    // Number of graphic pixels per ir image pixel when not zoomed.
		iSmallDiv = 10;     // Small aiming window size compared to ir window size.
		iIEoffset = 2;      // Compensation to use with Internet Explorer.
		iZoomComp = 0;      // Compensation in unZoomable mode;
		wasZoomed = false;  // Default zoom mode.
		bUnZoomable = true; // Is zoom available at all ?
	}	

}
else if( CamType== "X" ) {
	/*
	* X camera.
	*/
	iWidth = 480;       // Set image bitmap width and height.
	iHeight = 480;
	wWidth = 480;       // Set window width and height. 
	wHeight = 480;      // Height should be to 480 to preserve the layout.
	iPixWidth = 4;      // Number of graphic pixels per ir image pixel when zoomed.
	iNzPixWidth = 4;    // Number of graphic pixels per ir image pixel when not zoomed.
	iSmallDiv = 10;     // Small aiming window size compared to ir window size.
	iIEoffset = 2;      // Compensation to use with Internet Explorer.
	iZoomComp = 0;      // Compensation in unZoomable mode;
	wasZoomed = false;  // Default zoom mode.
	bUnZoomable = true; // Is zoom available at all ?
}
else if( CamType == "X2" ) {
	/*
	* X2 camera.
	*/
	if( !restree.getResourceValue( "gui.system.hideGraphics" ) )
		restree.setResourceValue( "gui.system.hideGraphics", true );

	iWidth = 720;       // Set image bitmap width and height.
	iHeight = 720;
	wWidth = 480;       // Set window width and height. 
	wHeight = 480;      // Height should be to 480 to preserve the layout.
	iPixWidth = 4;      // Number of graphic pixels per ir image pixel when zoomed.
	iNzPixWidth = 2.6667; // Number of graphic pixels per ir image pixel when not zoomed.
	iSmallDiv = 10;     // Small aiming window size compared to ir window size.
	iIEoffset = 0;      // Compensation to use with Internet Explorer.
	iZoomComp = 1;      // Compensation in unZoomable mode;
	bUnZoomable = false; // Zoom is available!
}
else if ( CamType == "E" || CamType == "A" || CamType == "E2" || CamType == "E3"  || CamType == "FX" ) {
	/*
	* Turn graphics off using the Gui on an E/A-camera.
	*/
	if( !restree.getResourceValue( "gui.system.hideGraphics" ) )
		restree.setResourceValue( "gui.system.hideGraphics", true );

	/* ere rtt detta ?? */
	iWidth = 1280;
	iHeight = 960;
	wWidth = 640; 
	wHeight = 480;
	iPixWidth = 4;     // = 1280x960
	iNzPixWidth = 2;   // = 640x480   
	iSmallDiv = 10;
	iIEoffset = 0;      // Compensation to use with Internet Explorer.
	iZoomComp = 1;     // Compensation in unZoomable mode;
	bUnZoomable = false;
}
else if ( CamType == "P" || CamType == "Pt" || CamType == "G" || CamType == "A2" )
{
	/*
	* Turn graphics off using the Gui on a P-camera.
	*/
	if( !restree.getResourceValue( "gui.system.hideGraphics" ) )
		restree.setResourceValue( "gui.system.hideGraphics", true );

	if ( CamType == "A2" || CamType == "Pt" )
		/* Set a far focus if A2 */
		restree.setResourceValue( "system.focus.distance", 50.0 );

	iWidth = 2560;
	iHeight = 1920;
	iWidth = 4 * restree.getResourceValue( ".image.flow.framebuffer.geom.width" );
	iHeight = 4 * restree.getResourceValue( ".image.flow.framebuffer.geom.height" );
	wWidth = 640;
	wHeight = 480;
	iPixWidth = 4;
	iNzPixWidth = 1;
	iSmallDiv = 20;
	iSmallDiv = iHeight / 128;
	iIEoffset = 0;      // Compensation to use with Internet Explorer.
	iZoomComp = 1;     // Compensation in unZoomable mode;
	bUnZoomable = false;
}
else
{
	Response.Redirect( "/Service/ImgCorr/" );
}

restree.setResourceValue( ".image.contadj.active", true );
restree.setResourceValue( ".image.contadj.lockMode", "none" );


/*
* Check that we managed to start the production application program.
*/
if( started )
{
	/*
	* Read deadpixmap filename from calibration.
	*/
	var mapPath = restree.getResourceValue( "image.ccase.deadPixMap" );
	mapPath += ".fileName";
	MapName = restree.getResourceValue( mapPath );

	/*
	* Any form data ?
	* No form data indicates a window refresh.
	*/
	if ( Request.Form.Count == 0 )
		getNewImage();

	if ( Request.Form.Count > 0 )
	{
		/*
		* Extract filteron from URL
		*/
		if ( Request.Form("filteron") != "" ) {
			strFilteron = "checked "
		}
		restree.setResourceValue( "prod.map.filterOn", ( Request.Form( "filteron" ) != "" ));     

		/*
		* Check if the ir image was zoomed.
		* Remember this and make sure that the ir image keeps it's zoom factor.
		*/
		if( Request.Form("zoomFlag") == 0 ) {
			wasZoomed = false;
		}
		if( Request.Form("presentTop") != "" ) {
			imageTop = Request.Form("presentTop");
		}
		if( Request.Form("presentLeft") != "" ) {
			imageLeft = Request.Form("presentLeft");
		}
		if( Request.Form("presentHcXpos") != "" ) {
			hcXpos = Request.Form("presentHcXpos");
		}
		if( Request.Form("presentHcYpos") != "" ) {
			hcYpos = Request.Form("presentHcYpos");
		}
		/*
		* Decode the command.
		*/


		if ( Request.Form("replOnCmd") != "" )
		{
			if( Request.Form("replOnCmd") == "ON" )
				restree.setResourceValue( "image.flow.maps.combGainDeadMap.pixReplace", true );
			else
				restree.setResourceValue( "image.flow.maps.combGainDeadMap.pixReplace", false );

			getNewImage();
		}
		else if ( Request.Form("NucNowCmd") == "ON" )
		{
			restree.setResourceValue("image.services.nuc.commit", true);
			var i = 1000;
			while (restree.getResourceValue( "image.services.nuc.status" ) != 0 && i-- > 0 )
				restree.sleep( 200 );

			getNewImage();
		} 
		else if ( Request.Form("killCmd") != "" || Request.Form( "NKill" ) != "" )
		{

			methodItem = Request.Form("method");
			if (methodItem != ""  || Request.Form( "NKill" ) != "" )
			{
				restree.setResourceValue( "prod.map.command", "init");
				var i = 1000;
				while (restree.getResourceValue( "prod.map.status" ) == "busy" && i-- > 0 )
					restree.sleep( 200 );

				/* kolla om init var OK */
				var arg1 = 0, arg2 = 0, arg3 = 0, arg4 = 0;
				var blocking = false;
				var methodName = "";


				if(  Request.Form( "NKill" ) != "" ) {
					NKill = Request.Form( "NKill" );
					iNKill = Number( Request.Form( "NKill" ))
						arg1 = -iNKill;
					methodItem = "killSpatImg";
					methodName = "";
					blocking = true;

					strFilteron = Request.Form( "filteron" );

				}

				else if( methodItem == "killPix" ) {
					arg1 =  Request.Form( "xCoord" );
					arg2 =  Request.Form( "yCoord" );

					strFilteron = Request.Form( "filteron" );

					blocking = true;
				}
				else if( methodItem == "killColumn" ) {
					arg1 =  Request.Form( "xCoord" );
					blocking = true;
				}
				else if( methodItem == "killRow" ) {
					arg2 =  Request.Form( "yCoord" );
					blocking = true;
				}
				else if( methodItem == "autoColumn" ) {
					blocking = true;
				}
				else if( methodItem == "autoRow" ) {
					blocking = true;
				}
				else if( methodItem == "killDyn" ) {
					blocking = true;
				}
				else if( methodItem == "killSpatImg" ) {
					blocking = true;
				}
				else if( methodItem == "killSpatGain" ) {
					blocking = true;
				}
				else if( methodItem == "killTempoImg" ) {
					blocking = true;
				}
				else if( methodItem == "killSlow" ) {
					blocking = true;
				}
				else if( methodItem == "killUnLin" ) {
					blocking = true;
				}
				else if( methodItem == "killTempoLong" ) {
					blocking = true;
				}
				else if( methodItem == "replaceKilled" ) {
					blocking = true;
				}
				else 
				{
					methodName = restree.getResourceValue( "prod.prodSpec.operability.config.pixKill" + "." + methodItem + ".pixKillID");
					blocking = true;
				}

				if ( methodName == "" )
				{
					restree.setResourceValue( "prod.map.arg1", arg1 );
					restree.setResourceValue( "prod.map.arg2", arg2 );
					restree.setResourceValue( "prod.map.arg3", arg3 );
					restree.setResourceValue( "prod.map.arg4", arg4 );
					restree.setResourceValue( "prod.map.command", methodItem );
				}
				else
				{
					restree.setResourceValue( "prod.map.pixKillID", methodName);
					restree.setResourceValue( "prod.map.command", "specPixKill");
				}
				if( blocking ) {
					i = 1000;
					while (restree.getResourceValue( "prod.map.status" ) == "busy" && i-- > 0 )
						restree.sleep( 200 );

					getNewImage();
				}
				currentAction = "killing";
			}

		}
		else if ( Request.Form("opercheck") != "" )
		{
			restree.setResourceValue( "prod.map.command", "init");
			var i = 1000;
			while (restree.getResourceValue( "prod.map.status" ) == "busy" && i-- > 0 )
				restree.sleep( 200 );

			/* kolla om init var OK */
			restree.setResourceValue( "prod.map.command", "checkMap");
			currentAction = "operability";
		}
		else if ( Request.Form("saveCmd") != "" )
		{
			// Setting nameType to active will generate the same map name.
			// Is shown below on the page.
			restree.setResourceValue("prod.map.nameType", "active");
			restree.setResourceValue("prod.map.command", "makeMapInfo");

			var i = 1000;
			while (restree.getResourceValue( "prod.map.status" ) == "busy" && i-- > 0 )
				restree.sleep( 200 );

			if( restree.getResourceValue( "prod.map.status" ) == "ready" ) {
				restree.setResourceValue( "prod.map.command", "saveDeadMap");
				var i = 1000;
				while (restree.getResourceValue( "prod.map.status" ) == "busy" && i-- > 0 )
					restree.sleep( 200 );

				if( CamType != "Z" && CamType != "Z3" )
				{
					// Persist calib.rsc, since it might have been changed by saveDeadMap
					restree.setResourceValue( "dump.file", "/FlashFS/system/calib.rsc"  );
					restree.setResourceValue( "dump.includeDefault", true  );
					restree.setResourceValue( "dump.node", ".calib"  );
					restree.setResourceValue( "dump.relativePaths", false  );
					restree.setResourceValue( "dump.commit", true  );
				}
			}
		}
		else if ( Request.Form("restoreCmd") != "" )
		{
			var fullPath = "/flashfs/system/maps/";
			fullPath += MapName;
			restree.setResourceValue( ".image.flow.maps.combGainDeadMap.fillValue", 32768 );	/* in case of no dead map file */
			restree.setResourceValue( "image.flow.maps.deadPixMap.readFile", fullPath );
			getNewImage();
		}
		else if ( Request.Form("newImage") != "" )
		{
			getNewImage();
		}
		else if ( Request.Form("clearErrCmd") != "" )
		{
			restree.setResourceValue( "prod.map.command", "nop");
			var i = 1000;
			while (restree.getResourceValue( "prod.map.status" ) == "busy" && i-- > 0 )
				restree.sleep( 200 );
		}
	}
	else 
	{
		/*
		* Check page mode when refreshed.
		*/
		currentAction = Request.QueryString("currentAction");
		Status = restree.getResourceValue( "prod.map.status" );

		if ( currentAction == "operability" )
		{
			if (Status == "ready")
				Response.Redirect("OperabilityLog.asp");

			if (Status != "busy")
				currentAction = "";
		}
		else if ( currentAction == "killing" )
		{
			methodItem = restree.getResourceValue( "prod.map.command");

			if (Status != "busy")
			{
				getNewImage();
				currentAction = "";
				forceCommandOK = true;
			}
		}
		else
			restree.setResourceValue("gui.system.hideGraphics", true);
	}
	/*
	* Always read status and error code...
	*/
	Status = restree.getResourceValue( "prod.map.status" );
	ECode = restree.getResourceValue( "prod.map.ecode" );
	replaceOn = restree.getResourceValue( "image.flow.maps.combGainDeadMap.pixReplace" );
}
var strTitle = "Pixel Replacement"; 
%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">

<!--
  ********************************************************
  Client side Javascript code to deal with image panning
  and haircross positioning.
  ********************************************************
-->

<SCRIPT type="text/javascript">

  /*
   * Transfer geometry information from server side Jscript
   * to client side JavaScript.
   */
//  if( isIE() )
//    var zoomComp = <%Response.Write( iZoomComp + iIEoffset );%>;
//  else
  var zoomComp = <%Response.Write( iZoomComp );%>;
  var IEoffset = <%Response.Write( iIEoffset );%>;
  var unZoomable = <%Response.Write( bUnZoomable );%>;
  var pixWidth = <%Response.Write( iPixWidth );%>;
  var nzPixWidth = <%Response.Write( iNzPixWidth );%>;
  var trueWidth = <%Response.Write( detectorWidth );%>;
  var trueHeight = <%Response.Write( detectorHeight );%>;
  var winWidth = <%Response.Write( wWidth );%>;
  var winHeight = <%Response.Write( wHeight );%>;
  var winTopMarg = 10;
  var winLeftMarg = 10;
  var imageWidth = <%Response.Write( iWidth );%>;
  var imageHeight = <%Response.Write( iHeight );%>;
  var xhairSize = 41;
  var halfXhairSize = 20;

  var pixtop = winTopMarg;
  var pixleft = winLeftMarg;
  var right = winWidth + winLeftMarg;
  var left = 0;
  var top = 0;
  var bottom = winHeight + winTopMarg;
  var draggedElem; 
  var mouseButtonDown = false; 
  var startIX = 0;
  var startIY = 0;
  var startMX = 0;
  var startMY = 0;
  var screenXpos = -1;
  var screenYpos = -1;
  var hcX = <%Response.Write( hcXpos );%>;
  var hcY = <%Response.Write( hcYpos );%>;
  var savedLeft = 0;
  var savedTop = 0;
  var origoX = 200;  // "mainpane" offset from left edge of window.
  var origoY = 100;  // "mainpane" offset from top of window.

  /*
   * Return true/false depending on zoom mode.
   */
  function isZoomed()
  {
<% if( bUnZoomable )
     Response.Write( "return false;\n" );
   else
     Response.Write( 'return !document.getElementById("noZoom").checked;\n' );
%>
  }

  /*
   * Return true/false depending on pixel replacement mode.
   */
  function replacing()
  {
    return document.getElementById("replace").checked;
  }

  /*
   * Return true if executing on MS Internet Explorer
   */
  function isIE() {
    return (navigator.appName == "Microsoft Internet Explorer");
  }

  /*
   * Position the ir image in the ir window.
   */
  function setPos( pTop, pBottom, pLeft, pRight )
  {

    // Set ir image position and clipping.
    var vp = "rect( " + pTop + "px " + pRight + "px " + pBottom + "px " + pLeft + "px )";
    document.getElementById("irimg").style.clip = vp;
    vp = pixtop + "px";
    document.getElementById("irimg").style.top = vp;
    vp = pixleft + "px";
    document.getElementById("irimg").style.left = vp;

    // Set haircross position and clipping.
    var xClip = 
          ( ( screenXpos - left ) + xhairSize > winWidth + winLeftMarg ?
                xhairSize - ( ( ( screenXpos - left ) + xhairSize ) - ( winWidth + winLeftMarg ) ) :
                xhairSize );
    var yClip = 
          ( ( screenYpos - top ) + xhairSize > winHeight + winTopMarg ?
                xhairSize - ( ( ( screenYpos - top ) + xhairSize ) - ( winHeight + winTopMarg ) ) :
                xhairSize );
    vp = "rect( " +
         ( screenYpos - top < winTopMarg ? winTopMarg - ( screenYpos - top ) : 0 ) +
         "px " +
         xClip +
         "px " +
         yClip +
         "px " +
         ( screenXpos -left < winLeftMarg ? winLeftMarg - ( screenXpos - left ) : 0 ) +
         "px )";
    document.getElementById("xhair").style.clip = vp;
    vp = ( screenYpos - top ) + "px";
    document.getElementById("xhair").style.top = vp;
    vp = ( screenXpos - left ) + "px";
    document.getElementById("xhair").style.left = vp;

    // Set marker position in small orientation window.
    if( isZoomed() )
      vp = ( 10  + ( pLeft / <%Response.Write( iSmallDiv );%> ) ) + "px";
    else
      vp = "-400px";
<% if( bUnZoomable ) Response.Write( "/*" ); %>
    document.getElementById("smallmarker").style.left = vp;
    vp = ( <%Response.Write( wHeight + 20 );%>  + ( pTop / <%Response.Write( iSmallDiv );%> ) ) + "px";
    document.getElementById("smallmarker").style.top = vp;
<% if( bUnZoomable ) Response.Write( "*/" ); %>
  }

  /*
   * Update the haircross position by IR coordinate.
   */
  function setHairCrossByIR( x, y )
  {
    /*
     * Calculate which ir pixel occupies this screen position.
     */
    var l = left - origoX;
    var t = top - origoY;
    var p = !isZoomed() ? nzPixWidth : pixWidth;
    var zc = zoomComp;

    if( isIE() ) {
      if( isZoomed() || unZoomable )
        zc += IEoffset;
    }
    hcX = x;
    hcY = y;
    if( hcX <= 0 )
      hcX = 0;

    if( hcY <= 0 )
      hcY = 0;

    /*
     * Recalculate the screen position using the ir image coordinates.
     * This makes the haircross "snap" to ir pixel positions.
     */
    var xp = ( ( hcX * p ) + winLeftMarg + ( origoX - left ) + p/2 ) - zc;
    var yp = ( ( hcY * p ) + winTopMarg + ( origoY - top ) + p/2 ) - zc;
    if( isIE() ) {
      xp += IEoffset;
      yp += IEoffset;
    }
    screenXpos = xp - halfXhairSize + l;
    screenYpos = yp - halfXhairSize + t;

    setPos( top, bottom, left, right );
  }

  /*
   * Update the haircross position by screen coordinate.
   */
  function setHairCross( x, y )
  {
    /*
     * Calculate which ir pixel occupies this screen position.
     */
    var l = left - origoX;
    var t = top - origoY;
    var p = !isZoomed() ? nzPixWidth : pixWidth;

    if( isIE() ) {
      x -= IEoffset;
      y -= IEoffset;
    }
    var nX = new Number( ( l + x - winLeftMarg - p/2 ) / p );
    var nY = new Number( ( t + y - winTopMarg - p/2 ) / p );
    
    setHairCrossByIR( nX.toFixed(0), nY.toFixed(0));
  }

  /*
   * Move the ir image in the ir window according to the in arguments.
   */
  function moveWin( mX, mY )
  {
    var diffX = startIX - ( mX - startMX );
    var diffY = startIY - ( mY - startMY );

    left = diffX;
    right = left + winWidth;
    if( right > imageWidth ) {
      right = imageWidth;
      left = imageWidth - winWidth;
    }
    if( left < 0 ) {
      left = 0;
      right = winWidth;
    }
    top = diffY;
    bottom = top + winHeight;
    if( bottom > imageHeight ) {
      bottom = imageHeight;
      top = imageHeight - winHeight;
    }
    if( top < 0 ) {
      top = 0;
      bottom = winHeight;
    }
    pixtop = winTopMarg - top;
    pixleft = winLeftMarg - left;
    setPos( top, bottom, left, right );
  }

  /*
   * Event function "dragging" the ir image in the ir window.
   */
  function dragIt(evt) {winTopMarg
    evt = (evt) ? evt : (window.event) ? window.event : "";
    var targElem = (evt.target) ? evt.target : evt.srcElement;
    if( mouseButtonDown && evt.ctrlKey ) {
      setHairCross( evt.clientX + document.body.scrollLeft, evt.clientY + document.body.scrollTop );
      return false;
    }
    if( draggedElem ) {
      targElem = draggedElem;
      if (targElem.className == "draggable") {
        while (targElem.id != "irimg" && targElem.parentNode) {
          targElem = targElem.parentNode;
        }
        if( evt.clientX >= 0 && evt.clientY >= 0 && isZoomed() )
          moveWin( evt.clientX, evt.clientY );

        return false;
      }
    }
  }

  /*
   * Event function capturing the mouse button down event.
   */
  function engage(evt) {
     evt = (evt) ? evt : (window.event) ? window.event : "";
     var targElem = (evt.target) ? evt.target : evt.srcElement;

     if( evt.ctrlKey ) {
       mouseButtonDown = true;
       setHairCross( evt.clientX + document.body.scrollLeft, evt.clientY + document.body.scrollTop );
       return false;
     }
     if (targElem.className == "draggable") {
       while (targElem.id != "irimg" && targElem.parentNode) {
         targElem = targElem.parentNode;
       }
       if( targElem.id == "irimg" ) {
         draggedElem = targElem;
         startMX = evt.clientX;
         startMY = evt.clientY;
         startIX = left;
         startIY = top;
         return false;
      }
    }
  }

  /*
   * Event function capturing the mouse button up event.
   */
  function release(evt) {
    mouseButtonDown = false;
    draggedElem = null;
  }

  /*
   * Event function capturing mouse out events.
   */
  function chkRelease(evt) {
    evt = (evt) ? evt : (window.event) ? window.event : "";
    if( evt.clientX < 0 ||  evt.clientY < 0 )
      draggedElem = null;
  }

  /*
   * Event function capturing key event.
   */
  function catchArrows(evt) {
     var bRetCode = true;
     evt = (evt) ? evt : (window.event) ? window.event : "";
     if (evt && evt.ctrlKey )
     {
        var keyCode = evt.keyCode;
        switch (keyCode)
        {
        case 37:
          setHairCrossByIR(1*hcX-1,hcY);
          bRetCode = false;
          break;

        case 38:
          setHairCrossByIR(hcX,(1*hcY)-1);
          bRetCode = false;
          break;

        case 39:
          setHairCrossByIR(1*hcX+1,hcY);
          bRetCode = false;
          break;

        case 40:
          setHairCrossByIR(hcX,(1*hcY)+1);
          bRetCode = false;
          break;
        }
     }
     return bRetCode;
  }

  /*
   * Init ir window according to present setup.
   */
  function init( x, y )
  {
    var p = !isZoomed() ? nzPixWidth : pixWidth;

    // Position ir image in window.
    draggedElem = null; 
    startIX = x;
    startIY = y;
    startMX = 0;
    startMY = 0;
    moveWin( 0, 0 );

    // Position crosshair
    var xp = ( ( hcX * p ) + winLeftMarg + ( origoX - left ) + p/2 );
    var yp = ( ( hcY * p ) + winTopMarg + ( origoY - top ) + p/2 );
    if( isIE() ) {
      xp += IEoffset;
      yp += IEoffset;
    }
    setHairCross( xp /*- 0.1*/, yp /*- 0.1*/ );
  }

  /*
   * Show entire ir image in ir window.
   */
  function showAll()
  {
    document.getElementById("bigImg").width = winWidth;
    document.getElementById("bigImg").height = winHeight;
    savedLeft = left;
    savedTop = top;
    init( 0, 0 );
  }

  /*
   * Show a zoomed ir image in the ir window.
   */
  function showPart( x, y )
  {
    document.getElementById("bigImg").width = imageWidth;
    document.getElementById("bigImg").height = imageHeight;
    init( x, y );
  }

  /*
   * Show the ir image in the ir window
   * according to present zoom setting.
   */
  function setZoomLevel( x, y )
  {
    if( isZoomed() )
      showPart( x, y );
    else
      showAll();
  }

  /*
   * Update hidden fields in the forms before
   * submitting the data to the web server.
   */
  function setSubmitData( frm )
  {
    var f;

    if( frm == "killfrom" ) {
      f = document.getElementById("killform");
      f.xCoord.value = hcX;
      f.yCoord.value = hcY;
      f.zoomFlag.value = isZoomed() ? 1 : 0;
      f.presentTop.value = top;
      f.presentLeft.value = left;
      f.presentHcXpos.value = hcX;
      f.presentHcYpos.value = hcY;
    }
    else if( frm == "operability" ) {
      f = document.getElementById("operability");
      f.zoomFlag.value = isZoomed() ? 1 : 0;
      f.presentTop.value = top;
      f.presentLeft.value = left;
      f.presentHcXpos.value = hcX;
      f.presentHcYpos.value = hcY;
    }
    else if( frm == "maphandling" ) {
      f = document.getElementById("maphandling");
      f.zoomFlag.value = isZoomed() ? 1 : 0;
      f.presentTop.value = top;
      f.presentLeft.value = left;
      f.presentHcXpos.value = hcX;
      f.presentHcYpos.value = hcY;
    }
    return true;
  }

  function setReplace()
  {
    var f = document.getElementById("inspect");

    f.replOnCmd.value = replacing() ? "ON" : "OFF";
    f.zoomFlag.value = isZoomed() ? 1 : 0;
    f.presentTop.value = top;
    f.presentLeft.value = left;
    f.presentHcXpos.value = hcX;
    f.presentHcYpos.value = hcY;
    f.submit();
  }

  function NucCameraFunc()
  {
    var f = document.getElementById("NucCamera");

    f.NucNowCmd.value = "ON";
    f.zoomFlag.value = isZoomed() ? 1 : 0;
    f.presentTop.value = top;
    f.presentLeft.value = left;
    f.presentHcXpos.value = hcX;
    f.presentHcYpos.value = hcY;
    f.submit();
  }


</SCRIPT>

<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">

    </head>
    <%
    if( Status == "busy" ) {
        Response.Write( '<meta http-equiv="Refresh" content="2');
        if ( currentAction != "" )
            Response.Write( ";url=pixkill.asp?currentAction=" + currentAction);
        Response.Write('">\n' );
        Response.Write( '<meta http-equiv="pragma" content="no-cache">\n' );
    }
    %>
    <body id="pgImgCorrPixKill" OnLoad="setZoomLevel( <%Response.Write( imageLeft + ", " + imageTop );%> )">
    <STYLE type="text/css">
      #irimg {
        position: absolute;
        left: auto; top: auto;
        height: auto;
        width: auto;
        overflow: hidden;
        z-index: 1;
        clip: rect( 10px 10px 10px 10px);
      }
      #xhair {
        position: absolute;
        left: 0px; top: 0px;
        height: 41px; width: 41px;
        background-color: none;
        overflow: hidden;
        z-index: 2;
        clip: rect( 10px 10px 10px 10px);
      }
      #smallimg {
        position: absolute;
        left: 10px; top: <%Response.Write( wHeight + 20 );%>px;
        height: 48px; width: 64px;
        background-color: none;
        z-index: 3;
      }
      #smallmarker {
        position: absolute;
        left: 10px; top: <%Response.Write( wHeight + 20 );%>px;
        height: 12px; width: 16px;
        background-color: none;
        z-index: 4;
      }
    </STYLE>
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuImgCorr", "mnuImgCorrPixKill" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE WIDTH="<%Response.Write( wWidth + 500 );%>">
                    <TR>
                      <TD VALIGN="top" WIDTH="<%Response.Write( wWidth + 20 );%>" HEIGHT="<%Response.Write( wHeight );%>">
                        <div id="irimg" class="draggable">
                          <img name="bigImg" id="bigImg" src="/Ram/webimage.jpg?arg=<% Response.Write( RandomString ); %>" width="<%Response.Write( iWidth );%>" height="<%Response.Write( iHeight );%>" class="draggable">
                          <script type="text/javascript">
                            document.onmousedown = engage;
                            document.onmouseup = release;
                            document.onmousemove = dragIt;
                            document.onmouseout = chkRelease;
                            document.onkeydown = catchArrows;
                          </script>
                        </div>
                        <div id="xhair" class="draggable">
                          <img name="hCross" src="/images/cross.gif">
                          <script type="text/javascript">
                            document.onmousedown = engage;
                            document.onmouseup = release;
                            document.onmousemove = dragIt;
                            document.onmouseout = chkRelease;
                            document.onkeydown = catchArrows;
                          </script>
                        </div>
                      </TD>
                      <TD VALIGN="top">
                        <h2>Instruction</h2>
                        <p>Click first on <b>New Image</b></p>
<% if( bUnZoomable ) Response.Write( "<!--\n" ); %>
                        <p>Click and drag within the large image with the mouse to pan when it is magnified.</p>
<% if( bUnZoomable ) Response.Write( "-->\n" ); %>
                        <p>Use ctrl + click and drag to place a crosshair on a bad pixel/row/column.
                           Move it with ctrl + arrow keys.</p>
                        <p>Select a method and press <b>**Kill**</b></p>
                        <p>Note: some methods work only in a calibrated camera</p>
	                        <p><b>Save</b> the dead pixel map when you are finished.</p>
                        <p>Use <b>Check Operability</b> to evaluate the quality of the image.</p>
                        <br>
                        <FORM ACTION="#" METHOD="post" NAME="clearErr" ID="clearErr">
                        <%if ( Status == "busy" )
                               Response.Write("<span id=errstatus> Camera working, please wait! </span>&nbsp;")
                          else if ( ECode > 0 )
                          {
                               Response.Write("<span id=errstatus>" + ecodeString( ECode ) + "</span>&nbsp;")
                               Response.Write('<INPUT TYPE="submit" VALUE="Clear Error" ID="clearErrCmd" NAME="clearErrCmd">');
                          }
							else if ( ECode < 0 ) {
                               Response.Write("<span id=errstatus> Production Application not available!</span>&nbsp;")
							}
							else {
	                            var ServiceMode = restree.getResourceValue( ".prod.log.serviceMode" );
								if( !ServiceMode ) {
                               Response.Write("<span id=errstatus> Camera not in service mode!</span>&nbsp;")
						  }
								else if ( Request.Form.Count > 0 || forceCommandOK ) {
                               Response.Write("<span id=OKstatus> Command OK </span>&nbsp;")
                               var nPixKilled = restree.getResourceValue( ".prod.map.pixKilled" );
                               if ( nPixKilled > 0 )
                                  Response.Write( "<BR>" + nPixKilled + " pixel(s) killed&nbsp;");
                          }
							}
                         %>
                          </FORM>
                      </TD>
                    </TR>
                  </TABLE>
                  <TABLE ID="Table2">
                    <TR>
<% if( bUnZoomable ) Response.Write( "<!--\n" ); %>
                      <TD WIDTH="<%Response.Write( iWidth  / iSmallDiv );%>" HEIGHT="<%Response.Write( ( iHeight / iSmallDiv ) + 10 );%>" >
                        <div id="smallimg">
                          <img name="smallImg" src="/Ram/webimage.jpg?arg=<% Response.Write( RandomString ); %>" WIDTH="<%Response.Write( iWidth  / iSmallDiv );%>" HEIGHT="<%Response.Write( iHeight / iSmallDiv );%>">
                        </div>
                        <div id="smallmarker">
                          <img name="smallMrk" src="/images/dotted_16x12.gif" WIDTH="<%Response.Write( wWidth  / iSmallDiv );%>" HEIGHT="<%Response.Write( wHeight / iSmallDiv );%>">
                        </div>
                      </TD>
<% if( bUnZoomable ) Response.Write( "-->\n" ); %>
                        <TD valign="top">
                            <FORM ACTION="#" METHOD="post" NAME="maphandling" ID="maphandling" OnSubmit="return setSubmitData( 'maphandling' );">
                                <INPUT TYPE="submit" VALUE="New Image" ID="newImage" NAME="newImage"  <%if( Status == "busy" ) Response.Write( "disabled" ); %>><br><br>
                                <INPUT TYPE="submit" VALUE="Save map to file" ID="saveCmd" NAME="saveCmd"  <%if( Status == "busy" ) Response.Write( "disabled" ); %>><br><br>
                                <INPUT TYPE="submit" VALUE="Restore map from file" ID="restoreCmd" NAME="restoreCmd"  <%if( Status == "busy" ) Response.Write( "disabled" ); %>><br><br>
                                <INPUT TYPE="hidden" VALUE="0" NAME="zoomFlag" ID="Hidden1">
                                <INPUT TYPE="hidden" VALUE="0" NAME="presentTop" ID="Hidden2">
                                <INPUT TYPE="hidden" VALUE="0" NAME="presentLeft" ID="Hidden3">
                                <INPUT TYPE="hidden" VALUE="0" NAME="presentHcXpos" ID="Hidden4">
                                <INPUT TYPE="hidden" VALUE="0" NAME="presentHcYpos" ID="Hidden5">
                            </FORM>
                        </td>
                        <TD valign="top">
                            <FORM ACTION="#" METHOD="post" NAME="killform" ID="killform" OnSubmit="return setSubmitData( 'killfrom' );">
                            Method:&nbsp;
                                <SELECT NAME="method" size="1" <%if( Status == "busy" ) Response.Write( "disabled" ); %> ID="Select1">
<%if( CamType == "X" || CamType == "Z" || CamType == "Z3" ) addResTreeOptions("prod.prodSpec.operability.config.pixKill", "pixKillID", "", methodItem);%>
<%if( CamType != "X" && CamType != "Z" && CamType != "Z3" ) addResTreeOptions("prod.prodSpec.operability.config.pixKill", "pixKillID", "AfterGM", methodItem);%>
                                  <OPTION VALUE="killPix" <%if ( methodItem == "killPix" ) Response.Write("SELECTED");%>>Pixel</OPTION>
                                  <OPTION VALUE="killColumn" <%if ( methodItem == "killColumn" ) Response.Write("SELECTED");%>>Column</OPTION>
                                  <OPTION VALUE="killRow" <%if ( methodItem == "killRow" ) Response.Write("SELECTED");%>>Row</OPTION>
                                  <OPTION VALUE="killSpatImg" <%if ( methodItem == "killSpatImg" ) Response.Write("SELECTED");%>>Spatial Image</OPTION>
                                  <OPTION VALUE="killTempoImg" <%if ( methodItem == "killTempoImg" ) Response.Write("SELECTED");%>>Temporal Image</OPTION>
                                  <OPTION VALUE="killSlow" <%if ( methodItem == "killSlow" ) Response.Write("SELECTED");%>>Slow Pixels</OPTION>
                                  <OPTION VALUE="killSpatGain" <%if ( methodItem == "killSpatGain" ) Response.Write("SELECTED");%>>Spatial Gain</OPTION>
<% if( CamType =="X" || CamType == "Z" || CamType == "Z3" ) Response.Write( "<!--\n" ); %>
                                  <OPTION VALUE="killDyn" <%if ( methodItem == "killDyn" ) Response.Write("SELECTED");%>>Dynamic Range</OPTION>
<% if( CamType =="X" || CamType == "Z" || CamType == "Z3" ) Response.Write( "-->\n" ); %>
                                  <OPTION VALUE="autoColumn" <%if ( methodItem == "autoColumn" ) Response.Write("SELECTED");%>>Auto Column</OPTION>
                                  <OPTION VALUE="autoRow" <%if ( methodItem == "autoRow" ) Response.Write("SELECTED");%>>Auto Row</OPTION>
<% if( CamType != "P" && CamType != "Pt" ) Response.Write( "<!--\n" ); %>
                                  <OPTION VALUE="killUnLin" <%if ( methodItem == "killUnLin" ) Response.Write("SELECTED");%>>Non Liniar Pixels</OPTION>
<% if( CamType != "P" && CamType != "Pt" ) Response.Write( "-->\n" ); %>
<% if( CamType != "X" ) Response.Write( "<!--\n" ); %>
                                  <OPTION VALUE="killTempoLong" <%if ( methodItem == "killTempoLong" ) Response.Write("SELECTED");%>>Slow Blinkers</OPTION>
<% if( CamType != "X" ) Response.Write( "-->\n" ); %>
                                  <OPTION VALUE="replaceKilled" <%if ( methodItem == "replaceKilled" ) Response.Write("SELECTED");%>>Replace only</OPTION>
                                </SELECT>
                                <BR><BR>
                                <INPUT TYPE="submit" VALUE="** Kill **" ID="killCmd" NAME="killCmd" <%if( Status == "busy" ) Response.Write( "disabled" ); %>>
                                <INPUT TYPE="hidden" VALUE="0" NAME="xCoord" ID="Hidden6">
                                <INPUT TYPE="hidden" VALUE="0" NAME="yCoord" ID="Hidden7">
                                <INPUT TYPE="hidden" VALUE="0" NAME="zoomFlag" ID="Hidden8">
                                <INPUT TYPE="hidden" VALUE="0" NAME="presentTop" ID="Hidden9">
                                <INPUT TYPE="hidden" VALUE="0" NAME="presentLeft" ID="Hidden10">
                                <INPUT TYPE="hidden" VALUE="0" NAME="presentHcXpos" ID="Hidden11">
                                <INPUT TYPE="hidden" VALUE="0" NAME="presentHcYpos" ID="Hidden12">
                            </FORM>
                            <FORM ACTION="#" METHOD="post" NAME="operability" ID="operability" OnSubmit="return setSubmitData( 'operability' );">
                                <INPUT TYPE="submit" VALUE="Check Operability" ID="opercheck" NAME="opercheck"  <%if( Status == "busy" ) Response.Write( "disabled" ); %>>
                                <INPUT TYPE="hidden" VALUE="0" NAME="zoomFlag">
                                <INPUT TYPE="hidden" VALUE="0" NAME="presentTop">
                                <INPUT TYPE="hidden" VALUE="0" NAME="presentLeft">
                                <INPUT TYPE="hidden" VALUE="0" NAME="presentHcXpos">
                                <INPUT TYPE="hidden" VALUE="0" NAME="presentHcYpos">
                            </FORM>
                            <br>  
                            <FORM ACTION="#" METHOD="post" NAME="inspect" ID="inspect">
                                <INPUT TYPE="hidden" VALUE="ON" ID="replOnCmd" NAME="replOnCmd">
                                <INPUT TYPE="hidden" VALUE="0" NAME="zoomFlag">
                                <INPUT TYPE="hidden" VALUE="0" NAME="presentTop">
                                <INPUT TYPE="hidden" VALUE="0" NAME="presentLeft">
                                <INPUT TYPE="hidden" VALUE="0" NAME="presentHcXpos">
                                <INPUT TYPE="hidden" VALUE="0" NAME="presentHcYpos">
                            </FORM>
                            <FORM ACTION="#" METHOD="post" NAME="NucCamera" ID="NucCamera">
                                <INPUT TYPE="hidden" VALUE="OFF" ID="NucNowCmd" NAME="NucNowCmd">
                                <INPUT TYPE="hidden" VALUE="0" NAME="zoomFlag">
                                <INPUT TYPE="hidden" VALUE="0" NAME="presentTop">
                                <INPUT TYPE="hidden" VALUE="0" NAME="presentLeft">
                                <INPUT TYPE="hidden" VALUE="0" NAME="presentHcXpos">
                                <INPUT TYPE="hidden" VALUE="0" NAME="presentHcYpos">
                            </FORM>
                        </TD>
					   
                        <TD valign="top">
<% if( bUnZoomable ) Response.Write( "<!--\n" ); %>
                        <INPUT TYPE="checkbox" id="noZoom" name="noZoom" <%if( !wasZoomed ) Response.Write( "checked " ); %>OnClick="setZoomLevel( savedLeft, savedTop )">&nbsp;Show entire image<br>
<% if( bUnZoomable ) Response.Write( "-->\n" ); %>
                        <INPUT TYPE="checkbox" id="replace" name="replace" <%if( replaceOn ) Response.Write( "checked " ); %>OnClick="setReplace()">&nbsp;Hide killed pixels<br><br>
                        <INPUT TYPE="button" VALUE="NUC" ID="NUC" NAME="NUC" OnClick="NucCameraFunc()" <%if( Status == "busy" ) Response.Write( "disabled" ); %>><br>

						
							<FORM ACTION=# METHOD="POST"><BR>
								<INPUT TYPE="submit" NAME="NPixKill" VALUE="Spat img kill">
								<INPUT TYPE="input" NAME="NKill" SIZE="2" maxlength="4"="Input2" VALUE= "<%Response.Write( iNKill );%>">number of pix.
							</FORM>
                        </TD>
                      </TR>
                      <TR>
                         <TD colspan=3>
                            Current dead pixel map file name: <%Response.Write(MapName); 
							if ( CamType != "X" && CamType != "Z" && CamType != "Z3" ) Response.Write("&nbsp;(<a href='ImgCorrSelCase.asp'>Change case</a>)");%><BR>
                            <%Response.Write( "&nbsp;<a href='ActivateDigFilters.asp'>Activate digital filters for spatial image kill</a>");%>
                        </TD>
                      </TR>
                </TABLE>
            </div>
            <%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
