<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<%
  var started = false;
  var enabled = false;
  var editMapName = true;
  var presGainMap = "";
  var testResPath = "prod.measure.status";
  var Ecode = 0;
  var ValueType;

  if( CamType == "Z" || CamType == "Z3" ) 
  {
    testResPath = "prod.map.status";
  }

  ValueType = restree.valueType( testResPath );
  if( ValueType != "N/A") /* This works on all types of values */
  { 
    started = true;
  }

  if( Request.Form.Count > 0 ) 
  {
    if( Request.Form( "mode" ) == "staticCold" ) 
    {
      if( started ) 
      {
        if( CamType == "X" ) 
        {
          enabled = true;
          restree.setResourceValue( "prod.measure.avgimages", 16  );
          restree.setResourceValue( "prod.measure.filename", "/Temp/cold.fff"  );
          restree.setResourceValue( "prod.measure.command", "averageImage"  );
          for( i = 0; i < 50; i++ ) 
          {
            Status = restree.getResourceValue( "prod.measure.status" );
            if( Status != "busy" ) 
            {
              break;
            }
            restree.sleep( 300 );
          }
          presGainMap = Request.Form( "mapname" );
          Ecode = restree.getResourceValue( "prod.measure.ecode" );
        }
        else if (CamType == "Z" || CamType == "Z3" )
        {
          enabled = true;
          editMapName = false;
          restree.setResourceValue( "prod.map.coldImage", "/Temp/cold.fff"  );
          restree.setResourceValue( "prod.map.command", "measColdImage"  );
          for( i = 0; i < 50; i++ ) 
          {
            Status = restree.getResourceValue( "prod.map.status" );
            if( Status != "busy" ) 
            {
              break;
            }
            restree.sleep( 300 );
          }
          /* Read any error code */
          presGainMap = Request.Form( "mapname" );
          Ecode = restree.getResourceValue( "prod.map.ecode" );
        }
      }
    }
  }
  var strTitle = "Gain Mapping, Calculation";
%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    </head>
    <body id="pgStaticMapping">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuImgCorr", "mnuImgCorrStaticMapCalc" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE WIDTH="95%">
                    <%
                      if( enabled ) {
                        if( !started ) {
                          Response.Write( '<TR><TD BGCOLOR="#FF0000">Error starting production program</TD></TR>\n' );
                        }
                        else if( Ecode != 0 ) {
                          Response.Write( '<TR><TD BGCOLOR="#FF0000">' );
                          Response.Write( ecodeString( Ecode ) );
                          Response.Write( '</TD></TR>\n' );
                        }
                      }
                    %>
                    <TR>
                        <TD VALIGN="top" WIDTH="50%">
                            <FORM ACTION="StaticMapResult.asp" METHOD="post" NAME="staticCalc" ID="Form1">
                                Static map name
                                <BR>
                                <BR>
                                <INPUT TYPE="text" MAXLENGTH="40" SIZE="40" NAME="mapname" VALUE="<%Response.Write( presGainMap );%>" ID="Text1"<%if (!enabled ) {Response.Write( " disabled" );} else if (!editMapName) {Response.Write( " readonly" );} %>><BR>
                                <BR>
                                <BR>
                                <INPUT TYPE="hidden" NAME="mode" VALUE="staticCalc">
                                <INPUT TYPE="submit" VALUE="Calculate and store map" ID="Submit1" NAME="Submit1"<%if (!enabled ) Response.Write( " disabled" ); %>>
                            </FORM>
                        </TD>
                        <TD VALIGN="top" WIDTH="50%">
                            <P>Press the <b>Calculate and store map</b> button to calculate the
                               static gain map.</P>
                            <P>The new map is stored in the map directory using the specified name.
                               The camera calibration is also updated.</P>
                            <P>The dead pixel replacement may need to be updated using the
                               <B>Pixel replacement</B> page.</P>
                        </TD>
                    </TR>
                </TABLE>
            </div>
            <%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
