<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<%
  var started = false;
  var enabled = false;
  var presGainMap = "";
  var testResPath = "prod.measure.status";
  var Ecode = 0;
  var ValueType;
  var mapStatus = false;

  if( CamType == "Z" || CamType == "Z3" ) 
  {
    testResPath = "prod.map.status";
  }

  ValueType = restree.valueType( testResPath );
  if( ValueType != "N/A") /* This works on all types of values */
  { 
    started = true;
  }

  if( Request.Form.Count > 0 ) 
  {
    if( Request.Form( "mode" ) == "staticCalc" ) 
    {
      if( started ) 
      {
        /* Do this for X */
        if( CamType == "X" ) 
        {
          enabled = true;
          restree.setResourceValue( "tcomp.services.autoNuc.active",  true );
          restree.setResourceValue( "prod.map.command", "init"  );
          for( i = 0; i < 50; i++ ) 
          {
            Status = restree.getResourceValue( "prod.map.status" );
            if( Status != "busy" ) 
            {
              break;
            }
            restree.sleep( 300 );
          }
          presGainMap = Request.Form( "mapname" );
          restree.setResourceValue( "prod.map.coldImage", "/Temp/cold.fff"  );
          restree.setResourceValue( "prod.map.warmImage", "/Temp/warm.fff"  );
          restree.setResourceValue( "prod.map.gainMap", presGainMap );
          restree.setResourceValue( "prod.map.command", "gainMap"  );
          for( i = 0; i < 50; i++ ) 
          {
            Status = restree.getResourceValue( "prod.map.status" );
            if( Status != "busy" ) 
            {
              break;
            }
            restree.sleep( 300 );
          }

          restree.setResourceValue( "calib.detector.gainMap.ds350C_we1_ap_fi_le.static.fileName", presGainMap );
          restree.setResourceValue( "calib.detector.gainMap.ds350C_we1_ap_fi_le.static.enabled", true );

          restree.setResourceValue( "image.services.range.commit", true  );
          for( i = 0; i < 50; i++ ) 
          {
            Status = restree.getResourceValue( "image.services.range.status" );
            if( Status == 0 ) 
            {
              break;
            }
            restree.sleep( 300 );
          }
        }
        /* Do this for Z */
        else if( CamType == "Z" || CamType == "Z3" ) 
        {
          enabled = true;
          /* Calculate a new gain dead map */
          restree.setResourceValue( "prod.map.command", "gainDeadMap"  );
          for( i = 0; i < 50; i++ ) 
          {
            Status = restree.getResourceValue( "prod.map.status" );
            if( Status != "busy" ) 
            {
              break;
            }
            restree.sleep( 300 );
          }
          if( Status == "ready" ) 
          {
            /* Reload range */
            restree.setResourceValue( "image.services.range.commit", true  );
            for( i = 0; i < 50; i++ ) 
            {
              Status = restree.getResourceValue( "image.services.range.status" );
              if( Status == 0 ) 
              {
                break;
              }
              restree.sleep( 300 );
            }
          }

          restree.setResourceValue( "tcomp.services.autoNuc.active",  true );
          
        }
        /* Save the calib */
        restree.setResourceValue( "dump.file", "/FlashFS/system/calib.rsc"  );
        restree.setResourceValue( "dump.includeDefault", true  );
        restree.setResourceValue( "dump.node", ".calib"  );
        restree.setResourceValue( "dump.relativePaths", false  );
        restree.setResourceValue( "dump.commit", true  );

        Ecode = restree.getResourceValue( "prod.map.ecode" );
      }
    }
    else if( Request.Form( "mode" ) == "turnOn" ) 
    {
      enabled = true;
      presGainMap = Request.Form( "mapname" );
      if( CamType == "X" ) {
        restree.setResourceValue( "calib.detector.gainMap.ds350C_we1_ap_fi_le.static.enabled", true );
      }
      else if( CamType == "Z" || CamType == "Z3" ) 
      {
        restree.setResourceValue( "calib.detector.staticGainMap.ds250C_we_ap_fi_le.enabled", true );
      }
      restree.setResourceValue( "image.services.range.commit", true  );
      for( i = 0; i < 50; i++ ) 
      {
        Status = restree.getResourceValue( "image.services.range.status" );
        if( Status == 0 ) 
        {
          break;
        }
        restree.sleep( 300 );
      }
    }
    else if( Request.Form( "mode" ) == "turnOff" ) 
    {
      enabled = true;
      presGainMap = Request.Form( "mapname" );
      if( CamType == "X" ) 
      {
        restree.setResourceValue( "calib.detector.gainMap.ds350C_we1_ap_fi_le.static.enabled", false );
      }
      else if( CamType == "Z" || CamType == "Z3" ) 
      {
        restree.setResourceValue( "calib.detector.staticGainMap.ds250C_we_ap_fi_le.enabled", false );
      }
      restree.setResourceValue( "image.services.range.commit", true  );
      for( i = 0; i < 50; i++ ) 
      {
        Status = restree.getResourceValue( "image.services.range.status" );
        if( Status == 0 ) 
        {
          break;
        }
        restree.sleep( 300 );
      }
    }
  }
  if( CamType == "X" ) 
  {
    mapStatus = restree.getResourceValue( "calib.detector.gainMap.ds350C_we1_ap_fi_le.static.enabled" );
  }
  else if( CamType == "Z" || CamType == "Z3" ) 
  {
    mapStatus = restree.getResourceValue( "calib.detector.staticGainMap.ds250C_we_ap_fi_le.enabled" );
  }
  var strTitle = "Gain Mapping, Result";
%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    </head>
    <body id="pgStaticMapping">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuImgCorr", "mnuImgCorrStaticMapResult" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE WIDTH="95%">
                    <%
                      if( enabled ) {
                        if( !started ) {
                          Response.Write( '<TR><TD COLSPAN="2" BGCOLOR="#FF0000">Error starting production program</TD></TR>\n' );
                        }
                        else if( Ecode != 0 ) {
                          Response.Write( '<TR><TD COLSPAN="2" BGCOLOR="#FF0000">' );
                          Response.Write( ecodeString( Ecode ) );
                          Response.Write( '</TD></TR>\n' );
                        }
                      }
                    %>
                    <TR>
                        <TD VALIGN="top" COLSPAN="2">
                            <P>The new static gain map have been created successfully.</P>
                            <P>The new map is stored as <b><%Response.Write( presGainMap );%></b>
                               and the camera calibration have been updated.</P>
                        </TD>
                    </TR>
                    <TR>
                       <TD>
                         <BR>
                         <FORM ACTION="StaticMapResult.asp" METHOD="post" NAME="staticOff" ID="Form1">
                           <INPUT TYPE="hidden" NAME="mapname" VALUE="<%Response.Write( presGainMap );%>">
                           <INPUT TYPE="hidden" NAME="mode" VALUE="turnOff">
                           <INPUT TYPE="submit" VALUE="Turn Off Static Map" ID="Submit2" NAME="Submit1"<%if( !mapStatus || !enabled ) Response.Write( " disabled" ); %>>
                       </FORM>
                       </TD>
                       <TD>
                         <BR>
                         <FORM ACTION="StaticMapResult.asp" METHOD="post" NAME="staticOn" ID="Form1">
                           <INPUT TYPE="hidden" NAME="mapname" VALUE="<%Response.Write( presGainMap );%>">
                           <INPUT TYPE="hidden" NAME="mode" VALUE="turnOn">
                           <INPUT TYPE="submit" VALUE="Turn On Static Map" ID="Submit2" NAME="Submit1"<%if( mapStatus || !enabled ) Response.Write( " disabled" ); %>>
                       </FORM>
                      </TD>
                    </TR>
                </TABLE>
            </div>
			<%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
