<%@ LANGUAGE = JSCRIPT %>

<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/serviceutils.inc" -->

<%
  /* Create proper working conditions in the camera  */

  var bAppStarted = isAppStarted("prodapp", "prod.tdrift.filename");
  var bEnabled = bAppStarted;
	var strDisabled = "disabled ";
  var nEcode = -1;

  /* Dummy initiations of our form content variables  */
  
	var strTDriftChecked = "";
	var strTCompActive = "";
	var strMapActive = "";
	var bRunning = false;
	var bStopped = false;
	var strCaseName = "";
  var strUseUserAreas = ""
  var strSwitchCase = ""
	var strComment = new String();
    
  if (bEnabled)
  {
    /* Go through the submitted form , if it is our own one. */
    
    if ( Request.Form.Count > 0 )
    {
      if (Request.Form( "SubmitStartTdrLogging" ) != "" )
      {
	      restree.setResourceValueWait("system.time.control", "LOCKED");
        var strHour = restree.getResourceValue("system.time.hour");
        var strMin = restree.getResourceValue("system.time.min");
	      var strSec =  restree.getResourceValue("system.time.sec");
	      restree.setResourceValueWait("system.time.control", "RUNNING");
         
	      restree.setResourceValue("prod.prodSpec.tdrift.config.verificationMode", (Request.Form( "verify" ) != ""));
	      restree.setResourceValue("prod.prodSpec.tdrift.config.useUserAreas", (Request.Form( "UseUserAreas" ) != ""));
	      restree.setResourceValue("prod.prodSpec.tdrift.config.switchCase", (Request.Form( "SwitchCase" ) != ""));
	      restree.setResourceValue("prod.tdrift.externalComment", "Service Web Log started at " + preZero(2,strHour) + ":" + preZero(2,strMin) + "." + preZero(2,strSec) );

        restree.setResourceValue("prod.tdrift.command", "init");
        bEnabled = waitWhileBusy("prod.tdrift.status");
        nEcode = restree.getResourceValue("prod.tdrift.ecode");
        
        if ( bEnabled ) 
        {
	        strDisabled = "";
	        restree.setResourceValue("prod.tdrift.command", "start");
	        waitWhileBusy("prod.tdrift.status");
          nEcode = restree.getResourceValue("prod.tdrift.ecode");
        }
	    }
	    else if (Request.Form ( "SubmitStopTdrLogging" ) != "" )
      { 
        if ( bEnabled ) 
        {
	        strDisabled = "";
	        
	        restree.setResourceValue("prod.tdrift.command", "stop");
	        bEnabled = waitWhileBusy("prod.syscalib.status");
          nEcode = restree.getResourceValue("prod.syscalib.ecode");
	        restree.setResourceValue("prod.tdrift.externalComment", "Stopped");
        }
	    }
    }
    else
      nEcode = 0;
    

    /* We are about to show our own form now. Fetch proper data for it */
    
    if (bEnabled)
    {
	    var bVerify = restree.getResourceValue("prod.prodSpec.tdrift.config.verificationMode");
	    if (bVerify)
	      strTDriftChecked = "checked ";

	    var bUseUserAreas = restree.getResourceValue("prod.prodSpec.tdrift.config.useUserAreas");
	    if( bUseUserAreas )
	      strUseUserAreas = "checked ";

	    var bSwitchCase = restree.getResourceValue("prod.prodSpec.tdrift.config.switchCase");
	    if( bSwitchCase )
	      strSwitchCase = "checked ";
	      
	    strComment = restree.getResourceValue("prod.tdrift.externalComment");
	    if ( strComment.substr(0,11)  == "Service Web" )
	      bRunning = true;
	    else if ( strComment == "Stopped" )
	      bStopped = true;
	      
	    var strCasePath = restree.getResourceValue("image.ccase.ccase");
	    strCaseName =  restree.getResourceValue(strCasePath + ".descr");
	    
	    var bTCompActive = restree.getResourceValue("tcomp.active");
	    if (bTCompActive)
  	    strTCompActive = "On";
  	  else
  	    strTCompActive = "Off";

	    var bGDMapActive = restree.getResourceValue( "image.flow.maps.combGainDeadMap.active" );
	    var bOMapActive = restree.getResourceValue( "image.flow.maps.combOffsetMap.active" );
	    var bSMapActive = restree.getResourceValue( "image.flow.maps.shutterMap.active" );
	    if( bGDMapActive || bOMapActive || bSMapActive )
  	    strMapActive = "Active";
  	  else
  	    strMapActive = "Off";
	  }
  }
  var strTitle = "Drift Compensation Logging"; 
%>
<HTML>
  <HEAD>
<%
  if (bRunning)
      Response.Write('<meta http-equiv="Refresh" content="5"><meta http-equiv="pragma" content="no-cache">');
%> 
    <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
    <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
  </HEAD>
  <body id="pgTDriftLogging">
    <%printStandardDecoration( strTitle );%>
    <%printNavigation( "mnuTDRIFT", "mnuTDRIFTLogging" );%>
    <!-- This is the actual contents -->
    <div id="mainpane">
      <div id="content">
        <TABLE>
          <TR>
            <TD vAlign="top">
              <%
                  if ( bEnabled == false )
                      Response.Write("<span id=errstatus> Production Application not available! </span><br>");
                  else if ( nEcode != 0 )
                      Response.Write("<span id=errstatus> Command not OK, " + ecodeString(nEcode) +" </span><br>");
              %>
            </TD>
          </TR>
          <TR>
            <TD vAlign="top">
            <% 
               if ( bRunning )
               {
                 Response.Write(strComment + "<BR><BR>");
                 Response.Write("Current case: "+strCaseName+"<br><br>");
                 Response.Write("Mapping is " + strMapActive + "<BR>");
                 Response.Write("Temperature drift compensation is " + strTCompActive + "<BR>");
               }
               else
               {
                 Response.Write("Please put the camera in a temperature chamber<BR>");
                 Response.Write("and let it look at a blackbody outside the chamber.<BR>");
                 Response.Write("Run a temperature cycle, and check the output log file.<BR><BR>");
               }
            %>
              <FORM id="Form1" name="TDR" action="#" method="post">
              
            <% if (!bRunning)
               {
                 Response.Write('<INPUT id="VerifyMode" type="checkbox" name="verify"'); 
                 Response.Write(strTDriftChecked); if ( !bEnabled) Response.Write("disabled"); Response.Write('>&nbsp;Verification mode <BR>');

                 Response.Write('<INPUT id="UseUserAreas" type="checkbox" name="UseUserAreas"'); 
                 Response.Write(strUseUserAreas); if ( !bEnabled) Response.Write("disabled"); Response.Write('>&nbsp;UseUserAreas <BR>');

                 Response.Write('<INPUT id="SwitchCase" type="checkbox" name="SwitchCase"'); 
                 Response.Write(strSwitchCase); if ( !bEnabled) Response.Write("disabled"); Response.Write('>&nbsp;SwitchCase <BR>');
               }
            %>
                
                <BR>
            <% if (bRunning)
               {
                 Response.Write('<INPUT id="Submit2" type="submit" value="Stop" name="SubmitStopTdrLogging" '); 
                 if ( !bEnabled ) Response.Write("disabled"); Response.Write('>');
               }
               else
               {
                 Response.Write('<INPUT id="Submit1" type="submit" value="Start" name="SubmitStartTdrLogging" '); 
                 if ( !bEnabled ) Response.Write("disabled"); Response.Write('>');
               }
            %>
             </FORM>
             <%
               if ( bStopped )
               {
                 Response.Write("<BR><BR>Logging stopped<BR><BR>");
                 Response.Write('<A href="/prod/file/flashfs/tmp/tdrift.log" >Click here to get the output file.</A><BR>');
               }
             %>
            </TD>
          </TR>
        </TABLE>
      </div>
      <div>
        <%printStandardFooter();%>
      </div>
    </div>
    <!-- End of actual contents -->
  </body>
</HTML>
