<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/versions.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<%
  function toCelsius( inTemp )
  {
      var outTemp = 1.0*inTemp - 273.15;
      return outTemp.toFixed(2);
  }
	function printTSvalues()
	{
		var tsItem = "";
		var strTsItem;
		
		var restreeCorr = new ResTree();
		
		restree.path = "system.tempsens";
		tsItem = restree.getFirst();
		
		Response.Write('<tr class="caption">');
		Response.Write('<td>Name</td>');
		Response.Write('<td>Raw</td>');
		Response.Write('<td>Corrected [&deg;C]</td></tr>');
	
		while (tsItem != "")
		{
		  if( tsItem != "raw" )
		  {
		    strTsItem = restree.getResourceValue(tsItem);
		    Response.Write('<tr><td>' + tsItem + '</td>');
		    Response.Write('<td>' + strTsItem.toFixed(2) + '</td>');
		    Response.Write('<td>' + toCelsius(restreeCorr.getResourceValue(".image.flow.TSens." + tsItem)) + '</td></tr>');
		  }
		  tsItem = restree.getNext();
		}
		restree.path = "";
		Response.Write('<tr><td> TSFpaRaw </td>');
		Response.Write('<td>' + restreeCorr.getResourceValue(".image.flow.detector.TSFpaRaw") + '</td><td></td></tr>');
		if ( restree.getResourceValue("system.tempsensValid") == false )
		  Response.Write('<td> <span id=errstatus> Some sensor is invalid <span> </td><td></td></tr>');
		  
	}
  var strTitle = "Temperature Sensors";
%>

<html>
    <head>
        <meta http-equiv="Refresh" content="5">
        <meta http-equiv="pragma" content="no-cache">
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    </head>
    <body id="pgTDriftSensors">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuTDRIFT", "mnuTDRIFTSensors" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
				      <table ID="Table1">
					      <%printTSvalues();%>
				      </table>
				      <br>
				      <br>
            </div>
			      <%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
