<%
ecodeTable = new Array(
    "OK",
    "Wrong state",
    "Resource error",
    "Memory error",
    "Invalid command",
    "OnChip term error",
    "Collect phase error",
    "Select phase error",
    "Coarsemap error",
    "Calculation error",

    "Calibration error",
    "File access error",
    "Value outside limits",
    "Framegrabbing error",
    "No logfile",
    "No prodspec parameters",
    "Calib case error",
    "Gainmap error",
    "Deadpixmap error",
    "Calib case not found",

    "Mbox error",
    "Range activation error",
    "Error in prodspec",
    "Prodspec version error",
    "Response calculation error",
    "Result outside prodspec limits",
    "Error from system call",
    "Tempsensor malfunction",
    "Noise ProdSpec operator error",
    "Software limit error",

    "Ulis Dos Vsk",
    "During nuc",
    "Wrong camera type",
    "Wrong lens mounted",
    "Wrong temperature",
    "Map creation error",
    "No BB for SlowPix",
    "SlowPix function error",
    "Focus Error",
    "Fusion calibration Error",

    "Shutter Error",
    "OA for blind bolometers outside spec",
    "I2C bus Error",
    "Nuc Error",
    "Aiming for calibratin Error",
    "Laser calibration Error",
	"Error Detecting IR spot(s)",
	"Error Detecting Vis spot(s)",
	"Lens data not found or in error",
	"Measurement failed",

	"BB not found in prodspec",
	"Wrong production state",
	"Unexpected power down detected",
	"Vis / IR camera alpha error",
	"Conveyor start up error",
   "Error in KaKa startup",		// 55
   "Visual align error",		// 56
   "Focus distance error",		// 57
   "Failed to find gainmap position offset",		// 58
   "Failed to compute GFID",		// 59
   "Failed to set live image",		// 60
   "Not ready for run in BAL",		// 61
   "Fail when detection collimator center",		// 62
   "Result from lens calibration outside spec",		// 63
   "Image recall failed when checking bar target",		//  64 
   "Image freeze failed when checking bar target",		// 65
   "Failed to find BAR target",		// 66
   "Dual vis camaras not calibrated",		// 67
   "Fusion not calbrated", // 68
   "Computed calibration constants for vis cameras outside spec",		// 69
   "Computed calibration constants for fusion outside spec",     // 70
   "Lens failed in BAR test",		// 71
   "Unable to \"fusion\" at close/(far) distance",		// 72
   "Bad image defect \"Blob\"",		// 73
   "Bad tdrift image( too many saturated pixels )",		// 74
   "Focus max/min position not found",		// 75
   "Focus far position too close to physical far position",		// 76
   "Focus near position too close to physical near position",		// 77
   "Slanted edge netd measurement failed",		// 78
   "Detector response out of spec",		// 79
   "Saturated pixels in image",
    "IR/Vis camera rotation out of spec when distortin mapping",
    "Camera Mtf out of spec"			// 82

);

maxEcode = 82;

function ecodeString( ecode )
{

  if( ecode < 0 || ecode > maxEcode )
    eStr = "Unknown ecode";
  else
    eStr = ecodeTable[ ecode ];

  return eStr;
}
%>
