<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/resTree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/inc/usermenu.inc" -->
<!-- #include virtual = "/inc/versions.inc" -->
<%
	function printStats()
	{
		var year, month, day, hour, min, sec;
		restree.path = "";
		var absZero = -273.15;
		var laserTime, operatingTime, upTime;
		var maxOpTemp = new Number(restree.getResourceValue("stats.maxOpTemp") + absZero);
		var minOpTemp = new Number(restree.getResourceValue("stats.minOpTemp") + absZero);
		var minDate = new Date( restree.getResourceValue( "stats.minOpTempTime" ) * 1000 );
		var maxDate = new Date( restree.getResourceValue( "stats.maxOpTempTime" ) * 1000 );

		laserTime = Math.round(restree.getResourceValue("stats.laserTime")/3600);
		operatingTime = Math.round((restree.getResourceValue("stats.operatingTime") / 3600));
		upTime = Math.round((restree.getResourceValue("stats.upTime") / 3600));
		
		
		Response.Write('<tr><td>Number of cold starts</td><td>' + restree.getResourceValue("stats.coldStarts") + '</td></tr>');
		Response.Write('<tr><td>Number of shutter operations</td><td>' + restree.getResourceValue("stats.shutterMoves") + '</td></tr>');
		if( CamType != "X" && CamType != "Z" && CamType != "FX" && CamType != "Z3" )
		  Response.Write('<tr><td>Number of focus moves</td><td>' + restree.getResourceValue("stats.focusMoves") + '</td></tr>');

		if( CamType != "A" && CamType != "Z" && CamType != "FX" && CamType != "A2" && CamType != "Z3" )
		  Response.Write('<tr><td>Laser time (hrs)</td><td>' + laserTime + '</td></tr>');

		Response.Write('<tr><td>Max. operating temperature (&deg;C)</td><td>' + maxOpTemp.toPrecision(4) + '</td></tr>');
	        year = maxDate.getFullYear();
	        month = new String( maxDate.getMonth() + 1 );
	        if( month.length < 2 )
	          month = "0" + month;

	        day = new String( maxDate.getDate() );
	        if( day.length < 2 )
	          day = "0" + day;

	        hour = new String( maxDate.getHours() );
	        if( hour.length < 2 )
	          hour = "0" + hour;

	        min = new String( maxDate.getMinutes() );
	        if( min.length < 2 )
	          min = "0" + min;

	        sec = new String( maxDate.getSeconds() );
	        if( sec.length < 2 )
	          sec = "0" + sec;

		Response.Write('<tr><td>Max. operating temperature time</td><td>' + year + '-' + month + '-' + day + ' ' + hour + ':' + min + ':' + sec + '</td></tr>');
		Response.Write('<tr><td>Min. operating temperature (&deg;C)</td><td>' + minOpTemp.toPrecision(4) + '</td></tr>');
	        year = minDate.getFullYear();
	        month = new String( minDate.getMonth() + 1 );
	        if( month.length < 2 )
	          month = "0" + month;

	        day = new String( minDate.getDate() );
	        if( day.length < 2 )
	          day = "0" + day;

	        hour = new String( minDate.getHours() );
	        if( hour.length < 2 )
	          hour = "0" + hour;

	        min = new String( minDate.getMinutes() );
	        if( min.length < 2 )
	          min = "0" + min;

	        sec = new String( minDate.getSeconds() );
	        if( sec.length < 2 )
	          sec = "0" + sec;

		Response.Write('<tr><td>Min. operating temperature time</td><td>' + year + '-' + month + '-' + day + ' ' + hour + ':' + min + ':' + sec + '</td></tr>');
		Response.Write('<tr><td>Operating time (hrs)</td><td>' + operatingTime + '</td></tr>');
		Response.Write('<tr><td>Up-time (hrs)</td><td>' + upTime + '</td></tr>');
	}

  var strTitle = CamFamily + " System Information";
%>
<html>
	<head>
    <title><%Response.Write(strTitle)%></title>
		<link href="/styles/flirweb.css" type="text/css" rel="stylesheet">
	</head>
	<body>
		<%  
      printStandardDecoration( strTitle );
			printUserNavigation("mnuUserSysInfo");
		%>
		<div id="mainpane">
            <div id="content">
				<table class="compact" ID="Table1">
					<caption>Camera</caption>
					<tr class="caption">
						<td>Name</td>
						<td>Part #</td>
						<td>Serial #</td>
						<td>Date</td>
					</tr>
					<tr>
						<td><% Response.Write(restree.getResourceValue("version.product.name")); %></td>
						<td><% Response.Write(restree.getResourceValue("version.product.article")); %></td>
						<td><% Response.Write(restree.getResourceValue("version.product.serial")); %></td>
						<td><% Response.Write(restree.getResourceValue("version.product.date")); %></td>
					</tr>
				</table>
				</p>
				<table class="compact" ID="Table3">
					<caption>Kits</caption>
					<tr class="caption">
						<td>Name</td>
						<td>Version</td>
						<td>Date</td>
					</tr>
					<%printKitVersions();%>
				</table>
				</p>
				<table class="compact" ID="Table7">
					<caption>Calibration</caption>
					<tr class="caption">
						<td>Name</td>
						<td>Date</td>
					</tr>
					<tr>
					    <%restree.path = "calib.general";%>
						<td><%Response.Write(restree.getResourceValue("calibStage"))%></td>
						<td><%Response.Write(restree.getResourceValue("date"))%></td>
					</tr>
				</table>
				</p>
				<table class="compact" ID="Table2">
					<caption>Hardware</caption>
					<tr class="caption">
						<td>Name</td>
						<td>Part #</td>
						<td>Revision #</td>
						<td>Serial #</td>
					</tr>
					<%printHWVersions();%>
				</table>
				</p>
				<table class="compact" ID="Table5">
					<caption>Firmware</caption>
					<tr class="caption">
						<td>Name</td>
						<td>Version</td>
						<td>Date</td>
						<td>From</td>
					</tr>
					<%printSWVersions("version.fw");%>
				</table>
				</p>				
				<table class="compact" ID="Table4">
					<caption>Software</caption>
					<tr class="caption">
						<td>Name</td>
						<td>Version</td>
						<td>Date</td>
						<td>From</td>
					</tr>
					<%printSWVersions("version.sw");%>
				</table>
				</p>
				<table class="compact" ID="Table6">
					<caption>Usage Statistics</caption>
					<%printStats();%>
				</table>
			</div>
			<%printStandardFooter();%>
		</div>
	</body>
</html>
