<%

function printStandardDecoration( pageName )
{
	Response.Write('<div id="logo"><img height="60" src="/images/flirtrans.gif" width="180"></div>');
	Response.Write('<div id="title"><h1>');
	Response.Write( pageName );
	Response.Write('</h1></div>');
}
function printStandardFooter()
{
	restree.path ="";
	var strSerial = restree.getResourceValue("version.product.serial");
	if ( strSerial == "*" )
		strSerial = restree.getResourceValue("version.hw.camcore.serial");
		
	Response.Write('<div id="contentfooter">' + restree.getResourceValue("version.product.name") + ', S/N:'  + strSerial + '</div>');
}

function menuRow(menuText, menuHref, menuType, menuSelected)
{
	menuStr = '<li class="' + menuType +'"';
	if (menuSelected)
	{
		menuStr += ' id="mnuSelected"';
	}
	menuStr+= '><a href="' + menuHref + '">' + menuText +'</a></li>';
	Response.Write(menuStr);
}

/* Input support functions */
function toDecPoint( inStr )
{
    var str = new String(inStr);
    var index = str.indexOf(",");
    
    if (index != -1)
        str = str.substring(0,index) + "." + str.substring(index+1);

    return str;
}

/* Output support functions */
function preZero(Z,S) 
{ 
  var str = new String(S); 
  
  while (str.length<Z) 
    str = '0' + str ; 
    
  return str;
}



//
// Simple jscript class for select tags.
//
//  The following jscript statements will create a select tag
//  "nLines" high. ( nLines = 1 for a drop down selector ).
//  The selector contains 3 options with the second option
//  preselected.
//
//      var aTag = new SelectTag( "test", nLines );  // Create.
//      aTag.option( "Value1", "Descr1", false );    // Add options.
//      aTag.option( "Value2", "Descr2", true );     // Preselected option.
//      aTag.option( "Value3", "Descr3", false );
//      aTag.print();                                // Dump to html page.
//
//  The created tag should look something like this :
//
//      <select name="test" size="1">
//        <option value="Value1">Descr1</option>
//        <option value="Value2" selected>Descr2</option>
//        <option value="Value3">Descr3</option>
//      </select>
//
function SelectTag( name, size, extra ) {
    this.name = name;
    this.size = size;
    this.extra = extra;
    this.options = "";
    this.noptions = 0;
}

SelectTag.prototype.option = function( value, descr, selected ) {
    this.options += '  <option value="';
    this.options += value;
    this.options += '"';
    if( selected ) {
        this.options += ' selected';
    }
    this.options += '>';
    this.options += descr;
    this.options += '</option>\n';
    this.noptions++;
}

SelectTag.prototype.print = function() {
    if( this.noptions > 0 ) {             // Skip if no options defined.
        var selectTag = '<select ' +this.extra+ ' name="' + this.name;
        if ( this.size >= 0 ) {
          if ( this.size == 0 )
             this.size = this.noptions;
          selectTag += '" size="' + this.size;
        }
        selectTag += '">\n';
        Response.Write( selectTag );
        Response.Write( this.options );
        Response.Write( "</select>\n" );
    }
}


%>
