<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/resTree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/inc/usermenu.inc" -->
<%
	var RtpUrl = 'rtsp://' + Request.ServerVariables("SERVER_NAME");
	var MovUrl = 'http://' + Request.ServerVariables("SERVER_NAME") + '/black-240x320.mov';
	var size = 1;
	var SizeX = 240;
	var SizeY = 320;  
	size = Request.QueryString( "imgsize" );
	if( size == "" )
		size = 1;
	if( Request.Form.Count > 0 ) {
	
	    if( Request.Form( "mode" ) == "Smaller" ) {
		sz = new Number( Request.Form( "imgsize" ) );
		sz -= 0.5;
		if( sz < 1.1 )
			sz = 1;

		size = sz;
		}
		else if( Request.Form( "mode" ) == "Larger" ) {
		sz = new Number( Request.Form( "imgsize" ) );
		sz += 0.5;
		if( sz > 2.9 )
			sz = 3;

		size = sz;
		}

	}
	SizeX = SizeX * size;
	SizeY = SizeY * size + 16;

  var strTitle = CamFamily + " Real Time Video";
%>
<html>
	<head>
		<script language="Javascript"> 
			var haveqt = false; 
		</script> 
		<script language="VBScript"> 
			On Error Resume Next 
			Set theObject = CreateObject("QuickTimeCheckObject.QuickTimeCheck.1") 
			On Error goto 0 
			If IsObject(theObject) Then 
				If theObject.IsQuickTimeAvailable(0) Then 
					haveqt = true 
				End If 
			End If 
		</script> 
		<script language="Javascript"> 
			if (navigator.plugins) { 
				for (i=0; i < navigator.plugins.length; i++ ) { 
					if (navigator.plugins[i].name.indexOf("QuickTime") >= 0) 
					{ 
						haveqt = true; 
					} 
				} 
			} 
			  
			if ((navigator.appVersion.indexOf("Mac") > 0) 
			&& (navigator.appName.substring(0,9) == "Microsoft") 
			&& (parseInt(navigator.appVersion) < 5) ) 
			{ haveqt = true; } 
		</script> 

    <title><%Response.Write(strTitle)%></title>
		<link href="/styles/flirweb.css" type="text/css" rel="stylesheet">
	</head>
	<body>
		<% printStandardDecoration(strTitle); %>
    <% printUserNavigation("mnuUserRTPCam");%>
		<div id="mainpane">
            <div id="content" align="center">
            
				<script language="Javascript"> 
					if (!haveqt)
					{
						document.write('<span class="attention">You need <a href=http://www.apple.com target="_blank">Apple QuickTime&trade; PlugIn</a> to view this page!');
					}
				</script> 
				<table class = "webcam">
					<tr>
						<td>
							<object classid="clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B" codebase="http://www.apple.com/qtactivex/qtplugin.cab" height="<%Response.Write(SizeY);%>" width="<%Response.Write(SizeX);%>" ID="Qtactivexplugin1" VIEWASTEXT>
								<param name="qtsrc" value="<%Response.Write(RtpUrl);%>">
								<param name="autoplay" value="True">			
								<param name="scale" value="Aspect">			
								<param name="controller" value="True">			
								<embed src="<%Response.Write(MovUrl);%>" type="video/quicktime" pluginspage="http://www.apple.com/quicktime/download/" height="<%Response.Write(SizeY);%>" width="<%Response.Write(SizeX);%>" autohref="true" 
									href="<<%Response.Write(RtpUrl);%>> T<myself> E<autoplay=true scale=Aspect controller=false height=<%Response.Write(SizeY);%> width=<%Response.Write(SizeX);%>>"
									autoplay="True" scale="Aspect" controller="True" target="Myself"/>
							</object>
						</td>
						<td class = "webcamControls">
							<form action="rtp.asp" method="POST" >
								<input type="hidden" name="imgsize" value="<%Response.Write( size );%>">
								<table class="webcam">
									<tr>
										<td>
											<input type="submit" name="mode" value="Smaller" <%if( size == "1" ) Response.Write( "disabled" ); %>>
										</td>
										<td>
											<input type="submit" name="mode" value="Larger" <%if( size == "3" ) Response.Write( "disabled" ); %>>
										</td>
									</tr>
								</table>
							</form>
						</td>
					</tr>
				</table>
			</div>
			<%printStandardFooter();%>
		</div>
	</body>
</html>
