<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<% var strTitle = "Accuracy Measurement"; %>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    </head>
    <body id="pgCalibAccMeas">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuCalib", "mnuCalibAccMeas" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <h2>Instruction</h2>
                <P>The following pages enable you to measure the accuracy of the camera.</P>
                <P>Start by setting the distance to the target in the <b>Set Object Parameters</b> page.</P>
                <P>Select one or more cases in the <b>Select Cases</b> page.
                   You cannot select cases that are being recalibrated at the same time. </P>
                <P>Measure the camera accuracy at the temperatures suggested by the camera,
                   or at other temperatures using the <b>Measure Temperature</b> page.</P>
<% if( CamType == "Z" || CamType == "Z3" ) Response.Write( "<!--\n" ); %>
                <P>The camera will tell you when to use a collimator or calibration adapter and
                   automatically adjust the object parameters for this.</P>
<% if( CamType == "Z" || CamType == "Z3" ) Response.Write( "-->\n" ); %>
                <P>Correct the suggested emissivity if needed.</P>
                <P>New measurements will replace old ones for (approximately) the same temperature. 
                   To remove a particular measurement, use the <b>Remove Temperature</b> page.</p>
                <P>The measurement protocol can be examined during the measurements and
                   afterwards using the <b>Show Acc Protocol</b> page. It can be permanently saved 
                   with a button on the <b>Measure Temperature</b> page.</P>
            </div>
	    <%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
