<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/serviceutils.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<%
  /* Create proper working conditions in the camera  */

  var bAppStarted = isAppStarted("prodapp", "prod.syscalib.ecode");
  var bEnabled = bAppStarted;
	var strDisabled = "disabled ";
  var strStateName;
  var nEcode = -1;
  
  if (bAppStarted)
  {
    strStateName = restree.getResourceValue("prod.syscalib.accStateName");
    if ( strStateName == "Idle" )
    {
      restree.setResourceValue("prod.syscalib.command", "accInit");
      bEnabled = waitWhileBusy("prod.syscalib.status");
    }
    nEcode = restree.getResourceValue("prod.syscalib.ecode");
  }
	if ( bEnabled ) 
	  strDisabled = "";

  /* Dummy initiations of our form content variables  */
  
	var BBSelector = new SelectTag("BBList", 0,strDisabled);
	var strEmiss = "";
	var strTrueT = "";
	var strUseAnyCheck = "";
	var strCaseList = "<br>";
    
  if (bEnabled)
  {
    /* Check that we have a legal strAccStateName  */
    
    /* Go through the submitted form , if it is our own one. */
    
    if ( Request.Form.Count > 0 ) 
    {
      if (Request.Form ( "SubmitSave" ) != "" )
      {
	      restree.setResourceValue("prod.syscalib.command", "accSave");

	      if ( !waitWhileBusy("prod.syscalib.status") )
	        nEcode = -1;
	      else
	      {
          nEcode = restree.getResourceValue("prod.syscalib.ecode");
	      }
	    }
      else if (Request.Form ( "SubmitNuc" ) != "" )
      {
	      restree.setResourceValue("image.services.nuc.commit", true);
	    }
      else if (Request.Form ( "SubmitAccMeasBB" ) != "" )
      {
        // Ignore the BBlist selection
	      strEmiss = toDecPoint(Request.Form("emiss"));
	      if (strEmiss != "")
	        restree.setResourceValue("prod.syscalib.cmdargAccMeas.newEmiss", 1.0*strEmiss);
	      strTrueT = toDecPoint(Request.Form("truet"));
	      restree.setResourceValue("prod.syscalib.cmdargAccMeas.BBtemp", 1.0*strTrueT+273.15);
	      if ( Request.Form("useany")!="" )
	        restree.setResourceValue("prod.syscalib.cmdargAccMeas.useAnyTemp", true);
	      else
	        restree.setResourceValue("prod.syscalib.cmdargAccMeas.useAnyTemp", false);
	      restree.setResourceValue("prod.syscalib.cmdargAccMeas.remove", false);
  	    
	      restree.setResourceValue("prod.syscalib.command", "accMeas");

	      if ( !waitWhileBusy("prod.syscalib.status") )
	        nEcode = -1;
	      else
	      {
          nEcode = restree.getResourceValue("prod.syscalib.ecode");
	      }
	    }
    }

    /* OK/Error in submitted form, or no submitted form. */
    /* We are about to show our own form now. Fetch proper data for it */

	  strTrueT = 1.0*restree.getResourceValue("prod.syscalib.cmdargAccMeas.BBtemp")-273.15;
	  strEmiss = restree.getResourceValue("prod.syscalib.cmdargAccMeas.newEmiss")*1.0;
	  if ( restree.getResourceValue("prod.syscalib.cmdargAccMeas.useAnyTemp") )
	    strUseAnyCheck = "checked ";

	  var strBBnames = restree.getResourceValue("prod.syscalib.cmdargAccMeas.selBBnames");
	  if ( strBBnames == "" )
	  {
	    BBSelector.option( "None", "None", false);
	    strTrueT = -273.15;
	  }
	  else
	  {
	    var arrBBnames = strBBnames.split("\t");
	    var j = 0;
  	  
	    while ( j < arrBBnames.length )
	    {
	      BBSelector.option( arrBBnames[j], arrBBnames[j], j==0);
	      j++;
	    }
	  }

		var strCaseID = "";
		var strCaseDescr = "";
  	
		var strCurrentCaseIDs = restree.getResourceValue("prod.syscalib.accCaseID");
		
		restree.path = "calib.ccase";
		var CCaseItem = restree.getFirst();
  	
		while (CCaseItem != "")
		{
		  strCaseDescr = restree.getResourceValue(CCaseItem + ".descr");
		  strCaseID = restree.getResourceValue(CCaseItem + ".ID");
		  
		  if (splitSearch(strCurrentCaseIDs, strCaseID) >= 0)
		    strCaseList += strCaseDescr + "<br>";
		    
			CCaseItem = restree.getNext();
		}
		restree.path = "";

  }
  var strTitle = "Measure Temperature";
%>

<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
  <!--- Browser scripts --->
        <SCRIPT>
            function setfocus()
            {
                document.measureBB.truet.focus();
            }
        </SCRIPT>
  <!--- End of browser scripts --->
    </head>
    <body id="pgCalibAccMeasMeasure" onLoad="setfocus()"  >
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuCalib", "mnuCalibAccMeasMeasure" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE ID="Table1">
                <TR>
                    <TD VALIGN="TOP" colspan=2>
                    <%
                      if ( bEnabled == false )
                          Response.Write("<span id=errstatus> Production Application not available! </span>");
                        else if ( nEcode == 0 )
                            Response.Write("<span id=OKstatus> Please aim and focus well before you measure!</span>");
                        else
                            Response.Write("<span id=errstatus>" + ecodeString(nEcode) + "</span>");
                    %>
                    <br><br>
                    <%
                       // We can't use the current lens here, due to the possiblity of a lens change
                       var strLensID   = restree.getResourceValue("prod.syscalib.cmdargAccMeas.accLensID");
                       if ( strLensID != "" && CamType != "X" && CamType != "X2" && CamType != "Z" && CamType != "Z3" )
                       {
                          var strLensPath = "calib.lens." + strLensID;
                          var strLensName = restree.getResourceValue(strLensPath + ".descr");
                          var strLensSerial = restree.getResourceValue(strLensPath + ".SN");
                          var fCalibDistance = restree.getResourceValue(strLensPath + ".calib.distance");
                          var strAdapterName = restree.getResourceValue(strLensPath + ".calib.adapter");
                          var strMessage = "Use lens " + strLensName + " #" + strLensSerial;
                          if ( strAdapterName != "" )
                            strMessage += " with adapter " + strAdapterName;
                          if ( 1*fCalibDistance < 3 )
                             strMessage += " at " + fCalibDistance.toFixed(2) + " m";
                          else
                             strMessage += " and a collimator mirror";
                          strMessage += "<br><br>";
                          Response.Write(strMessage);
                       }
                       else if( CamType == "X" || CamType == "X2" || CamType == "Z" || CamType == "Z3" )
                       {
                          var fCalibDistance = restree.getResourceValue( "image.sysimg.basicImgData.objectParams.objectDistance" );
                          var strMessage = "Use distance " + fCalibDistance.toFixed(2) + " m<br><br>";
                          Response.Write(strMessage);
                       }
                    %>
                    </td>
                </TR>
                <TR>
                    <TD VALIGN="TOP">
                    Selected case(s):<br>
                    <%Response.Write( strCaseList );%>
                    <FORM ACTION="#" METHOD="post" NAME=measureBB ID="Form1">
                        Blackbody<br>
                        <% BBSelector.print(); %>
                        <BR>
                        <BR>
                        <input TYPE="checkbox" id="Checkbox1" name="useany" <% Response.Write(strUseAnyCheck); if ( !bEnabled ) Response.Write("disabled");%>>&nbsp;Allow other temperatures<br>
                        <BR>
                        True temperature [&deg;C]&nbsp;&nbsp;&nbsp;<BR>
                        <INPUT TYPE="text" NAME="truet" MAXLENGTH="8" VALUE="<%if (strTrueT > -200.0) Response.Write(strTrueT.toFixed(2));%>"  <%if ( !bEnabled ) Response.Write("disabled");%> ID="Text2"><BR>
                        <BR>
                        Emissivity<BR>
                        <INPUT TYPE="text" NAME="emiss" MAXLENGTH="8" VALUE="<%if (strEmiss > 0.001) Response.Write(strEmiss.toFixed(3));%>"  <%if ( !bEnabled ) Response.Write("disabled");%> ID="Text3"><BR>
                        <BR>
                        <BR>
                        <INPUT TYPE="submit" VALUE="Measure now" ID="Submit4" NAME="SubmitAccMeasBB" <%if ( !bEnabled ) Response.Write("disabled")%>>
                    </FORM>
                    <FORM ACTION="#" METHOD="post" NAME=extra ID="Form2">
                        <INPUT TYPE="submit" VALUE="Save Measurements" ID="Submit6" NAME="SubmitSave" <%if ( !bEnabled ) Response.Write("disabled")%>>&nbsp;&nbsp;  
                        <INPUT TYPE="submit" VALUE="Nuc Camera" ID="Submit5" NAME="SubmitNuc" <%if ( !bEnabled ) Response.Write("disabled")%>>
                      </FORM>
                    <br><br>
                    </TD>
                </TR>
                </TABLE>
            </div>
			<%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
