<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/serviceutils.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<%
  /* Create proper working conditions in the camera  */

  var bAppStarted = isAppStarted("prodapp", "prod.syscalib.ecode");
  var bEnabled = bAppStarted;
	var strDisabled = "disabled ";
  var strStateName;
  var nEcode = -1;
  
  if (bAppStarted)
  {
    strStateName = restree.getResourceValue("prod.syscalib.accStateName");
    if ( strStateName == "Idle" )
    {
      restree.setResourceValue("prod.syscalib.command", "accInit");
      bEnabled = waitWhileBusy("prod.syscalib.status");
    }
    nEcode = restree.getResourceValue("prod.syscalib.ecode");
  }
	if ( bEnabled ) 
	  strDisabled = "";

  /* Dummy initiations of our form content variables  */
	var strCaseList = "<br>";
  
  if (bEnabled)
  {
    /* Check that we have a legal strAccStateName  */
    
    /* Go through the submitted form , if it is our own one. */
    
    if ( Request.Form.Count > 0 ) 
    {
      if (Request.Form ( "SubmitAccRemoveBB" ) != "" )
      {
	      var strRemoveT = toDecPoint(Request.Form("removet"));
	      restree.setResourceValue("prod.syscalib.cmdargAccMeas.BBtemp", 1.0*strRemoveT+273.15);
	      restree.setResourceValue("prod.syscalib.cmdargAccMeas.remove", true);
	      restree.setResourceValue("prod.syscalib.command", "accMeas");

	      if ( !waitWhileBusy("prod.syscalib.status") )
	        nEcode = -1;
	      else
	      {
          nEcode = restree.getResourceValue("prod.syscalib.ecode");
	      }
	    }
    }

    /* OK/Error in submitted form, or no submitted form. */
    /* We are about to show our own form now. Fetch proper data for it */
		var strCaseID = "";
		var strCaseDescr = "";
  	
		var strCurrentCaseIDs = restree.getResourceValue("prod.syscalib.accCaseID");
		
		restree.path = "calib.ccase";
		var CCaseItem = restree.getFirst();
  	
		while (CCaseItem != "")
		{
		  strCaseDescr = restree.getResourceValue(CCaseItem + ".descr");
		  strCaseID = restree.getResourceValue(CCaseItem + ".ID");
		  
		  if (strCurrentCaseIDs.search(strCaseID) >= 0)
		    strCaseList += strCaseDescr + "<br>";
		    
			CCaseItem = restree.getNext();
		}
		restree.path = "";

 }
 var strTitle = "Remove Temperature";
%>

<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
  <!--- Browser scripts --->
        <SCRIPT>
            function setfocus()
            {
                document.removeBB.removet.focus();
            }
        </SCRIPT>
  <!--- End of browser scripts --->
    </head>
    <body id="pgCalibAccMeasMeasure" onLoad="setfocus()"  >
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuCalib", "mnuCalibAccMeasRemove" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE ID="Table1">
                <TR>
                    <TD VALIGN="TOP" colspan=2>
                    <%
                      if ( bEnabled == false )
                          Response.Write("<span id=errstatus> Production Application not available! </span><br><br>");
                        else if ( nEcode != 0 )
                            Response.Write("<span id=errstatus>" + ecodeString(nEcode) + "</span><br><br>");
                    %>
                    </td>
                </TR>
                <TR>
                    <TD VALIGN="TOP" WIDTH="50%">
                    Selected case(s):<br>
                    <%Response.Write( strCaseList );%>
                    <FORM ACTION="#" METHOD="post" NAME=removeBB ID="Form3">
                        Temperature to remove [&deg;C]<BR>
                        <INPUT TYPE="text" NAME="removet" MAXLENGTH="8" VALUE=""  <%if ( !bEnabled ) Response.Write("disabled");%> ID="Text1"><BR>
                        <BR>
                        <INPUT TYPE="submit" VALUE="Remove" ID="Submit1" NAME="SubmitAccRemoveBB" <%if ( !bEnabled ) Response.Write("disabled")%>>
                      </FORM>
                    <br><br>
                    </TD>
                </TR>
                </TABLE>
            </div>
			    <%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
