<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<%  var strTitle = "System Recalibration"; %>

<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <link href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    </head>
    <body id="pgCalibSysCalib">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuCalib", "mnuCalibSysCalib" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <h2>Instruction</h2>
                <P>The following pages enable you to improve the accuracy of the camera by determining new RBF constants for each calibration case.</P>
<% if( CamType == "X" || CamType == "Z" || CamType == "Z3" ) Response.Write( "<!--\n" ); %>
                <P>First, make sure that all wanted cases are enabled in the <b>Enable/Disable Cases</b> page and
                   that the temperature limits are appropriate in the <b>Edit Case Limits</b> page.</P>
                <P>If you have more that one lense of the same kind, and want to calibrate them separately,
                   you have to <b>Add lens cases</b> for them. Otherwise they will share the same calibration.
<% if( CamType == "X" || CamType == "Z" || CamType == "Z3" ) Response.Write( "-->\n" ); %>
                <P>Start the recalibration by selecting one or more cases in the <b>Select Cases</b> page. 
                   This operation copies these cases, so you can work with them without affecting the current calibration.</P>
                <P>Measure the camera signal at the blackbody temperatures suggested by the camera using the <b>Measure Signal</b> page.</P>
<% if( CamType == "X" || CamType == "X2" || CamType == "Z" || CamType == "Z3" ) Response.Write( "<!--\n" ); %>
                <P>The camera will tell you when to use a collimator or calibration adapter and
                   automatically adjust the object parameters for this.</P>
<% if( CamType == "X" || CamType == "X2" || CamType == "Z" || CamType == "Z3" ) Response.Write( "-->\n" ); %>
                <p>If you've made a mistake, you can either correct it with the <b>Edit Measurements</b> page or
                   restart your calibration work from the <b>Select Cases</b> page.</p>
                <p>You can always temporarily save your recalibration work, and continue it later, using the <b>Activate or Save RBF</b> page.</p>
                <P>When the measurements are finished, you get the opportunity to calculate new RBF constants in the <b>Calculate RBF</b> page.</P>
                <P>The RBF curve adaptation protocol can be examined during the measurements (and afterwards) using the <b>Show Cal Protocol</b> page. </P>
                <P>To activate and store your work as a new calibration (or discard it), use the <b>Save or Activate RBF</b> page.</P>
                <P>The <b>Switch Calibration</b> page allows you to switch between your different stored calibrations.</P>
                <br>
                <br>
            </div>
			<%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
