<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/serviceutils.inc" -->
<%
  /* Create proper working conditions in the camera  */

  var bAppStarted = isAppStarted("prodapp", "prod.syscalib.ecode");
  var bEnabled = bAppStarted;
	var strDisabled = "disabled ";
  var strStateName;
  var strPrompt;
  var nEcode = -1;
  
  if (bAppStarted)
  {
    strStateName = restree.getResourceValue("prod.syscalib.stateName");
    if ( strStateName == "Idle" )
    {
      restree.setResourceValue("prod.syscalib.command", "init");
      bEnabled = waitWhileBusy("prod.syscalib.status");
    }
    strPrompt = restree.getResourceValue("prod.syscalib.prompt");
    nEcode = restree.getResourceValue("prod.syscalib.ecode");
  }
	if ( bEnabled ) 
	  strDisabled = "";

  /* Dummy initiations of our form content variables  */
  var VersionSelector = new SelectTag("VersList", 0, strDisabled);
	var strActivateCheck = "checked";
	var strSaveCheck = "";
	var strDiscardCheck = "";

  if (bEnabled)
  {
    /* Check that we have a legal strStateName  */
    
    if (strStateName == "Idle")
    {
      strStateName = "Select";
	    var strRedirectTo1 = "/service/calib/SysCalib" + strStateName + ".asp";
 	  
	    Response.Redirect(strRedirectTo1);
	    // This point should never be reached.....
	  }
	  else if (strStateName == "Empty")
	  {
	    Response.Redirect("/service/calib/SysCalib.asp");
	    // This point should never be reached.....
	  }
	  
    /* Go through the submitted form , if it is our own one. */
    if ( Request.Form.Count > 0 && Request.Form( "SubmitActivate" ) != "" ) 
    {
      restree.setResourceValue("prod.syscalib.version", Request.Form("VersList"));
	    restree.setResourceValue("prod.syscalib.command", Request.Form("action"));

	    if ( !waitWhileBusy("prod.syscalib.status") )
	      nEcode = -1;
	    else
	    {
        nEcode = restree.getResourceValue("prod.syscalib.ecode");
        strPrompt = restree.getResourceValue("prod.syscalib.prompt");
	    }
	    
	    if ( nEcode == 0 )
	    {
            /* Activate the first case again, if we have an InfraCAM */
            if ( CamType == "X" || CamType == "Z" || CamType == "Z3" )
		        restree.setResourceValue("calib.ccase.0.recalibSel", true);
            
            /* Submitted form OK, lets go to the next page. */
            strStateName = restree.getResourceValue("prod.syscalib.stateName");
	          var strRedirectTo2 = "/service/calib/SysCalib" + strStateName + ".asp";
            
            if (strStateName == "Idle")
              strRedirectTo2 = "/service/calib/SysCalib/Select.asp";
            else if (strStateName == "Empty" )
              strRedirectTo2 = "/service/calib/SysCalib.asp";
      	  
	          Response.Redirect(strRedirectTo2);
	          // This point should never be reached.....
	    }
    }
	  /* Error in submitted form, or no submitted form */
   

    /* We are about to show our own form now. Fetch proper data for it */
	  restree.setResourceValue("prod.syscalib.command", "getVersions");
	  waitWhileBusy("prod.syscalib.status");

	  var strNextVersion = restree.getResourceValue("prod.syscalib.cmdargAct.nextVersion");
	  VersionSelector.option( strNextVersion, strNextVersion, true);

	  var strVersions = restree.getResourceValue("prod.syscalib.cmdargAct.versions");
	  if ( strVersions != "" )
	  {
	    var arrVersions = strVersions.split("\t");
  	  
	    for ( var k = arrVersions.length-1; k >= 0; k-- )
	      VersionSelector.option( arrVersions[k], arrVersions[k], false);
	  }
  }
  var strTitle = "Save or Activate RBF";
%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
<!--- Browser scripts --->
            <script>
            function AreYouSure()
            {
              if(document.forms[0].action[0].checked)
              {
                  return confirm("Activating new calibration!!\n     Are you sure?");
              }
              else if(document.forms[0].action[2].checked)
              {
                  return confirm("Discarding present results!!\n     Are you sure?");
              }
              return true;
            }
            </script>
  <!--- End of browser scripts --->
    </head>
    <body id="pgCalibSysCalibActivate">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuCalib", "mnuCalibSysCalibActivate" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE id="Table1">
                    <TR>
                        <TD vAlign="top" colSpan="2">
                        <%
                          if ( bEnabled == false )
                              Response.Write("<span id=errstatus> Production Application not available! </span>");
                          else if ( nEcode == 0 )
                              Response.Write("<span id=OKstatus> Please check that all results are OK before you activate the calibration. </span>");
                          else
                              Response.Write("<span id=errstatus>" + strPrompt + "</span>");
                        %>
                        </TD>
                    </TR>
                    <TR>
                        <TD vAlign="top" width="250">
                            <FORM id="Form1" name="activeaction" action="#" method="post" onSubmit="return AreYouSure();">
                                Version<br>
                                <%VersionSelector.print();%><br>
                                <BR>
                                <BR>
                                <P>Action</P>
                                &nbsp;&nbsp;<INPUT id="Radio1" type="radio" value="actiSave" name="action" <% Response.Write(strActivateCheck);  if ( !bEnabled ) Response.Write("disabled");%>></INPUT>&nbsp;&nbsp;Activate 
                                current results
                                <BR>
                                &nbsp;&nbsp;<INPUT id="Radio2" type="radio" value="save" name="action" <% Response.Write(strSaveCheck);  if ( !bEnabled ) Response.Write("disabled");%>></INPUT>&nbsp;&nbsp;Save 
                                results temporarily
                                <BR>
                                &nbsp;&nbsp;<INPUT id="Radio3" type="radio" value="discard" name="action" <% Response.Write(strDiscardCheck);  if ( !bEnabled ) Response.Write("disabled");%>></INPUT>&nbsp;&nbsp;Discard 
                                current results
                                <BR>
                                <br>
                                <INPUT id="Button1" type="submit" value="Start" name="SubmitActivate" <%if ( !bEnabled ) Response.Write("disabled");%>></INPUT>
                            </FORM>
                            Temporarily saved results will be retrieved the next time you recalibrate the 
                            camera.
                        </TD>
                        <TD vAlign="top">
                            <% PrintCalibStatusInfo(true, false); %>
                        </TD>
                    </TR>
                </TABLE>
            </div>
			<%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
