<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/serviceutils.inc" -->
<%
  /* Create proper working conditions in the camera  */

  var bAppStarted = isAppStarted("prodapp", "prod.syscalib.ecode");
  var bEnabled = bAppStarted;
	var strDisabled = "disabled ";
  var strStateName;
  var strPrompt;
  var nEcode = -1;
  
  if (bAppStarted)
  {
    strStateName = restree.getResourceValue("prod.syscalib.stateName");
    if ( strStateName == "Idle" )
    {
      restree.setResourceValue("prod.syscalib.command", "init");
      bEnabled = waitWhileBusy("prod.syscalib.status");
    }
    strPrompt = restree.getResourceValue("prod.syscalib.prompt");
    nEcode = restree.getResourceValue("prod.syscalib.ecode");
  }
	if ( bEnabled ) 
	  strDisabled = "";

  /* Dummy initiations of our form content variables  */
	var CCaseSelector = new SelectTag("caseList", 0, "multiple " + strDisabled);
	var strCCaseID = "";
	var strModeCalcCheck = "";
	var strModeRetrCheck = "";
	var fLockedB = 0.0;
	var strLockBCheck = "";
	var fLockedF = 0.0;
	var strLockFCheck = "";
	var strLockOffsetCheck = "";
	var strExtraAmbCheck = "";
	var strLensTypeRBF = "";
	var strBMin = "";
	var strBMax = "";
	var strBSpan = "0";
  var options = 0;
	
  if (bEnabled)
  {
    /* Check that we have a legal strStateName  */
    
    if (strStateName != "Calculate")
    {
      if (strStateName == "Empty" || strStateName == "Idle")
         strStateName = "Select";
         
	    var strRedirectTo1 = "/service/calib/SysCalib" + strStateName + ".asp";
  	  
	    Response.Redirect(strRedirectTo1);
	    // This point should never be reached.....
	  }
	  
    /* Go through the submitted form , if it is our own one. */
    
    if ( Request.Form.Count > 0 && Request.Form( "SubmitCalcRBF" ) != "" ) 
    {
	    strCCaseID = Request.Form("caseList");
	    restree.setResourceValue("prod.syscalib.caseID", convFromSelSepToTab(strCCaseID));
	    
	    var strLockedB = Request.Form("lockedB");
	    if ( strLockedB != "" )
	    {
        fLockedB = 1.0*toDecPoint(strLockedB);
	      restree.setResourceValue("prod.syscalib.cmdargCalc.lockedB", fLockedB);
        if ( Request.Form("lockB") != "" )
          options += 1;
      }
      
      var strLockedF = Request.Form("lockedF");
      if (strLockedF != "" )
      {
        fLockedF = 1.0*toDecPoint(strLockedF);
	      restree.setResourceValue("prod.syscalib.cmdargCalc.lockedF", fLockedF);
        if ( Request.Form("lockF") != "" )
          options += 2;
      }
        
      if ( Request.Form("lockOffs") != "" )
        options += 4;

      if ( Request.Form("xAmb") != "" )
        options += 8;

      if ( Request.Form("lensTypeRBF") != "" )
        options += 16;

	    restree.setResourceValue("prod.syscalib.cmdargCalc.options", options);
	    restree.setResourceValue("prod.syscalib.command", Request.Form("mode"));

	    if ( !waitWhileBusy("prod.syscalib.status") )
	      nEcode = -1;
	    else
	    {
        nEcode = restree.getResourceValue("prod.syscalib.ecode");
        strPrompt = restree.getResourceValue("prod.syscalib.prompt");
	    }
	    
	    if ( nEcode == 0 )
	    {
        /* Submitted form OK, lets go to the next page. */
        
        strStateName = restree.getResourceValue("prod.syscalib.stateName");
        
        if (strStateName == "Empty" || strStateName == "Idle")
          strStateName = "Select";
           
	      var strRedirectTo2 = "/service/calib/SysCalib" + strStateName + ".asp";
  	  
	      Response.Redirect(strRedirectTo2);
	      // This point should never be reached.....
	    }
    }
	  
    /* Error in submitted form, or no submitted form. */
    /* We are about to show our own form now. Fetch proper data for it */

		var strCaseDescr = "";
		var strCaseID = "";
		var bCaseSelected = false;
		var bCaseEnabled = false;
		var strFlagsResName = "";
		var nFlags = 0;
		var strRvalResName = "";
		var fRval = 1.0;
		var strRBFInfo = "";
		var strCurrentSel = restree.getResourceValue("prod.syscalib.caseID");
		var nSelCount = 0;

		restree.path = "calib.ccase";
	  var restreeRBFCache = new ResTree();
		restreeRBFCache.path = "calib.extRBFCalc.recalData.RBFCache";
		
		var CCaseItem = restree.getFirst();
  	
		while (CCaseItem != "")
		{
		  strCaseDescr = restree.getResourceValue(CCaseItem + ".descr");
		  strCaseID = restree.getResourceValue(CCaseItem + ".ID");
		  bCaseSelected = restree.getResourceValue(CCaseItem + ".recalibSel");
		  if (bCaseSelected)
		  {
		    bCaseEnabled = restree.getResourceValue(CCaseItem + ".enabled");
		    if ( bCaseEnabled )
		    {
		      strFlagsResName = strCaseID + ".RBFflags";
		      strRvalResName = strCaseID + ".R";
		      if ( restreeRBFCache.valueType(strFlagsResName) != "N/A" )
		      {
		        nFlags = restreeRBFCache.getResourceValue(strFlagsResName);
		        fRval = restreeRBFCache.getResourceValue(strRvalResName)
		      }
		      else
		        nFlags = -1;
  		      
		      strRBFInfo = evalRBFFlags(fRval,nFlags);
		    }
		    else
		        strRBFInfo = "(Disabled)";
		        
		    bCaseSelected = false;
		    if (splitSearch(strCurrentSel, strCaseID) >= 0)
		    {
		       bCaseSelected = true;
		       nSelCount++;
		    }
  		         		
		    CCaseSelector.option( strCaseID, strCaseDescr + " " + strRBFInfo, bCaseSelected );
		  }
			CCaseItem = restree.getNext();
		}
		restree.path = "";
		
		
    strModeCalcCheck = "checked";
    strModeRetrCheck = "";

		if ( nEcode == 0 && nSelCount == 1)
		{
		  if ( Request.Form("mode") != "retrRBFcond")
		  {
	      restree.setResourceValue("prod.syscalib.command", "retrRBFcond");
	      waitWhileBusy("prod.syscalib.status");
	    }
    
      options = restree.getResourceValue("prod.syscalib.cmdargCalc.options");
      if ( (options & 1) != 0 )
        strLockBCheck = "checked";
         
      fLockedB =restree.getResourceValue("prod.syscalib.cmdargCalc.lockedB");
      
      if ( (options & 2) != 0 )
        strLockFCheck = "checked";
      
      fLockedF =restree.getResourceValue("prod.syscalib.cmdargCalc.lockedF");

      if ( (options & 4) != 0 )
        strLockOffsetCheck = "checked";
      
      if ( (options & 8) != 0 )
        strExtraAmbCheck = "checked";
        
    if ( (options & 16) != 0 )
        strLensTypeRBF = "checked";

      strBMin = restree.getResourceValue("prod.syscalib.cmdargCalc.BMin");
      strBMax = restree.getResourceValue("prod.syscalib.cmdargCalc.BMax");
      strBMin = strBMin.toFixed(1);
      strBMax = strBMax.toFixed(1);
      strBSpan = (1*strBMax - 1*strBMin)/2;
      strBSpan = strBSpan.toFixed(1);
   }
}
var strTitle = "Calculate RBF";
  
%>
<html>
    <head>
          <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
  <!--- Browser scripts --->
      <script>
          function setfocus()
          {
              document.calcRBF.lockedB.focus();
          }
      </script>
  <!--- End of browser scripts --->
    </head>
    <body id="pgCalibSysCalibCalculate" onLoad="setfocus()">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuCalib", "mnuCalibSysCalibCalculate" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE id="Table1">
                    <TR>
                        <TD vAlign="top" colSpan="2">
                        <%
                          if ( bEnabled == false )
                              Response.Write("<span id=errstatus> Production Application not available! </span>");
                          else if ( nEcode == 0 )
                              Response.Write("<span id=OKstatus> Normally, just press Enter to start the calculation </span>");
                          else
                              Response.Write("<span id=errstatus>" + strPrompt + "</span>");
                        %>
                        </TD>
                    </TR>
                    <TR>
                        <TD vAlign="top" width="350em">
                            <FORM id="Form1" name="calcRBF" action="#" method="post">
                                <P>Calculation of</P>
                                &nbsp;&nbsp; <%CCaseSelector.print();%><br>
                                <BR>
                                &nbsp;&nbsp;<INPUT id="Radio1" type="radio" value="calcRBF" name="mode" <% Response.Write(strModeCalcCheck); if ( !bEnabled ) Response.Write("disabled");%>></INPUT>&nbsp;&nbsp;Calculate 
                                RBF
                                <BR>
                                &nbsp;&nbsp;<INPUT id="Radio5" type="radio" value="retrRBFcond" name="mode" <% Response.Write(strModeRetrCheck); if ( !bEnabled ) Response.Write("disabled");%>></INPUT>&nbsp;&nbsp;Retrieve 
                                conditions
                                <BR>
                                <BR>
                                <P>Calculation conditions <STRONG>for single cases</STRONG></P>
                                <P>&nbsp;&nbsp;BMin: <% Response.Write(strBMin);%>&nbsp; BMax: <% Response.Write(strBMax);%></P>
                                <P>&nbsp;&nbsp;<INPUT id="Checkbox1" type="checkbox" name="lockB" <% Response.Write(strLockBCheck); if ( !(bEnabled && nSelCount == 1)) Response.Write(" disabled");%>>&nbsp;Lock B 
                                    ( <% Response.Write(strBSpan);%>) &nbsp;<INPUT id="Text1" type="text" size="8" name="lockedB" value="<% Response.Write(fLockedB.toFixed(1)); %>" <%if ( !(bEnabled) ) Response.Write(" disabled");%>></P>
                                <P>&nbsp;&nbsp;<INPUT id="Checkbox2" type="checkbox" name="lockF" <% Response.Write(strLockFCheck); if ( !(bEnabled && nSelCount == 1) ) Response.Write(" disabled");%>>&nbsp;Lock&nbsp;F&nbsp;&nbsp;
                                                  <INPUT id="Text2" type="text" size="5" name="lockedF" value="<% Response.Write(fLockedF.toFixed(2)); %>" <%if ( !(bEnabled && nSelCount == 1) ) Response.Write(" disabled");%>></P>
                                <P>&nbsp;&nbsp;<INPUT id="Checkbox3" type="checkbox" name="lockOffs" <% Response.Write(strLockOffsetCheck); if ( !(bEnabled && nSelCount == 1) ) Response.Write(" disabled");%>>&nbsp;Lock&nbsp;Offset&nbsp;(Use, if you unlock F)</P>
                                <P>&nbsp;&nbsp;<INPUT id="Checkbox4" type="checkbox" name="xAmb" <% Response.Write(strExtraAmbCheck); if ( !(bEnabled && nSelCount == 1) ) Response.Write(" disabled");%>>&nbsp;Extra 
                                    ambient point</P>
<% if( CamType == "X" || CamType == "Z" || CamType == "Z3" ) Response.Write( "<!--\n" ); %>
                                <P>&nbsp;&nbsp;<INPUT id="Checkbox5" type="checkbox" name="lensTypeRBF" <% Response.Write(strLensTypeRBF); if ( !(bEnabled && nSelCount == 1) ) Response.Write(" disabled"); %>>&nbsp;Apply to all lenses of this kind</p>
<% if( CamType == "X" || CamType == "Z" || CamType == "Z3" ) Response.Write( "-->\n" ); %>
                                <br>
                                <INPUT id="Button1" type="submit" value="Submit" name="SubmitCalcRBF"  <%if ( !bEnabled ) Response.Write("disabled");%>>
                            </FORM>
                        </TD>
                        <TD vAlign="top">
                            <% PrintCalibStatusInfo(false, true); %>
                        </TD>
                    </TR>
                </TABLE>
            </div>
			      <%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
