<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/serviceutils.inc" -->
<%

	function findLensItem( strLensID )
	{
		var lensItem = strLensID;
		var origPath = restree.path;
		restree.path = ".calib.lens";
		
		if ( restree.getResourceValue( lensItem + ".PN" ) == "FAILED" )
		{
		  lensItem = restree.getFirst();
  		
		  while (lensItem != "")
		  {
		    if ( lensItem.search(strLensID) >= 0 )
		    {
		      restree.path = origPath;
		      return ".calib.lens." + lensItem;
		    }
			  lensItem = restree.getNext();
		  }
		}
		if ( lensItem != "" )
		  lensItem = restree.path + "." + lensItem;

		restree.path = origPath;
		
		return lensItem;
  }


  /* Create proper working conditions in the camera  */
  var bAppStarted = isAppStarted("prodapp", "prod.syscalib.ecode");
  var bEnabled = bAppStarted;
	var strDisabled = "disabled ";
  var strStateName;
  var nEcode = -1;
  
  if (bAppStarted)
  {
    strStateName = restree.getResourceValue("prod.syscalib.accStateName");
    if ( strStateName == "Idle" )
    {
      restree.setResourceValue("prod.syscalib.command", "accInit");
      bEnabled = waitWhileBusy("prod.syscalib.status");
    }
    nEcode = restree.getResourceValue("prod.syscalib.ecode");
  }
	if ( bEnabled ) 
	  strDisabled = "";


  /* Dummy initiations of our form content variables  */
  
	var CCaseSelector = new SelectTag("caseList", 0, "multiple " + strDisabled);
	var strTemplate = "";
    
  if (bEnabled)
  {
    /* Check that we have a legal strStateName  */
    
    /* Go through the submitted form , if it is our own one. */
    
    if ( Request.Form.Count > 0 && Request.Form ( "SubmitEditLimits" ) != "" ) 
    {
	    var CCaseItem;
	    var DCaseItem;
      var restreeLens = new ResTree();
      var strCases = new String(Request.Form("caseList"));
      var arrCases = strCases.split(", ");
      var strTemp = new String;
      var strNewCaseDescr = new String;
      var strDescr = new String;
      var strCaseID = new String;
      var strLensDescr = new String;
      var strLensSNr = new String;
      var str;
      var fNewTemp;
      var fOldTemp;
      var fDiffTemp;
      var arrID;
      var j;
      var bChangeMade = false;
      
      strTemplate = String(Request.Form("Template")); // String() to be able to use replace below
     
      for( var i = 0; i < arrCases.length; i++ ) 
      {
        restree.path = arrCases[i];
        if ( restree.path != "" )  // Split generates at least one string
        {
          
          strTemp = toDecPoint(Request.Form("TMin"));
          if (strTemp != "")
          {
            fNewTemp = 1.0*strTemp + 273.15;
            fOldTemp = restree.getResourceValue("TMin");
            fDiffTemp = fNewTemp - fOldTemp;
            restree.setResourceValue("TMin", fNewTemp);
            
            fOldTemp = restree.getResourceValue("TMinWarn");
            fNewTemp = fOldTemp + fDiffTemp;
            restree.setResourceValue("TMinWarn", fNewTemp);
          
            fOldTemp = restree.getResourceValue("TMinClip");
            fNewTemp = fOldTemp + fDiffTemp;
            restree.setResourceValue("TMinClip", fNewTemp);

            fOldTemp = restree.getResourceValue("TBlue");
            fNewTemp = fOldTemp + fDiffTemp;
            if (fNewTemp > 0.15)
              restree.setResourceValue("TBlue", fNewTemp);
              
            bChangeMade = true;              
          }
          
          strTemp = toDecPoint(Request.Form("TMax"));
          if (strTemp != "")
          {
            fNewTemp = 1.0*strTemp + 273.15;
            fOldTemp = restree.getResourceValue("TMax");
            fDiffTemp = fNewTemp - fOldTemp;
            restree.setResourceValue("TMax", fNewTemp);
            
            fOldTemp = restree.getResourceValue("TMaxWarn");
            fNewTemp = fOldTemp + fDiffTemp;
            restree.setResourceValue("TMaxWarn", fNewTemp);
          
            fOldTemp = restree.getResourceValue("TMaxClip");
            fNewTemp = fOldTemp + fDiffTemp;
            restree.setResourceValue("TMaxClip", fNewTemp);

            fOldTemp = restree.getResourceValue("TRed");
            fNewTemp = fOldTemp + fDiffTemp;
            restree.setResourceValue("TRed", fNewTemp);

            bChangeMade = true;              
          }
          
          strTemp = toDecPoint(Request.Form("TMinCalib"));
          if (strTemp != "")
          {
            fNewTemp = 1.0*strTemp + 273.15;
            restree.setResourceValue("TMinCalib", fNewTemp);
            bChangeMade = true;              
          }

          strTemp = toDecPoint(Request.Form("TMaxCalib"));
          if (strTemp != "")
          {
            fNewTemp = 1.0*strTemp + 273.15;
            restree.setResourceValue("TMaxCalib", fNewTemp);
            bChangeMade = true;              
          }

          strNewCaseDescr = strTemplate;
          if (strNewCaseDescr != "")
          {
            strDescr = restree.getResourceValue("descr");
            strCaseID = restree.getResourceValue("ID");
            arrID = strCaseID.split("_");
            
            for (j = 0; j < arrID.length; j++)
            {
              str = arrID[j].substr(0,2); 
              if (  str == "le" || str == "%s" )
                break;
            }
            if ( j < arrID.length )
            {
              if (arrID[j] != "le%s" && arrID[j] != "%s")
              {
                var strLensItem = findLensItem(arrID[j]);
                if ( strLensItem != "" )
                {
                  strLensDescr = restreeLens.getResourceValue(strLensItem + ".descr");
                  strLensSNr = restreeLens.getResourceValue(strLensItem + ".SN");
                  
                  if ( strLensDescr == "" )
                  {
                     strLensDescr = arrID[j].substr(2); // chop of "le"
                     var nSNrStart = strLensDescr.indexOf("$");
                     if (nSNrStart >0)
                        strLensDescr = strLensDescr.substr(0,nSNrStart); // chop of "$SNr$"
                  }
                  
                  if ( strLensSNr != "" )
                  {
                    if ( arrID[j].search(strLensSNr) >= 0 )
                      strLensDescr += " #" + strLensSNr;
                  }
                }
                else
                  strLensDescr = "UNKNOWN";
              }
              else
                strLensDescr = "%s";
            }
            else
              strLensDescr = "UNKNOWN";
              
            strNewCaseDescr = strNewCaseDescr.replace("%lens%",strLensDescr);
            fNewTemp = restree.getResourceValue("TMin") - 273.15;
            strNewCaseDescr = strNewCaseDescr.replace("%tmin%",fNewTemp.toFixed(0));
            fNewTemp = restree.getResourceValue("TMax") - 273.15;
            strNewCaseDescr = strNewCaseDescr.replace("%tmax%",fNewTemp.toFixed(0));
            restree.setResourceValue("descr", strNewCaseDescr);
            bChangeMade = true;              
          }
        }
      }
		  restree.path = "";
		  
		  if (bChangeMade)
		  {
	      restree.setResourceValue("prod.syscalib.command", "accSave");  // Saves calib.rsc
	      waitWhileBusy("prod.syscalib.status");
	    }
    }

    /* We are about to show our own form now. Fetch proper data for it */
    
    if (strTemplate == "" )
    {
       if( CamType == "X" )
           strTemplate = "X-Cam %tmin%C - %tmax%C";
       else if( CamType == "Z" || CamType == "Z3" )
           strTemplate = "Z-Cam %tmin%C - %tmax%C";
       else
           strTemplate = "%lens%, %tmin%C - %tmax%C";
    }
	  
		var strCaseDescr = "";
		var strLimInfo = "";
		var strTMinInfo = "";
		var strTMaxInfo = "";
		var strTMinCalibInfo = "";
		var strTMaxCalibInfo = "";
		var bHighLight = false;
		
		if ( CamType == "X" || CamType == "Z" || CamType == "Z3" )
		   bHighLight = true;
  	
		restree.path = "calib.ccase";

		CCaseItem = restree.getFirst();
  	
		while (CCaseItem != "")
		{
		  strCaseDescr = restree.getResourceValue(CCaseItem + ".descr");
		  strTMinInfo = restree.getResourceValue(CCaseItem + ".TMin") -273.15;
		  strTMaxInfo = restree.getResourceValue(CCaseItem + ".TMax") -273.15;
		  strTMinCalibInfo = restree.getResourceValue(CCaseItem + ".TMinCalib") -273.15;
		  strTMaxCalibInfo = restree.getResourceValue(CCaseItem + ".TMaxCalib") -273.15;
		    
		  strLimInfo = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(" + strTMinInfo.toFixed(0) + "/" + strTMinCalibInfo.toFixed(0) + " to " + strTMaxInfo.toFixed(0) + "/" + strTMaxCalibInfo.toFixed(0) +")";
		         		
		  CCaseSelector.option( restree.path + "." + CCaseItem, strCaseDescr + ": " + strLimInfo, bHighLight );
  		  
			CCaseItem = restree.getNext();
		}

		restree.path = "calib.dcase";
		strLimInfo = "";

		DCaseItem = restree.getFirst();
  	
		while (DCaseItem != "")
		{
		  strCaseDescr = restree.getResourceValue(DCaseItem + ".descr");
		  strCaseDescr = strCaseDescr.replace("%s","DEFAULT");
		  strTMinInfo = restree.getResourceValue(DCaseItem + ".TMin") -273.15;
		  strTMaxInfo = restree.getResourceValue(DCaseItem + ".TMax") -273.15;
		  strTMinCalibInfo = restree.getResourceValue(DCaseItem + ".TMinCalib") -273.15;
		  strTMaxCalibInfo = restree.getResourceValue(DCaseItem + ".TMaxCalib") -273.15;
		    
		  strLimInfo = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(" + strTMinInfo.toFixed(0) + "/" + strTMinCalibInfo.toFixed(0) + " to " + strTMaxInfo.toFixed(0) + "/" + strTMaxCalibInfo.toFixed(0) +")";
		         		
		  CCaseSelector.option( restree.path + "." + DCaseItem, strCaseDescr + ": " + strLimInfo, false );
  		  
			DCaseItem = restree.getNext();
		}
		restree.path = "";
  }
  var strTitle = "Edit Case Limits";
%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    </head>
    <body id="pgCalibSysCalibEnaDisa">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuCalib", "mnuCalibSysCalibEditLimits" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE>
                <TR>
                    <TD VALIGN="TOP" colspan=2>
                        <%
                          if ( bEnabled == false )
                              Response.Write("<span id=errstatus> Production Application not available! </span>");
                          else 
                              Response.Write("<span id=OKstatus> Select the cases you want to change. Edit one or more limits and press submit. </span>");
                        %>
                        <BR>
                        <BR>
                    </td>
                </TR>
                <TR>
                    <TD VALIGN="TOP">
                    <FORM ACTION="#" METHOD="post" NAME=selcase ID="Form1">
                        <p>Case(s)</p>
                        <%CCaseSelector.print();%><br>
                        &nbsp;Name:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(Min/Calib&nbsp;to&nbsp;Max/Calib)<br>
                        <BR>
                        <BR>
                        <p>TMin and TMax</p>
                        <INPUT TYPE="input" NAME="TMin" SIZE="5" maxlength="5" ID="Input3"  <%if ( !bEnabled ) Response.Write("disabled");%>> to 
                        <INPUT TYPE="input" NAME="TMax" SIZE="5" maxlength="5" ID="Input1"  <%if ( !bEnabled ) Response.Write("disabled");%>>
                        <BR>
                        <p>TMinCalib and TMaxCalib</p>
                        <INPUT TYPE="input" NAME="TMinCalib" SIZE="5" maxlength="5" ID="Input2"  <%if ( !bEnabled ) Response.Write("disabled");%>> to
                        <INPUT TYPE="input" NAME="TMaxCalib" SIZE="5" maxlength="5" ID="Input4"  <%if ( !bEnabled ) Response.Write("disabled");%>>
                        <BR>
                        <BR>
                        <p>Case name template</p>
                        <INPUT TYPE="input" NAME="Template" SIZE ="40" ID="Input5" VALUE='<%Response.Write( strTemplate );%>'  <%if ( !bEnabled ) Response.Write("disabled");%>>
                        <BR>
                        <BR>
                        <BR>
                        <INPUT TYPE="submit" VALUE="Submit" ID="Submit1" NAME="SubmitEditLimits"  <%if ( !bEnabled ) Response.Write("disabled");%>>
                    </FORM>
                    </TD>
                </TR>
                </TABLE>
            </div>
            <div>
			      <%printStandardFooter();%>
            </div>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
