<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/serviceutils.inc" -->
<%
  /* Create proper working conditions in the camera  */

  var bAppStarted = isAppStarted("prodapp", "prod.syscalib.ecode");
  var bEnabled = bAppStarted;
	var strDisabled = "disabled ";
  var strStateName;
  var nEcode = -1;
  
  if (bAppStarted)
  {
    strStateName = restree.getResourceValue("prod.syscalib.accStateName");
    if ( strStateName == "Idle" )
    {
      restree.setResourceValue("prod.syscalib.command", "accInit");
      bEnabled = waitWhileBusy("prod.syscalib.status");
    }
    nEcode = restree.getResourceValue("prod.syscalib.ecode");
  }
	if ( bEnabled ) 
	  strDisabled = "";

  /* Dummy initiations of our form content variables  */
  
	var CCaseSelector = new SelectTag("caseList", 0, "multiple " + strDisabled);
	var strCaseID = "";
	var CCaseItem;
	var bCaseEnabled = false;
	var strCases = "";
    
  if (bEnabled)
  {
    /* Check that we have a legal strStateName  */
    
    /* Go through the submitted form , if it is our own one. */
    
    if ( Request.Form.Count > 0 && Request.Form ( "SubmitEnaDisa" ) != "" ) 
    {
      var strCases = new String(Request.Form("caseList"));
      var bEnableCase = false;
      if (Request.Form("action") == "enable")
         bEnableCase = true;
      
		  restree.path = "calib.ccase";
		  CCaseItem = restree.getFirst();
		  
		  var bChangeMade = false;
    	
		  while (CCaseItem != "")
		  {
		    strCaseID = restree.getResourceValue(CCaseItem + ".ID");
		    
		    if ( strCases.search(strCaseID) >= 0 )
		    {
		      restree.setResourceValue(CCaseItem + ".enabled", bEnableCase);
		      bChangeMade = true;
		    }
		    
			  CCaseItem = restree.getNext();
		  }
		  restree.path = "";
		  
		  if (bChangeMade)
		  {
	      restree.setResourceValue("prod.syscalib.command", "accSave");  // Saves calib.rsc
	      waitWhileBusy("prod.syscalib.status");
	    }
    }

    /* We are about to show our own form now. Fetch proper data for it */
	  
		strCaseID = "";
		var strCaseDescr = "";
		bCaseEnabled = false;
		var strFlagsResName = "";
		var nFlags = 0;
		var strRvalResName = "";
		var fRval = 1.0;
		var strRBFInfo = "";
  	
		restree.path = "calib.ccase";
	  var restreeRBFCache = new ResTree();
		restreeRBFCache.path = "calib.extRBFCalc.recalData.RBFCache";
	  var restreeRBF = new ResTree();
		restreeRBF.path = "calib.extRBF";

		CCaseItem = restree.getFirst();
  	
		while (CCaseItem != "")
		{
		  strCaseDescr = restree.getResourceValue(CCaseItem + ".descr");
		  strCaseID = restree.getResourceValue(CCaseItem + ".ID");
		  bCaseEnabled = restree.getResourceValue(CCaseItem + ".enabled");
		  if ( bCaseEnabled )
		  {
		    strFlagsResName = strCaseID + ".RBFflags";
		    strRvalResName = strCaseID + ".R";
		    if ( restreeRBFCache.valueType(strFlagsResName) != "N/A" )
		    {
		      nFlags = restreeRBFCache.getResourceValue(strFlagsResName);
		      fRval = restreeRBFCache.getResourceValue(strRvalResName)
		    }
		    else if ( restreeRBF.valueType(strFlagsResName) != "N/A" )
		    {
		      nFlags = restreeRBF.getResourceValue(strFlagsResName);
		      fRval = restreeRBF.getResourceValue(strRvalResName)
		    }
		    else
		      nFlags = -1;
		      
		    strRBFInfo = evalRBFFlags(fRval,nFlags);
		  }
		  else
		      strRBFInfo = "(Disabled)";
		         		
		  CCaseSelector.option( strCaseID, strCaseDescr + " " + strRBFInfo, false );
  		  
			CCaseItem = restree.getNext();
		}
		restree.path = "";
  }
var strTitle = "Enable/Disable Cases";

%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    </head>
    <body id="pgCalibSysCalibEnaDisa">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuCalib", "mnuCalibSysCalibEnaDisa" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE>
                <TR>
                    <TD VALIGN="TOP" colspan=2>
                        <%
                          if ( bEnabled == false )
                              Response.Write("<span id=errstatus> Production Application not available! </span>");
                          else 
                              Response.Write("<span id=OKstatus> Select the cases you want to change and press submit. </span>");
                        %>
                        <BR>
                        <BR>
                    </td>
                </TR>
                <TR>
                    <TD VALIGN="TOP">
                    <FORM ACTION="#" METHOD="post" NAME=selcase ID="Form1">
                        <P>Case(s)</P>
                        <%CCaseSelector.print();%><br>
                        <BR>
                        <P>Action</P>
                        &nbsp;&nbsp;<INPUT id="Radio1" type="radio" value="enable" name="action" checked  <%if ( !bEnabled ) Response.Write("disabled");%>></INPUT>&nbsp;&nbsp;Enable
                        <BR>
                        &nbsp;&nbsp;<INPUT id="Radio2" type="radio" value="disable" name="action"  <%if ( !bEnabled ) Response.Write("disabled");%>></INPUT>&nbsp;&nbsp;Disable 
                        <BR>
                        <BR>
                        <INPUT TYPE="submit" VALUE="Submit" ID="Submit1" NAME="SubmitEnaDisa"  <%if ( !bEnabled ) Response.Write("disabled");%>>
                    </FORM>
                    </TD>
                    <TD VALIGN="TOP">
                        &nbsp;
                    </td>
                </TR>
                </TABLE>
            </div>
            <div>
			      <%printStandardFooter();%>
            </div>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
