<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<%
    /* Server side script */
	function printOpSpecData(ItemArg, ItemType)
	{
	    /* 
	      ItemType 
	        0 = Whole Image
	        1 = Area with two clustertypes
	        2 = Other areas
	     */
	       
		var Item = ItemArg;
		
		restree.path = "prod.prodSpec.operability.perf";
		if ( ItemArg == "" )
		    Item = restree.getFirst();
		
		if (Item != "")
		{
		    var width = 0;
		    var height = 0;
		    
		    if ( ItemType == 0 )
		    {
		        while (Item != "")
		        {
		            if ( restree.valueType( Item + ".adjR" ) != "N/A" )
		            {
		                Response.Write("<table>");
		                width = 1*restree.getResourceValue(Item + ".mbox.mboxWidth");
		                height = 1*restree.getResourceValue(Item + ".mbox.mboxHeight");
		                Response.Write("<tr><th align=left>SubArea</th><th align=left>" + Item + "</th><tr>");
		                Response.Write("<tr><td>Number of pixels</td><td>" + width*height + "</td><tr>");
    		        
			            Response.Write("<tr><td>adjR</td><td>" + restree.getResourceValue(Item + ".adjR") + "</td></tr>");
			            Response.Write("<tr><td>threeOrMoreAdjR</td><td>" + restree.getResourceValue(Item + ".threeOrMoreAdjR") + "</td></tr>");
			            Response.Write("<tr><td>adjC</td><td>" + restree.getResourceValue(Item + ".adjC") + "</td></tr>");
			            Response.Write("<tr><td>threeOrMoreAdjC</td><td>" + restree.getResourceValue(Item + ".threeOrMoreAdjC") + "</td></tr>");
			            Response.Write("<tr><td>nops</td><td>" + restree.getResourceValue(Item + ".nops") + "</td></tr>");
			            Response.Write("<tr><td>rows</td><td>" + restree.getResourceValue(Item + ".rows") + "</td></tr>");
			            Response.Write("<tr><td>cols</td><td>" + restree.getResourceValue(Item + ".cols") + "</td></tr>");
			            Response.Write("<tr><td>clusterTypeA</td><td>" + restree.getResourceValue(Item + ".clusterTypeA") + "</td></tr>");
			            Response.Write("<tr><td>sumRC</td><td>" + restree.getResourceValue(Item + ".sumRC") + "</td></tr>");
			            
		                Response.Write("</table><br>");
		            }
			        
			        if ( ItemArg != "" )
			            break;		
			            
			        Item = restree.getNext();
			    }
		    }
		    else if ( ItemType == 1 )
		    {
		        while (Item != "")
		        {
		            if ( restree.valueType( Item + ".clusterTypeB" ) != "N/A" )
		            {
		                Response.Write("<table>");
		                width = 1*restree.getResourceValue(Item + ".mbox.mboxWidth");
		                height = 1*restree.getResourceValue(Item + ".mbox.mboxHeight");
		                Response.Write("<tr><th align=left>SubArea</th><th align=left>" + Item + "</th><tr>");
		                Response.Write("<tr><td>Number of pixels</td><td>" + width*height + "</td><tr>");
    		        
			            Response.Write("<tr><td>clusterTypeA</td><td>" + restree.getResourceValue(Item + ".clusterTypeA") + "</td></tr>");
			            Response.Write("<tr><td>clusterTypeB</td><td>" + restree.getResourceValue(Item + ".clusterTypeB") + "</td></tr>");
			            Response.Write("<tr><td>sumRC</td><td>" + restree.getResourceValue(Item + ".sumRC") + "</td></tr>");
		                Response.Write("</table><br>");
		            }
			        
			        if ( ItemArg != "" )
			            break;		
			            
			        Item = restree.getNext();
			    }
		    }
		    else if ( ItemType == 2 )
		    {
		        while (Item != "")
		        {
                    if ( restree.valueType( Item + ".clusterTypeB" ) == "N/A" &&
                         restree.valueType( Item + ".adjR" ) == "N/A")
                    {
                    
		                Response.Write("<table>");
		                width = 1*restree.getResourceValue(Item + ".mbox.mboxWidth");
		                height = 1*restree.getResourceValue(Item + ".mbox.mboxHeight");
		                Response.Write("<tr><th align=left>SubArea</th><th align=left>" + Item + "</th><tr>");
		                Response.Write("<tr><td>Number of pixels</td><td>" + width*height + "</td><tr>");

			            Response.Write("<tr><td>nops</td><td>" + restree.getResourceValue(Item + ".nops") + "</td></tr>");
			            Response.Write("<tr><td>rows</td><td>" + restree.getResourceValue(Item + ".rows") + "</td></tr>");
			            Response.Write("<tr><td>cols</td><td>" + restree.getResourceValue(Item + ".cols") + "</td></tr>");
			            Response.Write("<tr><td>clusterTypeA</td><td>" + restree.getResourceValue(Item + ".clusterTypeA") + "</td></tr>");
			            Response.Write("<tr><td>sumRC</td><td>" + restree.getResourceValue(Item + ".sumRC") + "</td></tr>");
		                Response.Write("</table><br>");

			       }
			        if ( ItemArg != "" )
			            break;		
			        Item = restree.getNext();
			    }
		    }
		}
		restree.path = "";
	}

    /* Start the production application, unless already done */
    var started = false;
      
    var valueType = restree.valueType( "prod.prodSpec.operability.gen.date" );
    if( valueType != "N/A") /* This works on all types of values */
    { 
        started = true;
    }
        
    if( started == false ) 
    {
        restree.setResourceValue( "appl.supv.exec",  "prodapp" );
        for( i = 0; i < 1000; i++ ) 
        {
            var valueType = restree.valueType( "prod.prodSpec.operability.gen.date" );
            if( valueType != "N/A") 
            {
                started = true;
                break;
            }
        }
    }
  var strTitle = "Operability Specification";
%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    </head>
    <body id="pgCamInfoOpSpec">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuCamInfo", "mnuCamInfoOpSpec" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <%if (started == false)
                    Response.Write("<span id=errstatus> Production application not available! </span><br<br>");
                %>
                <h3>Specification&nbsp;for&nbsp;Non-Operation Pixels</h3>
                <TABLE ID="Table5">
                <TR>
                <TH align=left>Date</TH>
                <TH align=left>&nbsp;Descr</TH>
                <TH align=left>&nbsp;Version</TH>
                </TR>
                <TR>
                <TD><%Response.Write(restree.getResourceValue("prod.prodSpec.operability.gen.date"));%></TD>
                <TD>&nbsp;<%Response.Write(restree.getResourceValue("prod.prodSpec.operability.gen.descr"));%></TD>
                <TD>&nbsp;<%Response.Write(restree.getResourceValue("prod.prodSpec.operability.gen.version"));%></TD>
                </TR>
                </TABLE>
                <br>
                <b>Whole Image</b><br><br>
                <%printOpSpecData("A_WI",0);%>
                <br>
                

                <b>Area A_3</b><br><br>
                <%printOpSpecData("A_3",1);%>
                <br>

                <b>Areas A1_1 to A3_3</b><br><br>
                <%printOpSpecData("",2);%>
                <br>
                
            </div>
			<%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
