<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<%
  /* Server side script */
  function GetTwoFirstChar( Text )
  {
     var Str = new String(Text);
     return Str.substr(0,2);
  }

  function RunTestsIn( strResPath )
  {
    restree.path = strResPath;
    var testItem = restree.getFirst();
    
    while ( testItem != "" )
    {
      restree.setResourceValue( testItem, "on" );
      testItem = restree.getNext();
    }
    restree.path = "";
  }
  function GetTestResultFrom( strResPath )
  {
    restree.path = strResPath;
    var testItem = restree.getFirst();
    var strResult = "No tests found";
    
    while ( testItem != "" )
    {
      strResult = restree.getResourceValue( testItem );
      if ( GetTwoFirstChar(strResult) != "OK" )
        break;
        
      testItem = restree.getNext();
    }
    restree.path = "";
    
    return strResult; 
  }


  function PrintDecoratedStatusText( StatusText )
  {
     var StrTest = GetTwoFirstChar(StatusText);
     
     if ( StrTest == "OK" || StrTest == "Te" )
        Response.Write('<span id="OKstatus">' +  StatusText + '</span>');
     else if ( StrTest == "E " || StrTest == "FA" )
        Response.Write('<span id="errstatus">' +  StatusText + '</span>');
     else
        Response.Write(StatusText);
  }

  var RunBatteryTest = false;
  var RunClockTest = false;
  var RunEEPromTest = false;
  var RunTSensTest = false;
  var RunFocusTest = false;
  var RunGPSTest = false;
  var RunAll = true;
  var Tester = "";
  var AllCheck = "checked";
  var BatteryCheck = "";
  var ClockCheck = "";
  var EEPromCheck = "";
  var TSensCheck = "";
  var FocusCheck = "";
  var GPSCheck = "";
  var BatteryStatus = "?";
  var ClockStatus = "?";
  var EEPromStatus = "?";
  var TSensStatus = "?";
  var FocusStatus = "?";
  var GPSStatus = "?";
  var ErrCnt = 0;
  var CheckChecks = false;
  

  var started = false;
  
  var ErrCntType = restree.valueType( "bit.test.errcnt" );
  if( ErrCntType != "N/A") 
  {
    started = true;
  }
  if( started == false ) 
  {
    restree.setResourceValue( "appl.supv.exec",  "bitapp" );
    for( i = 0; i < 1000; i++ ) 
    {
        var ErrCntType = restree.valueType( "bit.test.errcnt" );
        if( ErrCntType != "N/A") 
        {
            started = true;
            break;
        }
     }
  }

  if( started )
  {
    if ( Request.Form.Count > 0 ) 
    {
        Tester = Request.Form( "tester" );
        
        if ( Tester != "" )
        {
            restree.setResourceValue( "bit.test.description.tester", Tester );
            restree.setResourceValue( "bit.test.description.category", "Self Test" );
            restree.setResourceValue( "bit.test.description.article", restree.getResourceValue("version.product.article") );
            restree.setResourceValue( "bit.test.description.env", "?????" );
            restree.setResourceValue( "bit.test.description.serial", restree.getResourceValue("version.product.serial"));
            
            RunBatteryTest = false;
            RunClockTest = false;
            RunEEPromTest = false;
            RunTSensTest = false;
            RunFocusTest = false;
            RunGPSTest = false;
            RunAll = false;
            AllCheck = "";
            BatteryCheck = "";
            ClockCheck = "";
            EEPromCheck = "";
            TSensCheck = "";
            GPSCheck = "";
        
            if ( Request.Form ( "all" ) ==  "on" )
            {
                RunAll = true;
                RunBatteryTest = true;
                RunClockTest = true;
                RunEEPromTest = true;
                RunTSensTest = true;
                RunFocusTest = true;
                RunGPSTest = true;
                AllCheck = "checked";
            }

            if ( Request.Form ( "battery" ) ==  "on" )
            {
                RunBatteryTest = true;
                BatteryCheck = "checked";
            }
            if ( Request.Form ( "clock" ) ==  "on" )
            {
                RunClockTest = true;
                ClockCheck = "checked";
            }
            if ( Request.Form ( "EEProm" ) ==  "on" )
            {
                RunEEPromTest = true;
                EEPromCheck = "checked";
            }
            if ( Request.Form ( "tempsens" ) ==  "on" )
            {
                RunTSensTest = true;
                TSensCheck = "checked";
            }
            if ( Request.Form ( "focus" ) ==  "on" && (CamType == "P" || CamType == "Pt" || CamType == "E" || CamType == "A" || CamType == "X2" || CamType == "G" || CamType == "A2"  || CamType == "E3" ) )
            {
                RunFocusTest = true;
                FocusCheck = "checked";
            }
            if ( Request.Form ( "gps" ) ==  "on" && (CamType == "P" || CamType == "Pt" || CamType == "G" || CamType == "E2" || CamType == "E3" ) )
            {
                RunGPSTest = true;
                GPSCheck = "checked";
            }
            
            if ( Request.Form ( "ViewLog" ) != "" )
            {
                Response.Redirect("/tmp/bitlog.txt");
            }
            else if ( Request.Form ( "RunTests" ) != "" )
            {
                if ( CamType == "X" )
                {
                  if ( RunBatteryTest )
                      restree.setResourceValue( "bit.test.items.battery", "on" );
                  if ( RunClockTest )
                      restree.setResourceValue( "bit.test.items.clock", "on" );
                  if ( RunEEPromTest )
                      restree.setResourceValue( "bit.test.items.eeprom", "on" );
                  if ( RunTSensTest )
                      restree.setResourceValue( "bit.test.items.tempsens", "on" );
                } 
                if ( CamType == "X2" )
                {
                  if ( RunBatteryTest )
                      restree.setResourceValue( "bit.test.items.battery.battery", "on" );
                  if ( RunClockTest )
                      restree.setResourceValue( "bit.test.items.clock.clock", "on" );
                  if ( RunEEPromTest )
                      RunTestsIn( "bit.test.items.eeprom");
                  if ( RunTSensTest )
                      RunTestsIn( "bit.test.items.tempsens");
                  if ( RunFocusTest )
                      restree.setResourceValue( "bit.test.items.focus.detect", "on" );
                } 
                if ( CamType == "Z" || CamType == "Z3" )
                {
                  if ( RunEEPromTest )
                      restree.setResourceValue( "bit.test.items.eeprom.main", "on" );
                  if ( RunTSensTest )
                      restree.setResourceValue( "bit.test.items.tempsens.TSBoard", "on" );
				} 
                else if ( CamType == "A" || CamType == "A2" )
                {
                  if ( RunClockTest )
                      restree.setResourceValue( "bit.test.items.clock.clock", "on" );
                  if ( RunEEPromTest )
                      RunTestsIn( "bit.test.items.eeprom");
                  if ( RunTSensTest )
                      RunTestsIn( "bit.test.items.tempsens");
                  if ( RunFocusTest )
                      restree.setResourceValue( "bit.test.items.focus.focus", "on" );
                }
                else if ( CamType == "PREM" )
                {
                  if ( RunBatteryTest )
                      restree.setResourceValue( "bit.test.items.battery.battery", "on" );
                  if ( RunClockTest )
                      restree.setResourceValue( "bit.test.items.clock.clock", "on" );
                  if ( RunEEPromTest )
                      RunTestsIn( "bit.test.items.eeprom");
                }
                else if ( CamType == "E" )
                {
                  if ( RunBatteryTest )
                      restree.setResourceValue( "bit.test.items.battery.battery", "on" );
                  if ( RunClockTest )
                      restree.setResourceValue( "bit.test.items.clock.clock", "on" );
                  if ( RunEEPromTest )
                      RunTestsIn( "bit.test.items.eeprom");
                  if ( RunTSensTest )
                      RunTestsIn( "bit.test.items.tempsens");
                  if ( RunFocusTest )
                      restree.setResourceValue( "bit.test.items.focus.focus", "on" );
                }
                else if ( CamType == "E2" || CamType == "E3" )
                {
                  if ( RunBatteryTest )
                      restree.setResourceValue( "bit.test.items.battery.battery", "on" );
                  if ( RunClockTest )
                      restree.setResourceValue( "bit.test.items.clock.clock", "on" );
                  if ( RunEEPromTest )
                      RunTestsIn( "bit.test.items.eeprom");
                  if ( RunTSensTest )
                      RunTestsIn( "bit.test.items.tempsens");
                  if ( RunFocusTest )
                      RunTestsIn( "bit.test.items.focus.focus");
                  if ( RunGPSTest )
                      restree.setResourceValue( "bit.test.items.gps.detect", "on" );
                }
                else if ( CamType == "FX" )
                {
                  if ( RunBatteryTest )
                      restree.setResourceValue( "bit.test.items.battery.battery", "on" );
                  if ( RunClockTest )
                      restree.setResourceValue( "bit.test.items.clock.clock", "on" );
                  if ( RunEEPromTest )
                      RunTestsIn( "bit.test.items.eeprom");
                  if ( RunTSensTest )
                      RunTestsIn( "bit.test.items.tempsens");
                }
                else if ( CamType == "P" || CamType == "Pt" || CamType == "G" )
                {
                  if ( RunBatteryTest )
                      restree.setResourceValue( "bit.test.items.battery.battery", "on" );
                  if ( RunClockTest )
                      restree.setResourceValue( "bit.test.items.clock.clock", "on" );
                  if ( RunEEPromTest )
                      RunTestsIn( "bit.test.items.eeprom");
                  if ( RunTSensTest )
                      RunTestsIn( "bit.test.items.tempsens");
                  if ( RunFocusTest )
                      restree.setResourceValue( "bit.test.items.focus.focus", "on" );
                  if ( RunGPSTest )
                      restree.setResourceValue( "bit.test.items.gps.detect", "on" );
                }
                
                CheckChecks = true;
            }
            else //if ( Request.Form ( "ClearLog" ) != "" ) This param is not present in the form!
            {
                restree.setResourceValue( "bit.test.clearLog", "true" );
                restree.setResourceValue( "bit.test.clearResult", "true" );
                restree.setResourceValue( "bit.test.errcnt", 0 );
            }
        }
     }
     if ( CamType == "X" )
     {
        BatteryStatus = restree.getResourceValue("bit.test.items.battery");
        ClockStatus = restree.getResourceValue("bit.test.items.clock");
        EEPromStatus = restree.getResourceValue("bit.test.items.eeprom");
        TSensStatus = restree.getResourceValue("bit.test.items.tempsens");
     }
     else if ( CamType == "X2" )
     {
        BatteryStatus = restree.getResourceValue("bit.test.items.battery.battery");
        ClockStatus = restree.getResourceValue("bit.test.items.clock.clock");
        EEPromStatus = GetTestResultFrom("bit.test.items.eeprom");
        TSensStatus = GetTestResultFrom("bit.test.items.tempsens");
        FocusStatus = restree.getResourceValue("bit.test.items.focus.detect");
     }
     else if ( CamType == "Z" || CamType == "Z3" )
     {
        EEPromStatus = restree.getResourceValue("bit.test.items.eeprom.main");
        TSensStatus = restree.getResourceValue("bit.test.items.tempsens.TSBoard");
     }
     else if ( CamType == "A" || CamType == "A2" )
     {
        ClockStatus = restree.getResourceValue("bit.test.items.clock.clock");
        EEPromStatus = GetTestResultFrom("bit.test.items.eeprom");
        TSensStatus = GetTestResultFrom("bit.test.items.tempsens");
        FocusStatus = restree.getResourceValue("bit.test.items.focus.focus");
     }
     else if ( CamType == "PREM" )
     {
        BatteryStatus = restree.getResourceValue("bit.test.items.battery.battery");
        ClockStatus = restree.getResourceValue("bit.test.items.clock.clock");
        EEPromStatus = GetTestResultFrom("bit.test.items.eeprom");
     }
     else if ( CamType == "E" )
     {
        BatteryStatus = restree.getResourceValue("bit.test.items.battery.battery");
        ClockStatus = restree.getResourceValue("bit.test.items.clock.clock");
        EEPromStatus = GetTestResultFrom("bit.test.items.eeprom");
        TSensStatus = GetTestResultFrom("bit.test.items.tempsens");
        FocusStatus = restree.getResourceValue("bit.test.items.focus.focus");
     }
     else if ( CamType == "E2" || CamType == "E3" )
     {
        BatteryStatus = restree.getResourceValue("bit.test.items.battery.battery");
        ClockStatus = restree.getResourceValue("bit.test.items.clock.clock");
        EEPromStatus = GetTestResultFrom("bit.test.items.eeprom");
        TSensStatus = GetTestResultFrom("bit.test.items.tempsens");
        FocusStatus = restree.getResourceValue("bit.test.items.focus.focus");
     }
     else if ( CamType == "FX" )
     {
        BatteryStatus = restree.getResourceValue("bit.test.items.battery.battery");
        ClockStatus = restree.getResourceValue("bit.test.items.clock.clock");
        EEPromStatus = GetTestResultFrom("bit.test.items.eeprom");
        TSensStatus = GetTestResultFrom("bit.test.items.tempsens");
     }
     else if ( CamType == "P" || CamType == "Pt" || CamType == "G" )
     {
        BatteryStatus = restree.getResourceValue("bit.test.items.battery.battery");
        ClockStatus = restree.getResourceValue("bit.test.items.clock.clock");
        EEPromStatus = GetTestResultFrom("bit.test.items.eeprom");
        TSensStatus = GetTestResultFrom("bit.test.items.tempsens");
        FocusStatus = restree.getResourceValue("bit.test.items.focus.focus");
        GPSStatus = restree.getResourceValue("bit.test.items.gps.detect");
     }
     Tester = restree.getResourceValue("bit.test.description.tester");
     ErrCnt = restree.getResourceValue("bit.test.errcnt");

     /* Reset the check button status, if the tests were OK */
     if ( CheckChecks )
     {
        if (GetTwoFirstChar(BatteryStatus) != "E ")
            BatteryCheck = "";
        if (GetTwoFirstChar(ClockStatus) != "E ")
            ClockCheck = "";
        if (GetTwoFirstChar(EEPromStatus) != "E ")
            EEPromCheck = "";
        if (GetTwoFirstChar(TSensStatus) != "E ")
            TSensCheck = "";
        if (GetTwoFirstChar(FocusStatus) != "E ")
            FocusCheck = "";
        if (GetTwoFirstChar(GPSStatus) != "E ")
            GPSCheck = "";
     }
     
  }
  var strTitle = "Self Test";
%>
<HTML>
    <HEAD>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
            <script>
            /* client side script */
            function AskClear(theForm)
            {
                if(confirm("Clearing the log!!\n     Are you sure?"))
                {
                    theForm.submit();
                }
            }
            </script>
    </HEAD>
    <body id="pgDiagBITSelfTest">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuDiag", "mnuDiagBITSelfTest" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE>
                    <FORM ACTION="#" METHOD="post" NAME="SelfTest" ID="Form2">
                        <TR>
                            <TD VALIGN="top" colspan="2">
                                <%if ( started == false )
                                    Response.Write("<span id=errstatus> Test Application not available! </span>")
                                else if ( Tester == "" )
                                    Response.Write("<span id=errstatus> Please fill in the tester field! </span>")
                                else
                                {
                                    var PartNumber = restree.getResourceValue("bit.test.description.article");
                                    Response.Write("Of part number " + PartNumber);
                                }%>
                                <BR>
                            </TD>
                        </TR>
                        <TR>
                            <TD VALIGN="top" colspan="2">
                                Tester<BR>
                                <INPUT id="Text1" type="text" name="tester" value="<%Response.Write(Tester);%>"><BR>
                            </TD>
                        </TR>
                        <TR>
                            <TD VALIGN="top">
                                <u>Tests</u><BR>
                                <input id=Checkbox1 type=checkbox name="all" <%Response.Write(AllCheck);%>>&nbsp;&nbsp;<B>All Self tests&nbsp;&nbsp;(Err status: <%Response.Write(ErrCnt);%>)</B><BR>
<% if (CamType == "Z" || CamType == "A" || CamType == "A2" || CamType == "Z3" ) Response.Write("<!--- \n"); %>
                                <INPUT id=Checkbox2 type=checkbox name="battery" <%Response.Write(BatteryCheck);%>>&nbsp;&nbsp;Battery&nbsp;&nbsp;(<%PrintDecoratedStatusText(BatteryStatus);%>)<BR>
<% if (CamType == "Z" || CamType == "A" || CamType == "A2" || CamType == "Z3" ) Response.Write("---> \n"); %>
<% if (CamType == "Z" || CamType == "Z3" ) Response.Write("<!--- \n"); %>
                                <INPUT id=Checkbox3 type=checkbox name="clock" <%Response.Write(ClockCheck);%>>&nbsp;&nbsp;Clock&nbsp;&nbsp;(<%PrintDecoratedStatusText(ClockStatus);%>)<BR>
<% if (CamType == "Z" || CamType == "Z3" ) Response.Write("---> \n"); %>
                                <INPUT id=Checkbox4 type=checkbox name="EEProm" <%Response.Write(EEPromCheck);%>>&nbsp;&nbsp;EEProm&nbsp;&nbsp;(<%PrintDecoratedStatusText(EEPromStatus);%>)<BR>
<% if (CamType == "PREM") Response.Write("<!--- \n"); %>
                                <INPUT id=Checkbox5 type=checkbox name="tempsens" <%Response.Write(TSensCheck);%>>&nbsp;&nbsp;Temperature&nbsp;sensors&nbsp;&nbsp;(<%PrintDecoratedStatusText(TSensStatus);%>)<BR>
<% if (CamType == "PREM") Response.Write("---> \n"); %>
<% if (CamType == "X" || CamType == "X2" || CamType == "Z" || CamType == "PREM" || CamType == "E2" || CamType == "FX" || CamType == "Z3" ) Response.Write("<!--- \n"); %>                                
                                <INPUT id="Checkbox6" type=checkbox name="focus" <%Response.Write(FocusCheck);%>>&nbsp;&nbsp;Focus&nbsp;motor&nbsp;&nbsp;(<%PrintDecoratedStatusText(FocusStatus);%>)<BR>
<% if (CamType == "X" || CamType == "X2" || CamType == "Z" || CamType == "PREM" || CamType == "E2" || CamType == "FX" || CamType == "Z3" ) Response.Write("---> \n"); %>                                
<% if (CamType == "X" || CamType == "Z" || CamType == "E" || CamType == "P" || CamType == "Pt" || CamType == "G" || CamType == "A" || CamType == "PREM" || CamType == "A2" || CamType == "E2" || CamType == "E3" || CamType == "FX" || CamType == "Z3" ) Response.Write("<!--- \n"); %>                                
                                <INPUT id="Checkbox6" type=checkbox name="focus" <%Response.Write(FocusCheck);%>>&nbsp;&nbsp;Focus&nbsp;&nbsp;(<%PrintDecoratedStatusText(FocusStatus);%>)<BR>
<% if (CamType == "X" || CamType == "Z" || CamType == "E" || CamType == "P" || CamType == "Pt" || CamType == "G" || CamType == "A" || CamType == "PREM" || CamType == "A2"|| CamType == "E2" || CamType == "E3"  || CamType == "FX" || CamType == "Z3" ) Response.Write("---> \n"); %>                                
<% if (CamType != "P" && CamType != "Pt" && CamType != "G" ) Response.Write("<!--- \n"); %>                                
                                <INPUT id="Checkbox7" type=checkbox name="gps" <%Response.Write(GPSCheck);%>>&nbsp;&nbsp;GPS&nbsp;&nbsp;(<%PrintDecoratedStatusText(GPSStatus);%>)<BR>
<% if (CamType != "P" && CamType != "Pt" && CamType != "G" ) Response.Write("---> \n"); %>                                
                            </TD>
                        </TR>
                        <tr>
                            <td colspan="2">
                                <INPUT TYPE="submit" VALUE="Run tests" ID="Button1" NAME="RunTests">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                <INPUT TYPE="submit" VALUE="View log" ID="Button2" NAME="ViewLog">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                <INPUT TYPE="button" VALUE="Clear log and results" OnClick="AskClear(this.form)" ID="Button3" NAME="ClearLog">
                            </td>
                        </tr>
                    </FORM>
                </TABLE>
            </div>
            <%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</HTML>
