<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<%  var strTitle = "Noise Tests"; %>
<HTML>
    <HEAD>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    </HEAD>
    <body id="pgDiagNoise">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuDiag", "mnuDiagNoise" );%>
        <!-- This is the actual contents -->
        <div id="mainpane"> 
            <div id="content">
                <TABLE ID="Table1">
                    <TR>
                        <TD VALIGN="top">
                            <h2>Instruction</h2>
                            Three noise measurement methods are available<br>
                            <b>Temporal</b> measuring noise by comparing a sequence of images.<br>
                            <b>Spatial</b> measuring noise in a image averaged from several images.<br>
                            <b>Total</b> measuring noise in a single image.<br>
                            <br>
                            To run the tests:<br>
                            - Point the camera at a suitable blackbody.<br>
                            - On the "Noise Measurements" page, select the methods to be used by
                              activating the checkmarks for each method.<br>
                            - Fill in the blackbody temperature.<br>
                            - To erase previous results, activate the "Clear old results" checkmark.<br>
                            - Press the "Measure Noise" button to start the measurements.<br>
                            <br>
                            The selected measurement methods will be exectued in sequence. The presently
                            executing method will be displayed in red at the top of the page.<br>
                            When all measurements are performed, the results will be displayed by the "Noise Results" page.<br>
                            <br>
                        </TD>
                    </TR>
                </TABLE>
            </div>
            <%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</HTML>
