	<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<%
  /*********************************************************
  * Start of serverside Jscript code.
  *********************************************************/

  function startTemporal()
  {
    restree.setResourceValue( "prod.netd.command",  "temporal" );
  }

  function startSpatial()
  {
    restree.setResourceValue( "prod.netd.command",  "spatial" );
  }

  function startTotal()
  {
    restree.setResourceValue( "prod.netd.command",  "total" );
  }

  /* Start the production application, unless already done */
  var started = false;
  var Status = "not started";
  var ECode = -1;
  var currentAction = "";
  var description = "no action";
  var temporal = 1;
  var spatial = 1;
  var total = 1;
  var CmdReady = false;
  var objTemp = "";
  var forceRefresh = false;

  var ValueType = restree.valueType( "prod.netd.status" );
  if( ValueType != "N/A") /* This works on all types of values */
  { 
    started = true;
  }

  if( started == false ) 
  {
    restree.setResourceValue( "appl.supv.exec",  "prodapp" );
    for( i = 0; i < 150; i++ ) 
    {
      var ValueType = restree.valueType( "prod.map.status" );
      if( ValueType != "N/A") 
      {
        started = true;
        break;
      }
      restree.sleep( 200 );
    }
  }
  if( started ) {
    /*
     * Any form data ?
     * No form data indicates a window refresh.
     */
    if( Request.Form.Count > 0 ) {
      /*
       * Read information from checkboxes.
       */
      if( Request.Form( "cbTempo" ) == "on" ) {
        temporal = 1;
      }
      else {
        temporal = 0;
      }
      if( Request.Form( "cbSpat" ) == "on" ) {
        spatial = 1;
      }
      else {
        spatial = 0;
      }
      if( Request.Form( "cbTot" ) == "on" ) {
        total = 1;
      }
      else {
        total = 0;
      }
      /*
       * Clear previous netd results of ordered to do so.
       */
      if( Request.Form( "cbClear" ) == "on" ) {
        restree.setResourceValue( "prod.netd.temporal.mKPix", 0 );
        restree.setResourceValue( "prod.netd.temporal.mKRow", 0 );
        restree.setResourceValue( "prod.netd.temporal.mKCol", 0 );
        restree.setResourceValue( "prod.netd.temporal.dUnitsPix", 0 );
        restree.setResourceValue( "prod.netd.temporal.dUnitsRow", 0 );
        restree.setResourceValue( "prod.netd.temporal.dUnitsCol", 0 );

        restree.setResourceValue( "prod.netd.spatial.mKPix", 0 );
        restree.setResourceValue( "prod.netd.spatial.mKRow", 0 );
        restree.setResourceValue( "prod.netd.spatial.mKCol", 0 );
        restree.setResourceValue( "prod.netd.spatial.mKPixDiff", 0 );
        restree.setResourceValue( "prod.netd.spatial.dUnitsPix", 0 );
        restree.setResourceValue( "prod.netd.spatial.dUnitsRow", 0 );
        restree.setResourceValue( "prod.netd.spatial.dUnitsCol", 0 );
        restree.setResourceValue( "prod.netd.spatial.dUnitsPixDiff", 0 );

        restree.setResourceValue( "prod.netd.total.mKPix", 0 );
        restree.setResourceValue( "prod.netd.total.mKRow", 0 );
        restree.setResourceValue( "prod.netd.total.mKCol", 0 );
        restree.setResourceValue( "prod.netd.total.dUnitsPix", 0 );
        restree.setResourceValue( "prod.netd.total.dUnitsRow", 0 );
        restree.setResourceValue( "prod.netd.total.dUnitsCol", 0 );
      }
      /*
       * Read config parameters from prodspec and transfer them to resources in prod.netd.
       * Uniformityskip is hardcoded to 20. ( same as used by BAL ).
       */
      var vl;

      vl = restree.getResourceValue( "prod.prodSpec.imgQuality.config.avgImages" );
      restree.setResourceValue( "prod.netd.spatial.frames", vl );
      restree.setResourceValue( "prod.netd.spatial.uniformitySkip", 20 );
      vl = restree.getResourceValue( "prod.prodSpec.imgQuality.config.seqLength" );
      restree.setResourceValue( "prod.netd.temporal.frames", vl );
      vl = restree.getResourceValue( "prod.prodSpec.imgQuality.config.centerSize" );
      restree.setResourceValue( "prod.netd.temporal.clipSize", vl );

      /*
       * Start the first noise measurement.
       */
      objTemp = new Number( toDecPoint( Request.Form( "objTemp" ) ) );
      var m_val = objTemp + 273.15;
      restree.setResourceValue( "prod.netd.objectTemp", m_val.toString( 10 ) );
      restree.setResourceValue( "prod.netd.command",  "init" );
      currentAction = "init";
      description = "initialization";
    }
    else 
    {
      /*
       * Check page mode when refreshed.
       *
       * Sequence through temporal/spatial/total netd measurements
       * according to checkbox data stored in temporal/spatial/total variables.
       */
      currentAction = Request.QueryString( "currentAction" );
      if( Request.QueryString( "temporal" ) != "" )
        temporal = Request.QueryString( "temporal" );

      if( Request.QueryString( "spatial" ) != "" )
        spatial = Request.QueryString( "spatial" );

      if( Request.QueryString( "total" ) != "" )
        total = Request.QueryString( "total" );

      if( Request.QueryString( "objTemp" ) != "" )
        objTemp = new Number( toDecPoint( Request.QueryString( "objTemp" ) ) );

      Status = restree.getResourceValue( "prod.netd.status" );
      /*
       * If the netd init command is ready,
       * start a temporal, spatial or total measurement if ordered to do so.
       */
      if( currentAction == "init" ) {
        if( Status == "ready" ) {
          if( temporal != 0 ) {
            currentAction = "temporal";
            description = "temporal measurement";
            startTemporal();
          }
          else if( spatial != 0 ) {
            currentAction = "spatial";
            description = "spatial measurement";
            startSpatial();
          }
          else if( total != 0 ) {
            currentAction = "total";
            description = "total measurement";
            startTotal();
          }
          else {
            currentAction = "ready";
            description = "result preparation";
            forceRefresh = true;
          }
        }
        else if( Status != "busy" ) {
          currentAction = "";
          description = "no action";
        }
        else {
          description = "initialization";
        }
      }
      /*
       * If a temporal netd measurement is ready,
       * start a spatial or total measurement if ordered to do so.
       */
      else if( currentAction == "temporal" ) {
        if( Status == "ready" ) {
          if( spatial != 0 ) {
            currentAction = "spatial";
            description = "spatial measurement";
            startSpatial();
          }
          else if( total != 0 ) {
            currentAction = "total";
            description = "total measurement";
            startTotal();
          }
          else {
            currentAction = "ready";
            description = "result preparation";
            forceRefresh = true;
          }
        }
        else if( Status != "busy" ) {
          currentAction = "";
          description = "no action";
        }
        else {
          description = "temporal measurement";
        }
      }
      /*
       * If a spatial netd measurement is ready,
       * start a total measurement if ordered to do so.
       */
      else if( currentAction == "spatial" ) {
        if( Status == "ready" ) {
          if( total != 0 ) {
            currentAction = "total";
            description = "total measurement";
            startTotal();
          }
          else {
            currentAction = "ready";
            description = "result preparation";
            forceRefresh = true;
          }
        }
        else if( Status != "busy" ) {
          currentAction = "";
          description = "no action";
        }
        else {
          description = "spatial measurement";
        }
      }
      /*
       * If a total netd measurement is ready, all measurements are ready.
       */
      else if( currentAction == "total" ) {
        if( Status == "ready" ) {
          currentAction = "ready";
          description = "result preparation";
          forceRefresh = true;
        }
        else if( Status != "busy" ) {
          currentAction = "";
          description = "no action";
        }
        else {
          description = "total measurement";
        }
      }
      else if( currentAction == "ready" ) {
        currentAction = "";
        description = "no action";
        CmdReady = true;
      }
    }
    if( CmdReady ) {
      Response.Redirect( "/service/diag/noiseresults.asp" );
    }
    /*
     * Always read status and error code...
     */
    Status = restree.getResourceValue( "prod.netd.status" );
    ECode = restree.getResourceValue( "prod.netd.ecode" );
  }
  
	var strCasePath = restree.getResourceValue("image.ccase.ccase");
	var strCaseName =  restree.getResourceValue(strCasePath + ".descr");
	var strFilterName =  restree.getResourceValue("image.flow.digitalFilter.name");
  var strTitle = "Noise Measurements";
%>
<html>
  <head>
    <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
    <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
  </head>
  <%
    if( Status == "busy" || forceRefresh == true ) {
        Response.Write( '<meta http-equiv="Refresh" content="2' );
        Response.Write( ";url=noisemeasure.asp?currentAction=" + currentAction );
        Response.Write( "&temporal=" + temporal );
        Response.Write( "&spatial=" + spatial );
        Response.Write( "&total=" + total );
        Response.Write( "&objTemp=" + objTemp );
        Response.Write('">\n' );
        Response.Write( '<meta http-equiv="pragma" content="no-cache">\n' );
    }
  %>
  <body id="pgNoiseMeasure">
    <%printStandardDecoration( strTitle );%>
    <%printNavigation( "mnuDiag", "mnuDiagNoiseMeasure" );%>

    <!-- This is the actual contents -->
    <div id="mainpane">
      <div id="content">
        <TABLE ID="Table1">
          <TR><TD>
  <%
            if( Status == "busy" || forceRefresh == true )
              Response.Write("<span id=errstatus> Performing " + description + ", please wait! </span>")
            else if( ECode > 0 )
              Response.Write("<span id=errstatus>" + ecodeString( ECode ) + "</span>")
            else if( ECode < 0 )
              Response.Write("<span id=errstatus> Production Application not available!</span>")
            else if( CmdReady )
              Response.Write("<span id=OKstatus> Command OK </span>")
            else
              Response.Write("&nbsp;")
  %>
          </TD></TR>
          <TR>
            <TD>
            <% 
              Response.Write("Current case: "+strCaseName+"<br>");
              Response.Write("Noise filter: "+strFilterName+"<br><br>");
            %>
              Measurements to perform 
            </TD>
          </TR>
          <FORM ACTION="#" METHOD="post" NAME="noiseMeas" ID="Form1">
            <TR>
              <TD><INPUT TYPE="checkbox" id="cbTempo" name="cbTempo"<%if( temporal != 0 ) Response.Write( " checked" );%>>&nbsp;Temporal noise</TD>
            </TR>
            <TR>
               <TD><INPUT TYPE="checkbox" id="cbSpat" name="cbSpat"<%if( spatial != 0 ) Response.Write( " checked" );%>>&nbsp;Spatial noise</TD>
            </TR>
            <TR>
              <TD><INPUT TYPE="checkbox" id="cbTot" name="cbTot"<%if( total != 0 ) Response.Write( " checked" );%>>&nbsp;Total noise</TD>
            </TR>
            <TR>
              <TD><BR><INPUT TYPE="checkbox" id="cbClear" name="cbClear">&nbsp;Clear old results</TD>
            </TR>
            <TR>
              <TD>Blackbody temperature (&deg;C)</TD>
            </TR>
            <TR>
              <TD><INPUT TYPE="text" ID="objTemp" NAME="objTemp" VALUE="<%Response.Write( objTemp );%>"></TD>
            </TR>
            <TR>
              <TD><INPUT TYPE="submit" id="submit1" name="submit1" value="Measure Noise"></TD>
            </TR>
          </FORM>
        </TABLE>
      </div>
      <%printStandardFooter();%>
    </div>
      <!-- End of actual contents -->
  </body>
</html>
