<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<%
  /*********************************************************
  * Start of serverside Jscript code.
  *********************************************************/
  /* Jscript variables for netd result resource values. */
  var tempoPixMk = 0.0;
  var tempoRowMk = 0.0;
  var tempoColMk = 0.0;
  var tempoPixDu = 0;
  var tempoRowDu = 0;
  var tempoColDu = 0;
  var spatPixMk = 0.0;
  var spatRowMk = 0.0;
  var spatColMk = 0.0;
  var spatUnifMk = 0.0;
  var spatPixDu = 0;
  var spatRowDu = 0;
  var spatColDu = 0;
  var spatUnifDu = 0;
  var totPixMk = 0.0;
  var totRowMk = 0.0;
  var totColMk = 0.0;
  var totPixDu = 0;
  var totRowDu = 0;
  var totColDu = 0;

  /* Start the production application, unless already done */
  var started = false;

  var ValueType = restree.valueType( "prod.netd.status" );
  if( ValueType != "N/A") /* This works on all types of values */
  { 
    started = true;
  }

  if( started == false ) 
  {
    restree.setResourceValue( "appl.supv.exec",  "prodapp" );
    for( i = 0; i < 150; i++ ) 
    {
      var ValueType = restree.valueType( "prod.map.status" );
      if( ValueType != "N/A") 
      {
        started = true;
        break;
      }
      restree.sleep( 200 );
    }
  }
  if( started ) {
    tempoPixMk = restree.getResourceValue( "prod.netd.temporal.mKPix" );
    tempoRowMk = restree.getResourceValue( "prod.netd.temporal.mKRow" );
    tempoColMk = restree.getResourceValue( "prod.netd.temporal.mKCol" );
    tempoPixDu = restree.getResourceValue( "prod.netd.temporal.dUnitsPix" );
    tempoRowDu = restree.getResourceValue( "prod.netd.temporal.dUnitsRow" );
    tempoColDu = restree.getResourceValue( "prod.netd.temporal.dUnitsCol" );
    spatPixMk = restree.getResourceValue( "prod.netd.spatial.mKPix" );
    spatRowMk = restree.getResourceValue( "prod.netd.spatial.mKRow" );
    spatColMk = restree.getResourceValue( "prod.netd.spatial.mKCol" );
    spatUnifMk = restree.getResourceValue( "prod.netd.spatial.mKPixDiff" );
    spatPixDu = restree.getResourceValue( "prod.netd.spatial.dUnitsPix" );
    spatRowDu = restree.getResourceValue( "prod.netd.spatial.dUnitsRow" );
    spatColDu = restree.getResourceValue( "prod.netd.spatial.dUnitsCol" );
    spatUnifDu = restree.getResourceValue( "prod.netd.spatial.dUnitsPixDiff" );
    totPixMk = restree.getResourceValue( "prod.netd.total.mKPix" );
    totRowMk = restree.getResourceValue( "prod.netd.total.mKRow" );
    totColMk = restree.getResourceValue( "prod.netd.total.mKCol" );
    totPixDu = restree.getResourceValue( "prod.netd.total.dUnitsPix" );
    totRowDu = restree.getResourceValue( "prod.netd.total.dUnitsRow" );
    totColDu = restree.getResourceValue( "prod.netd.total.dUnitsCol" );
  }
  var strTitle = "Noise Results";
%>
<html>
  <head>
    <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
    <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
  </head>
  <body id="pgNoiseResults">
    <%printStandardDecoration( strTitle );%>
    <%printNavigation( "mnuDiag", "mnuDiagNoiseResults" );%>

    <!-- This is the actual contents -->
    <div id="mainpane">
      <div id="content">
        <TABLE ID="Table1">
          <CAPTION>Temporal noise</CAPTION>
          <TR>
            <TD>&nbsp;</TD>
            <TD ALIGN="center" WIDTH="120"><B>MilliKelvin</B></TD>
            <TD ALIGN="center" WIDTH="120"><B>Digital Units</B></TD>
          </TR>
          <TR>
            <TD><B>Pixel Noise</TD>
            <TD ALIGN="center"><%Response.Write( tempoPixMk.toFixed(2) );%></TD>
            <TD ALIGN="center"><%Response.Write( tempoPixDu.toFixed(2) );%></TD>
          </TR>
          <TR>
            <TD><B>Row Noise</TD>
            <TD ALIGN="center"><%Response.Write( tempoRowMk.toFixed(2) );%></TD>
            <TD ALIGN="center"><%Response.Write( tempoRowDu.toFixed(2) );%></TD>
          </TR>
          <TR>
            <TD><B>Column Noise</TD>
            <TD ALIGN="center"><%Response.Write( tempoColMk.toFixed(2) );%></TD>
            <TD ALIGN="center"><%Response.Write( tempoColDu.toFixed(2) );%></TD>
          </TR>
        </TABLE>
        <BR>
        <BR>
        <TABLE ID="Table2">
          <CAPTION>Spatial noise</CAPTION>
          <TR>
            <TD>&nbsp;</TD>
            <TD ALIGN="center" WIDTH="120"><B>MilliKelvin</B></TD>
            <TD ALIGN="center" WIDTH="120"><B>Digital Units</B></TD>
          </TR>
          <TR>
            <TD><B>Pixel Noise</TD>
            <TD ALIGN="center"><%Response.Write( spatPixMk.toFixed(2) );%></TD>
            <TD ALIGN="center"><%Response.Write( spatPixDu.toFixed(2) );%></TD>
          </TR>
          <TR>
            <TD><B>Row Noise</TD>
            <TD ALIGN="center"><%Response.Write( spatRowMk.toFixed(2) );%></TD>
            <TD ALIGN="center"><%Response.Write( spatRowDu.toFixed(2) );%></TD>
          </TR>
          <TR>
            <TD><B>Column Noise</TD>
            <TD ALIGN="center"><%Response.Write( spatColMk.toFixed(2) );%></TD>
            <TD ALIGN="center"><%Response.Write( spatColDu.toFixed(2) );%></TD>
          </TR>
          <TR>
            <TD><B>Uniformity</TD>
            <TD ALIGN="center"><%Response.Write( spatUnifMk.toFixed(2) );%></TD>
            <TD ALIGN="center"><%Response.Write( spatUnifDu.toFixed(2) );%></TD>
          </TR>
        </TABLE>
        <BR>
        <BR>
        <TABLE ID="Table3">
          <CAPTION>Total noise</CAPTION>
          <TR>
            <TD>&nbsp;</TD>
            <TD ALIGN="center" WIDTH="120"><B>MilliKelvin</B></TD>
            <TD ALIGN="center" WIDTH="120"><B>Digital Units</B></TD>
          </TR>
          <TR>
            <TD><B>Pixel Noise</TD>
            <TD ALIGN="center"><%Response.Write( totPixMk.toFixed(2) );%></TD>
            <TD ALIGN="center"><%Response.Write( totPixDu.toFixed(2) );%></TD>
          </TR>
          <TR>
            <TD><B>Row Noise</TD>
            <TD ALIGN="center"><%Response.Write( totRowMk.toFixed(2) );%></TD>
            <TD ALIGN="center"><%Response.Write( totRowDu.toFixed(2) );%></TD>
          </TR>
          <TR>
            <TD><B>Column Noise</TD>
            <TD ALIGN="center"><%Response.Write( totColMk.toFixed(2) );%></TD>
            <TD ALIGN="center"><%Response.Write( totColDu.toFixed(2) );%></TD>
          </TR>
        </TABLE>
      </div>
      <%printStandardFooter();%>
    </div>
      <!-- End of actual contents -->
  </body>
</html>
