<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/resTree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<%
	
    /* Server side script */
   
	function printStats()
	{
		var year, month, day, hour, min, sec;
		restree.path = "";
		var absZero = -273.15;
		var laserTime, operatingTime, upTime;
		var maxOpTemp = new Number(restree.getResourceValue("stats.maxOpTemp") + absZero);
		var minOpTemp = new Number(restree.getResourceValue("stats.minOpTemp") + absZero);
		laserTime = Math.round(restree.getResourceValue("stats.laserTime")/3600);
		operatingTime = Math.round((restree.getResourceValue("stats.operatingTime") / 3600));
		lcdTime = Math.round((restree.getResourceValue("stats.lcdTime") / 3600));
		upTime = Math.round((restree.getResourceValue("stats.upTime") / 3600));
		var minDate = new Date( restree.getResourceValue( "stats.minOpTempTime" ) * 1000 );
		var maxDate = new Date( restree.getResourceValue( "stats.maxOpTempTime" ) * 1000 );

		Response.Write('<tr><td>Number of cold starts</td><td>' + restree.getResourceValue("stats.coldStarts") + '</td></tr>');
		Response.Write('<tr><td>Number of shutter operations</td><td>' + restree.getResourceValue("stats.shutterMoves") + '</td></tr>');
		if( CamType != "X" && CamType != "Z" && CamType != "FX" && CamType != "Z3" )
		  Response.Write('<tr><td>Number of focus moves</td><td>' + restree.getResourceValue("stats.focusMoves") + '</td></tr>');

		if( CamType != "A" && CamType != "Z" && CamType != "FX" && CamType != "A2" && CamType != "Z3" )
		  Response.Write('<tr><td>Laser time (hrs)</td><td>' + laserTime + '</td></tr>');

		Response.Write('<tr><td>Max. operating temperature (&deg;C)</td><td>' + maxOpTemp.toPrecision(4) + '</td></tr>');
	        year = maxDate.getFullYear();
	        month = new String( maxDate.getMonth() + 1 );
	        if( month.length < 2 )
	          month = "0" + month;

	        day = new String( maxDate.getDate() );
	        if( day.length < 2 )
	          day = "0" + day;

	        hour = new String( maxDate.getHours() );
	        if( hour.length < 2 )
	          hour = "0" + hour;

	        min = new String( maxDate.getMinutes() );
	        if( min.length < 2 )
	          min = "0" + min;

	        sec = new String( maxDate.getSeconds() );
	        if( sec.length < 2 )
	          sec = "0" + sec;

		Response.Write('<tr><td>Max. operating temperature time</td><td>' + year + '-' + month + '-' + day + ' ' + hour + ':' + min + ':' + sec + '</td></tr>');
		Response.Write('<tr><td>Min. operating temperature (&deg;C)</td><td>' + minOpTemp.toPrecision(4) + '</td></tr>');
	        year = minDate.getFullYear();
	        month = new String( minDate.getMonth() + 1 );
	        if( month.length < 2 )
	          month = "0" + month;

	        day = new String( minDate.getDate() );
	        if( day.length < 2 )
	          day = "0" + day;

	        hour = new String( minDate.getHours() );
	        if( hour.length < 2 )
	          hour = "0" + hour;

	        min = new String( minDate.getMinutes() );
	        if( min.length < 2 )
	          min = "0" + min;

	        sec = new String( minDate.getSeconds() );
	        if( sec.length < 2 )
	          sec = "0" + sec;

		Response.Write('<tr><td>Min. operating temperature time</td><td>' + year + '-' + month + '-' + day + ' ' + hour + ':' + min + ':' + sec + '</td></tr>');
		Response.Write('<tr><td>Operating time (hrs)</td><td>' + operatingTime + '</td></tr>');
		Response.Write('<tr><td>Up-time (hrs)</td><td>' + upTime + '</td></tr>');
		if( CamType == "Z3" )
			Response.Write('<tr><td>Lcd-time (hrs)</td><td>' + lcdTime + '</td></tr>');
	}
	
    if ( Request.Form.Count > 0 ) 
    {
        if (Request.Form( "resetstat" ) != "")
        {
            restree.setResourceValue("stats.reset", 1 * Request.Form( "stat_pw" ));
            restree.sleep(500);
        }
    }
  var strTitle = "Usage statistics";
%>
<html>
	<head>
    <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
		<link href="/styles/flirweb.css" type="text/css" rel="stylesheet">
	</head>
	<body id="pgDiagStatistics">
        <%printStandardDecoration( strTitle );%>
        <% printNavigation("mnuDiag", "mnuDiagStatistics");%>
        <div id="mainpane">
            <div id="content">
                <form action="#" method=post id=form1 name=reset>
				<table ID="Table3">
					<%printStats();%>
				<tr><td>&nbsp;</td></tr>
				<tr><td>
				<input type=submit id=button1 name=resetstat value="Reset Statistics"></td><td>
				Password&nbsp;<INPUT id="stat_pw" type="password" name="stat_pw" value="">
				</td></tr>
				</table>
                </form>	
			</div>
			<%printStandardFooter();%>
		</div>
	</body>
</html>
