<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/eepromlock.inc" -->
<%
    /* Server side script */
    function cvtStar2Today(inStr)
    {
        if (inStr == "*" && EEPromIsUnlocked())
        {
            var today = new Date;
            return today.getFullYear() + "-" + today.getMonth() + "-" + today.getDate();
        }
        return inStr;
    }

    if ( Request.Form.Count > 0 ) 
    {
        EEPromLockActions();
        
        if ( EEPromIsUnlocked() )
        {
            if (Request.Form( "edconf" ) != "")
            {
                var CamName = Request.Form( "camname" );
                var CamSerial = Request.Form( "camserial" );
                var CamArticle = Request.Form( "camarticle" );
                var CamRevision = Request.Form( "camrevision" );
                var CamDate = Request.Form( "camdate" );
                var MustDumpCalib = false;
                
                if ( CamName != "" )
                   restree.setResourceValue("version.product.name", CamName);
                if ( CamSerial != "" )
                {
                   restree.setResourceValue("version.product.serial", CamSerial);
                   restree.setResourceValue("calib.general.CameraSN", CamSerial);
                   MustDumpCalib = true;
                }
                if ( CamArticle != "" )
                {
                   restree.setResourceValue("version.product.article", CamArticle);
                   restree.setResourceValue("calib.general.CameraPN", CamArticle);
                   MustDumpCalib = true;
                }
                if ( CamRevision != "" )
                {
                   restree.setResourceValue("version.product.revision", CamRevision);
                }
                if ( CamDate != "" )
                   restree.setResourceValue("version.product.date", CamDate);
                   
                if ( MustDumpCalib )
                {
    				restree.setResourceValue("dump.node","calib");
				    restree.setResourceValue("dump.file","/flashfs/system/calib.rsc");
				    restree.setResourceValue("dump.commit","on");
                }
            }
        }
    }
  var strTitle = "Edit Camera Information";
%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
        <script>
        /* client side script */
        function UnlockFirst()
        {
            alert("Please unlock the EEProm first.");
            return false;
        }
        </script>
    </head>
    <body id="pgEEPROMEdConf">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuEEPROM", "mnuEEPROMEdCamInfo" );%>

        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <form action="#" method=post name=edconf id=edconf <%if( !EEPromIsUnlocked() ) Response.Write( ' onsubmit="return UnlockFirst();"' );%>>
                <TABLE ID="Table1">
                <TR>
                <TD>
                <B>Camera name</B></TD>
                <TD>
                <input type=text id=camname name=camname value="<%Response.Write(restree.getResourceValue("version.product.name"))%>">
                </TD>
                </TR>
                <TR>
                <TD>
                <B>Camera serial number</B>
                </TD>
                <TD >
                <input type=text id=camserial name=camserial value="<%Response.Write(restree.getResourceValue("version.product.serial"))%>"></TD>
                </TD>
                </TR>
                <TR>
                <TD>
                <B>Camera part number</B>
                </TD>
                <TD >
                <input type=text id=camarticle name=camarticle value="<%Response.Write(restree.getResourceValue("version.product.article"))%>"></TD>
                </TR>
                <TR>
                <TD>
                <B>Camera revision</B>
                </TD>
                <TD >
                <input type=text id="Text1" name=camrevision value="<%Response.Write(restree.getResourceValue("version.product.revision"))%>"></TD>
                </TR>
                <tr>
                <TD >
                <B>Manufacturing date</B>
                </TD>
                <TD >
                <input type=text id=camdate name=camdate value="<%Response.Write(cvtStar2Today(restree.getResourceValue("version.product.date")))%>"></TD>
                </TD>
                </TR>
                <tr>
                <TD>
                <input type=submit id=button1 name=edconf value="Apply">
                </TD>
                </TR>
                </TABLE>
                </form>
                <table><tr><td>
                <form action="#" method=post id="Form2" name=unlock>
                    <%PrintEEPromControls();%>
                </form>				
                </td></tr></table>
                <br><br>
            </div>
			<%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
