<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<%
  var started = false;
  var enabled = false;
  var Ecode = 0;
  var strSpecMapName = "Unknown";
  var strDsGenMapName = "Unknown";
  var strGenMapName = "Unknown";
  var strLensSpecMapName = "Unknown";
      
  if (restree.getResourceValue( "prod.log.status" ) == "ready")
    started = true;

  if( Request.Form.Count > 0 ) {
    if( Request.Form( "mode" ) == "readCold" ) {
      enabled = true;
      /*
       * Start the production application, unless already done
       */
      if( !started ) {
        restree.setResourceValue( "appl.supv.exec",  "prodapp" );
        for( i = 0; i < 50; i++ ) {
          if (restree.getResourceValue( "prod.log.status" ) == "ready")
          {
            started = true;
            break;
          }
          restree.sleep( 300 );
        }
      }
      if( started ) 
      {
        restree.setResourceValue( "prod.map.coldImage", "/Temp/cold.fff" );
        
        // No tcomp when mapping please
        restree.setResourceValue( "tcomp.active", false );

		var RadiometricModel = ""
		RadiometricModel = restree.getResourceValue( ".caps.config.image.flow.radiometrics.model" );
		
        if( CamType == "A2" || CamType == "Pt" ) {
            restree.setResourceValue( "image.flow.maps.gainMap.apf.enabled", false );
            restree.setResourceValue( "system.focus.distance", 60.0 );
            restree.sleep( 1000 );
            restree.setResourceValue( "prod.map.command", "measColdImageMp" );
            restree.setResourceValue( "image.flow.maps.gainMap.apf.enabled", true );
        }
        else if ( CamType == "E" || CamType == "A" || CamType == "X2" || CamType == "E2" || ( CamType == "E3" && RadiometricModel == "TECless" ))
            restree.setResourceValue( "prod.map.command", "measColdImageMp" );
        else
            restree.setResourceValue( "prod.map.command", "measColdImage" );
            
        i = 50;
        while (restree.getResourceValue( "prod.map.status" ) == "busy" && i-- > 0 )
          restree.sleep( 300 );
          
        //
        // Return error code of last command.
        //
        Ecode = restree.getResourceValue( "prod.map.ecode" );
        
        //
        // Pick up the relevant Gain Map names
        //
        restree.setResourceValue("prod.map.nameType", "specific");
        restree.setResourceValue("prod.map.command", "makeMapInfo");
        i = 50;
        while (restree.getResourceValue( "prod.map.status" ) == "busy" && i-- > 0 )
          restree.sleep( 300 );
        strSpecMapName = restree.getResourceValue( "prod.map.gainMap" );
        
        restree.setResourceValue("prod.map.nameType", "dsgeneral");
        restree.setResourceValue("prod.map.command", "makeMapInfo");
        i = 50;
        while (restree.getResourceValue( "prod.map.status" ) == "busy" && i-- > 0 )
          restree.sleep( 300 );
        strDsGenMapName = restree.getResourceValue( "prod.map.gainMap" );

        restree.setResourceValue("prod.map.nameType", "general");
        restree.setResourceValue("prod.map.command", "makeMapInfo");
        i = 50;
        while (restree.getResourceValue( "prod.map.status" ) == "busy" && i-- > 0 )
          restree.sleep( 300 );
		strGenMapName = restree.getResourceValue( "prod.map.gainMap" );
		  
		restree.setResourceValue("prod.map.nameType", "lensSpecific");
        restree.setResourceValue("prod.map.command", "makeMapInfo");
        i = 50;
        while (restree.getResourceValue( "prod.map.status" ) == "busy" && i-- > 0 )
          restree.sleep( 300 );
        strLensSpecMapName = restree.getResourceValue( "prod.map.gainMap" );
		
		}
    }
  }
  // Read filename of selected gainmap from calibration.
  var strPresGainMap = restree.getResourceValue( "image.ccase.staticGainMap" );
  if (strPresGainMap != "FAILED" && strPresGainMap != "<no match>" )  // Static map camera?
    strPresGainMap = restree.getResourceValue( strPresGainMap + ".fileName" );
  else                            
  {                                // P-type camera
     strPresGainMap = restree.getResourceValue( "image.ccase.gainMap" );  
     strPresGainMap = restree.getResourceValue( strPresGainMap + ".T.0.fileName" );
  }
  var strPresDeadMap = restree.getResourceValue( "image.ccase.deadPixMap" );
  strPresDeadMap = restree.getResourceValue( strPresDeadMap + ".fileName" );
  
  var strDeadPixStorage = restree.getResourceValue("prod.prodSpec.map.config.deadPixStorage");

  var bDpxInGainMap = ( strPresGainMap == strPresDeadMap ) || (strDeadPixStorage == "inGainMap");

  
  var strCurCasePath = restree.getResourceValue( "image.ccase.ccase" );
  var strCurCaseDescr = restree.getResourceValue( strCurCasePath + ".descr" );
  
  var strTitle = "Gain Mapping, Calculation";
%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    <body id="pgImgCorrGainMap">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuImgCorr", "mnuImgCorrGainMapCalc" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
               <B>Calculate map</B>
              <TABLE>
                <TR>
                  <TD VALIGN="top">
                    <BR>
                    <BR>
                    <FORM ACTION=GainMapResult.asp METHOD="POST">
                    <TABLE>
                      <TR>
                        <TD VALIGN="top" >Current Case:</TD>
                        <TD VALIGN="top"><%Response.Write( strCurCaseDescr );%></TD>
                      </TR>
                      <TR>
                        <TD VALIGN="top">Map type:</TD>
                        <TD>
                          <SELECT NAME="method" SIZE="5"<%if( !enabled || Ecode != 0 ) Response.Write( " disabled" );%>>
                            <OPTION VALUE="active" selected>1: The active map</OPTION>
                            <OPTION VALUE="specific">2: Specific map for current lens</OPTION>
                            <OPTION VALUE="dsgeneral">3: Map for cases of the same kind</OPTION>
                            <OPTION VALUE="general">4: Default map for all cases</OPTION>
                            <OPTION VALUE="lensSpecific">5: Map for current case</OPTION>
                          </SELECT><br><br>
                          Map type 3 in practice means similar cases for all lenses.
                        </TD>
                      </TR>
                      <TR>
                        <TD VALIGN="top">Map names:</TD>
                        <TD>
                        1:&nbsp;<%Response.Write( strPresGainMap ); %><br>
                        2:&nbsp;<%Response.Write( strSpecMapName ); %><br>
                        3:&nbsp;<%Response.Write( strDsGenMapName ); %><br>
                        4:&nbsp;<%Response.Write( strGenMapName ); %><br>
                        5:&nbsp;<%Response.Write( strLensSpecMapName ); %><br>
                        </TD>
                      </TR>
                      <TR>
                        <TD VALIGN="top">Bad pixels:</TD>
                        <TD>
                          <INPUT TYPE="checkbox" NAME="dpxLocation" VALUE="inGainMap" ID="dpxLocation" <%if( enabled && bDpxInGainMap ) Response.Write( " checked" ); if( !enabled || Ecode != 0 || bDpxInGainMap ) Response.Write( " disabled" );%>> &nbsp;Store in gain map
                        </TD>
                      </TR>
                      <TR>
                        <TD>
                          <br>
                          <INPUT TYPE="hidden" NAME="mode" VALUE="calcMap">
                          <INPUT TYPE="submit" NAME="calcMap" VALUE="Calculate Map"<%if( !enabled || Ecode != 0 ) Response.Write( " disabled" );%>>
                        </TD>
                        <TD>&nbsp;</TD>
                      </TR>
                    </TABLE
                    </FORM>
                    <BR>
                  </TD>
                  <TD VALIGN="top">
                    <%
                      if( enabled ) {
                        if( !started ) {
                          Response.Write( "Camera error : <span id=errstatus>Error starting production program</span>\n" );
                        }
                        else if( Ecode != 0 ) {
                          Response.Write( "Camera error : <span id=errstatus>" );
                          Response.Write( ecodeString( Ecode ) );
                          Response.Write( "</span>\n" );
                        }
                      }
                    %>
                    <p>Select a map type and press the <b>Calculate Map</b> button.</p>
                    <p>A more specific map will take priority over a general map. 
                       This can be quite confusing if you make a general map when a specific already exists. You will neither be able to activate the general map nor make any bad pixel replacements in it.</p>
                    <p>Please store the pixel replacement data in the gain maps. Having separate dead pixel maps becomes complicated when you have many maps.</p>
                  </TD>
                </TR>
             </TABLE>
            </div>
            <%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
