<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<%
  //
  // Create a calib case select tag.
  // The presently active calib case is preselected.
  //
  function caseSelector( rTree, name, nLines, extra ) {
    var casePath, presCase, fullPath, selTag;

    selTag = new SelectTag( name, nLines, extra );
    rTree.path = "";
    presCase = rTree.getResourceValue( "image.ccase.ccase" );
    rTree.path = "calib.ccase";
    casePath = rTree.getFirst();

    while( casePath != "" ) {
      fullPath = ".calib.ccase." + casePath;
      selTag.option( casePath, rTree.getResourceValue( casePath + ".descr" ), fullPath == presCase );
      casePath = rTree.getNext();
    }
    rTree.path = "";
    return selTag;
  }

  /* Main part of server side script */


  var selectTag = caseSelector( restree, "ccase", 1, "" );
  var strTitle = "Gain Mapping, Select Case"

%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    <body id="pgImgCorrGainMap">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuImgCorr", "mnuImgCorrGainMapSelCase" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
              <b>Select calib case</b>
              <TABLE>
                <TR>
                  <TD VALIGN="top">
                    <BR>
                    <BR>
                    <FORM ACTION=GainMapWarm.asp METHOD="POST">
                      <%selectTag.print();%>
                      <BR>
                      <BR>
                      <BR>
                      <INPUT TYPE="hidden" NAME="mode" VALUE="setup">
                      <INPUT TYPE="submit" NAME="setUp" VALUE="Camera SetUp">
                    </FORM>
                    <BR>
                  </TD>
                </TR>
             </TABLE>
            </div>
            <%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>

