<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<%
  //
  // Create find the current range description.
  //
  function findDescr( rTree ) {
    var presRange, descr, TMax, TMin;
	
	if ( CamType != "G")
	{
	  descr = restree.getResourceValue( restree.getResourceValue(".image.ccase.ccase") + ".descr");
	}
	else
	{
		rTree.path = "";
		presRange = rTree.getResourceValue( "image.services.TMax.arrayIndex" );
		rTree.path = "calib.detector.iTimeScaling.userTable." + presRange;
		TMax = -273.15 + rTree.getResourceValue( "TMax" );
		TMin = -273.13 + rTree.getResourceValue( "TMin" );
		descr = " " + TMin.toFixed(0) + " - " + TMax.toFixed(0) + "C (" + rTree.getResourceValue( "ds" ) + ")"
	    rTree.path = "";
	}

    return descr;
  }

  var enabled = true;
  var strTitle = "Gain Mapping, Warm Image"
  var strCurrentDescr = findDescr(restree);
%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    <body id="pgImgCorrGainMap">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuImgCorr", "mnuImgCorrGainMapWarm" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
              <b>Create warm image</b>
              <TABLE>
                <TR>
                  <TD VALIGN="top">
                    <BR>
                    <BR>
                    <FORM ACTION=GainMapCold.asp METHOD="POST">
                      <BR>
                      <BR>
                      <BR>
                      <INPUT TYPE="hidden" NAME="mode" VALUE="readWarm">
                      <INPUT TYPE="submit" NAME="readWarm" VALUE="Read Warm Image"<%if( !enabled ) Response.Write( " disabled" );%>>
                    </FORM>
                    <BR>
                  </TD>
                  <TD VALIGN="top">
                    <p>For: <%Response.Write(strCurrentDescr);%>&nbsp;(<a href=ImgCorrSelCase.asp>Change</a>)</p>
                    <p>Point the camera at the warm blackbody<br>
                    and press the <b>Read Warm Image</b> button.</p>
                  </TD>
                </TR>
             </TABLE>
            </div>
            <%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
