<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<%
  var enabled = false;
  var editMapName = true;
  var presGainMap;
  var presMapEnable;
	var DS = "?";
	var BB = "?";
	var ECode = 0;

  var started = false;
  var Ecode = 0;
      
  if (restree.getResourceValue( "prod.log.status" ) == "ready")
    started = true;

  /*
   * Start the production application, unless already done
   */
  if( !started ) {
	restree.setResourceValue( "appl.supv.exec",  "prodapp" );
	for( i = 0; i < 100; i++ ) {
	  if (restree.getResourceValue( "prod.log.status" ) == "ready")
	  {
		started = true;
		break;
	  }
	  restree.sleep( 300 );
	}
  }

  var MapName = "-";  
  if( Request.Form.Count > 0 ) 
  {
      // Read filename of selected gainmap from calibration.
      if( CamType == "G" ) {
        restree.setResourceValue( "prod.tdrift.filename", "" );  // Clear file name to get default file name

				if ( Request.Form("shuttermapHT") != "" )
					restree.setResourceValue( "prod.tdrift.command", "shutterMapHT" ); 

        if ( Request.Form("shuttermap") != "" )
        restree.setResourceValue( "prod.tdrift.command", "saveShutterMap" ); 


        i = 50;
        while( restree.getResourceValue( "prod.tdrift.status" ) == "busy" && i-- > 0 )
            restree.sleep( 300 );

        ecode = restree.getResourceValue( "prod.tdrift.ecode" );
        if( ecode == 1 ) {
            restree.setResourceValue( "prod.tdrift.command", "init" ); 
       
            i = 50;
            while (restree.getResourceValue( "prod.tdrift.status" ) == "busy" && i-- > 0 )
              restree.sleep( 300 );

            restree.setResourceValue( "prod.tdrift.filename", "" );  // Clear file name to get default file name

						if ( Request.Form("shuttermapHT") != "" )
							restree.setResourceValue( "prod.tdrift.command", "shutterMapHT" ); 

						if ( Request.Form("shuttermap") != "" )
            restree.setResourceValue( "prod.tdrift.command", "saveShutterMap" ); 

            i = 50;
            while (restree.getResourceValue( "prod.tdrift.status" ) == "busy" && i-- > 0 )
                restree.sleep( 300 );

          }
           MapName = restree.getResourceValue( "prod.tdrift.externalComment" );
           restree.setResourceValue( "prod.tdrift.externalComment", "" );
      }                
      if( restree.getResourceValue( "prod.tdrift.status" ) == "error" ) {
				var ECode = restree.getResourceValue( "prod.tdrift.ecode" );

			}
  }
  else
    MapName = "";

	 DS = restree.getResourceValue( "prod.prodSpec.tdrift.shutterMapTableHT.0.ds" );
	 BB = restree.getResourceValue( "prod.prodSpec.tdrift.shutterMapTableHT.0.BBtemp" );
	 BB = BB - 273.15;
	 BB = BB.toFixed( 0 );


%>
<html>
    <head>
        <title><%Response.Write( " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    </head>
    <body id="pgShutterMap1">
        <%printStandardDecoration( "Make shutter map for Ghost camera" );%>
        <%printNavigation( "mnuImgCorr", "mnuImgCorrGainMapSelCase" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE WIDTH="80%">
                    <TR>
                        <TD VALIGN="top">
                            <P>Point the camera at a blackbody.</P>
                            <P>Press the <b>Shutter map</b> button to store a Shutter map for current case and integration time</P>

                        </TD>
                    </TR>
                    <TR>
                        <TD VALIGN="top">
                            <FORM ACTION="shuttermap.asp" METHOD="post" NAME="shuttermap" ID="shuttermap">
                                <BR>
                                  <INPUT TYPE="submit" NAME="shuttermap" VALUE="Create shutter map">
                            </FORM>
                        </TD>
                    </TR>
                    <TR>
                        <TD VALIGN="top">
                            <P>Or press the <b>ShutterHT map</b> button to store a ShutterHT map for DS:
														<b><%Response.Write( DS )%></b></P>
														<P>Use BlackBody temperature:<b>&nbsp;<%Response.Write( BB )%>&nbsp;C</b></P>
                        </TD>
                    </TR>
                    <TR>
                        <TD VALIGN="top">
                            <FORM ACTION="shuttermap.asp" METHOD="post" NAME="shuttermapHT" ID="shuttermapHT">
                                <BR>
                                  <INPUT TYPE="submit" NAME="shuttermapHT" VALUE="Create HT shutter map">
                            </FORM>
                        </TD>
                    </TR>
                    <TR>
                        <TD VALIGN="top">
														<% if( ECode > 0 )
																Response.Write("<span id=errstatus>" + ecodeString( ECode ) + "</span>&nbsp;");
															else {
																Response.Write( "Map created: " );
																Response.Write( MapName );
															}
														%>
                        </TD>
                    </TR>
                </TABLE>
            </div>
			<%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
