<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<%
  var started = false;
  var enabled = false;
  var editMapName = true;
  var presGainMap = "";
  var testResPath = "prod.measure.status";
  var Ecode = 0;
  var ValueType;

  if( CamType == "Z" || CamType == "Z3" ) 
  {
    testResPath = "prod.map.status";
  }
  
  ValueType = restree.valueType( testResPath );
  if( ValueType != "N/A") /* This works on all types of values */
  { 
    started = true;
  }

  if( Request.Form.Count > 0 ) 
  {
    if( Request.Form( "mode" ) == "staticWarm" ) 
    {
      /*
       * Start the production application, unless already done
       */
      if( !started ) 
      {
        restree.setResourceValue( "appl.supv.exec",  "prodapp" );
        for( i = 0; i < 50; i++ ) 
        {
          ValueType = restree.valueType( testResPath );
          if( ValueType != "N/A") 
          {
            started = true;
            break;
          }
          restree.sleep( 300 );
        }
      }
      
      if( started ) 
      {
          /* Is this a X camera? */
          if( CamType == "X" ) 
          {
            enabled = true;
            restree.setResourceValue( "prod.measure.command", "init"  );
            for( i = 0; i < 50; i++ ) 
            {
              Status = restree.getResourceValue( "prod.measure.status" );
              if( Status != "busy" ) 
              {
                break;
              }
              restree.sleep( 300 );
            }
            if( Status == "ready" ) 
            {
              restree.setResourceValue( "prod.measure.avgimages", 16  );
              restree.setResourceValue( "prod.measure.filename", "/Temp/warm.fff"  );
              restree.setResourceValue( "prod.measure.command", "averageImage"  );
              for( i = 0; i < 50; i++ ) 
              {
                Status = restree.getResourceValue( "prod.measure.status" );
                if( Status != "busy" ) 
                {
                  break;
                }
                restree.sleep( 300 );
              }
            }
            presGainMap = Request.Form( "mapname" );
            Ecode = restree.getResourceValue( "prod.measure.ecode" );
          }
          /* Is this a Z camera? */
          else if (CamType == "Z" || CamType == "Z3" )
          {
            enabled = true;
            editMapName = false;
            /* Init map subsystem */
            restree.setResourceValue( "prod.map.command", "init"  );
            for( i = 0; i < 50; i++ ) 
            {
              Status = restree.getResourceValue( "prod.map.status" );
              if( Status != "busy" ) 
              {
                break;
              }
              restree.sleep( 300 );
            }
            if( Status == "ready" ) 
            {
              /* Turn of filters
                 Make map info 
                 */
              restree.setResourceValue( "image.flow.digitalFilter.globEnabled", "false" );
              restree.setResourceValue( "prod.map.nameType", "active"  );
              restree.setResourceValue( "prod.map.command", "makeMapInfo"  );
              for( i = 0; i < 50; i++ ) 
              {
                Status = restree.getResourceValue( "prod.map.status" );
                if( Status != "busy" ) 
                {
                  break;
                }
                restree.sleep( 300 );
              }
            }
            if( Status == "ready" ) 
            {
              /* Measure warm image */
              restree.setResourceValue( "prod.map.warmImage", "/Temp/warm.fff"  );
              restree.setResourceValue( "prod.map.command", "measWarmImage"  );
              for( i = 0; i < 50; i++ ) 
              {
                Status = restree.getResourceValue( "prod.map.status" );
                if( Status != "busy" ) 
                {
                  break;
                }
                restree.sleep( 300 );
              }
            }
            /* Read any error code */
            presGainMap = Request.Form( "mapname" );
            Ecode = restree.getResourceValue( "prod.map.ecode" );
          }
      }
    }
  }
  var strTitle = "Gain Mapping, Warm Image";
%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    </head>
    <body id="pgStaticMapping">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuImgCorr", "mnuImgCorrStaticMapCold" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE WIDTH="95%">
                    <%
                      if( enabled ) {
                        if( !started ) {
                          Response.Write( '<TR><TD BGCOLOR="#FF0000">Error starting production program</TD></TR>\n' );
                        }
                        else if( Ecode != 0 ) {
                          Response.Write( '<TR><TD BGCOLOR="#FF0000">' );
                          Response.Write( ecodeString( Ecode ) );
                          Response.Write( '</TD></TR>\n' );
                        }
                      }
                    %>
                    <TR>
                        <TD VALIGN="top" WIDTH="50%">
                            <FORM ACTION="StaticMapCalc.asp" METHOD="post" NAME="staticCold" ID="Form1">
                                Static map name
                                <BR>
                                <BR>
                                <INPUT TYPE="text" MAXLENGTH="40" SIZE="40" NAME="mapname" VALUE="<%Response.Write( presGainMap );%>" ID="Text1"<%if (!enabled ) {Response.Write( " disabled" );} else if (!editMapName) {Response.Write( " readonly" );} %>><BR>
                                <BR>
                                <BR>
                                <INPUT TYPE="hidden" NAME="mode" VALUE="staticCold">
                                <INPUT TYPE="submit" VALUE="Read Cold Image" ID="Submit1" NAME="Submit1"<%if (!enabled ) Response.Write( " disabled" ); %>>
                            </FORM>
                        </TD>
                        <TD VALIGN="top" WIDTH="50%">
                            <P>Point the camera at a cold blackbody.</P>
                            <P>Press the <b>Read Cold Image</b> button to store the cold image.</P>
                        </TD>
                    </TR>
                </TABLE>
            </div>
			<%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
