<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<%
  var presGainMap;
  var enabled = false;
  // Read filename of selected gainmap from calibration.
  if( CamType == "X" ) 
  {
    enabled = true;
    var defaultMapName = "ds350C_we1_ap_fi_le_static.gan";
    presGainMap = restree.getResourceValue( "image.ccase.gainMap" );
    presGainMap = restree.getResourceValue( presGainMap + ".static.fileName" );
    if( presGainMap == "FAILED" || presGainMap == "" )
      presGainMap = defaultMapName;
  }
  else if( CamType == "Z" || CamType == "Z3" ) 
  {
    var defaultMapName = "ds250C_we_ap_fi_le.gan";
    presGainMap = restree.getResourceValue( "image.ccase.staticGainMap" );
    presGainMap = restree.getResourceValue( presGainMap + ".fileName" );
    if( presGainMap == "FAILED" || presGainMap == "" )
      presGainMap = defaultMapName;
  }
  var strTitle = "Gain Mapping, Prepare";
%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    </head>
    <body id="pgStaticMapping">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuImgCorr", "mnuImgCorrStaticMapPrepare" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE WIDTH="95%">
                    <TR>
                        <TD VALIGN="top" WIDTH="50%">
                            <FORM ACTION="StaticMapWarm.asp" METHOD="post" NAME="staticPrepare" ID="Form1">
                                Static map name
                                <BR>
                                <BR>
                                <INPUT TYPE="text" MAXLENGTH="40" SIZE="40" NAME="mapname" VALUE="<%Response.Write( presGainMap );%>" ID="Text1"<%if (!enabled ) Response.Write( " readonly" ); %>><BR>
                                <BR>
                                <BR>
                                <INPUT TYPE="hidden" NAME="mode" VALUE="staticPrepare">
                                <INPUT TYPE="submit" VALUE="Prepare" ID="Submit1" NAME="Submit1">
                            </FORM>
                        </TD>
                        <TD VALIGN="top" WIDTH="50%">
                            <P>Set the map name to the desired string. <%Response.Write(CamType);%>&nbsp;usually uses
                               the map name <%Response.Write( defaultMapName );%></P>
                            <P>Press the <b>Prepare</b> button to prepare the camera for
                               the static map procedure.</P>
                        </TD>
                    </TR>
                </TABLE>
            </div>
			<%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
