<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<%
  var enabled = false;
  var editMapName = true;
  var presGainMap;
  var presMapEnable;

  if( Request.Form.Count > 0 ) 
  {
    if( Request.Form( "mode" ) == "staticPrepare" ) 
    {
      enabled = true;
      // Read filename of selected gainmap from calibration.
      if( CamType == "X" ) 
      {
        presMapEnable = restree.getResourceValue( "image.ccase.gainMap" );
        if( presMapEnable == "FAILED" || presMapEnable == "" )
          presMapEnable = ".calib.detector.gainMap.ds350C_we1_ap_fi_le";
		    presMapEnable += ".static.enabled";
        restree.setResourceValue( presMapEnable, false );
	    }
	    else if( CamType == "Z" || CamType == "Z3" ) 
	    {
	      editMapName = false;
	      presMapEnable = restree.getResourceValue( "image.ccase.staticGainMap" );
	      if( presMapEnable == "FAILED" || presMapEnable == "" )
	        presMapEnable = ".calib.detector.staticGainMap.ds250C_we_ap_fi_le";
	  	  presMapEnable += ".enabled";
        /* Not needed for Z (I hope (:)
        restree.setResourceValue( presMapEnable, false );
        */
  	  }
      presGainMap = Request.Form( "mapname" );

      restree.setResourceValue( "image.state.live.set",  true );
      restree.setResourceValue( "tcomp.services.autoNuc.active",  false );
      restree.res.SetBoolValueWait( "image.services.range.commit", 1 );
      for( i = 0; i < 50; i++ ) 
      {
        Status = restree.getResourceValue( "image.services.range.status" );
        if( Status == 0 ) 
        {
          break;
        }
        restree.sleep( 300 );
      }
    }
  }
  var strTitle = "Gain Mapping, Warm Image";
%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    </head>
    <body id="pgStaticMap">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuImgCorr", "mnuImgCorrStaticMapWarm" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE WIDTH="95%">
                    <TR>
                        <TD VALIGN="top" WIDTH="50%">
                            <FORM ACTION="StaticMapCold.asp" METHOD="post" NAME="staticWarm" ID="Form1">
                                Static map name
                                <BR>
                                <BR>
                                <INPUT TYPE="text" MAXLENGTH="40" SIZE="40" NAME="mapname" VALUE="<%Response.Write( presGainMap );%>" ID="Text1"<%if (!enabled ) {Response.Write( " disabled" );} else if (!editMapName) {Response.Write( " readonly" );} %>><BR>
                                <BR>
                                <BR>
                                <INPUT TYPE="hidden" NAME="mode" VALUE="staticWarm">
                                <INPUT TYPE="submit" VALUE="Read Warm Image" ID="Submit1" NAME="Submit1"<%if (!enabled ) Response.Write( " disabled" ); %>>
                            </FORM>
                        </TD>
                        <TD VALIGN="top" WIDTH="50%">
                            <P>Point the camera at a warm blackbody.</P>
                            <P>Press the <b>Read Warm Image</b> button to store the warm image.</P>
                        </TD>
                    </TR>
                </TABLE>
            </div>
			<%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
