<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<%
//
// Create find the current range name.
//
function rangeName( rTree ) {
	var presRange, rangeDescr, TMax, TMin;

	rTree.path = "";
	presRange = rTree.getResourceValue( "image.services.TMax.arrayIndex" );
	rTree.path = "calib.detector.iTimeScaling.userTable." + presRange;
	TMax = -273.15 + rTree.getResourceValue( "TMax" );
	TMin = -273.13 + rTree.getResourceValue( "TMin" );
	rangeDescr = " " + TMin.toFixed(0) + " - " + TMax.toFixed(0) + " (" + rTree.getResourceValue( "ds" ) + ")"
		rTree.path = "";
	return rangeDescr;
}

var started = false;
var enabled = false;
var Ecode = 0;
var strSpecMapName = "Unknown";


if (restree.getResourceValue( "prod.log.status" ) == "ready")
started = true;

if( Request.Form.Count > 0 ) {
	if( Request.Form( "mode" ) == "readCold" ) {
		enabled = true;
		/*
		* Start the production application, unless already done
		*/
		if( !started ) {
			restree.setResourceValue( "appl.supv.exec",  "prodapp" );
			for( i = 0; i < 50; i++ ) {
				if (restree.getResourceValue( "prod.log.status" ) == "ready")
				{
					started = true;
					break;
				}
				restree.sleep( 300 );
			}
		}
		if( started ) 
		{
			restree.setResourceValue( "prod.map.coldImage", "/Temp/cold.fff" );

			restree.setResourceValue( "prod.map.command", "measColdImage" );

			i = 50;
			while (restree.getResourceValue( "prod.map.status" ) == "busy" && i-- > 0 )
				restree.sleep( 300 );

			//
			// Return error code of last command.
			//
			Ecode = restree.getResourceValue( "prod.map.ecode" );

			//
			// Pick up the relevant Gain Map name
			//
			restree.setResourceValue("prod.map.nameType", "curAlphaIT");
			restree.setResourceValue("prod.map.command", "makeMapInfo");
			i = 500;
			while (restree.getResourceValue( "prod.map.status" ) == "busy" && i-- > 0 )
				restree.sleep( 300 );

			EcodeTmp = restree.getResourceValue( "prod.map.ecode" );
			if ( Ecode == 0 )
				Ecode = EcodeTmp;

			strSpecMapName = restree.getResourceValue( "prod.map.gainMap" );
		}
	}
}
var strRangeName = rangeName(restree);

var strPresDeadMap = restree.getResourceValue( "image.ccase.deadPixMap" );
strPresDeadMap = restree.getResourceValue( strPresDeadMap + ".fileName" );

var strTitle = "Gain Mapping, Calculation";
%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    <body id="pgImgCorrGainMap">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuImgCorr", "mnuImgCorrGainMapCalc" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
               <B>Calculate map</B>
              <TABLE>
                <TR>
                  <TD VALIGN="top">
                    <BR>
                    <BR>
                    <FORM ACTION=GainMapResult.asp METHOD="POST">
                    <TABLE>
                      <TR>
                        <TD VALIGN="top" >Current Range:</TD>
                        <TD>&nbsp;<%Response.Write( strRangeName);%></TD>
                      </TR>
                      <TR>
                        <TD VALIGN="top">Map type:</TD>
                        <TD>&nbsp;Range specific </TD>
                        <INPUT TYPE="hidden" NAME="method" VALUE="curAlphaIT">
                      </TR>
                      <TR>
                        <TD VALIGN="top">Map name:</TD>
                        <TD>&nbsp;<%Response.Write( strSpecMapName ); %></TD>
                      </TR>
                      <TR>
                        <TD>
						  <INPUT TYPE="hidden" NAME="dpxLocation" VALUE="inDeadMap">
                        </TD>
                      </TR>
                      <TR>
                        <TD>
                          <br>
                          <INPUT TYPE="hidden" NAME="mode" VALUE="calcMap">
                          <INPUT TYPE="submit" NAME="calcMap" VALUE="Calculate Map"<%if( !enabled || Ecode != 0 ) Response.Write( " disabled" );%>>
                        </TD>
                        <TD>&nbsp;</TD>
                      </TR>
                    </TABLE
                    </FORM>
                    <BR>
                  </TD>
                  <TD VALIGN="top">
                    <%
                      if( enabled ) {
                        if( !started ) {
                          Response.Write( "Camera error : <span id=errstatus>Error starting production program</span>\n" );
                        }
                        else if( Ecode != 0 ) {
                          Response.Write( "Camera error : <span id=errstatus>" );
                          Response.Write( ecodeString( Ecode ) );
                          Response.Write( "</span>\n" );
                        }
                      }
                    %>
                    <p>Please press the <b>Calculate Map</b> button.</p>
                  </TD>
                </TR>
             </TABLE>
            </div>
            <%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
