<%

var ShowUnImplemented = 0;

function printNavigation( expandedMenu, selectedMenu )
{
	Response.Write('<div id="navigation"><ul>');
	menuRow("Service Menu", "/service/index.asp", "topmenu", selectedMenu == "mnuServiceWeb");	
	menuRow("Camera Information", "/service/CamInfo/index.asp", "mainmenu", selectedMenu == "mnuCamInfo");
	if ((expandedMenu == "mnuCamInfo") || (expandedMenu=="ALL"))
	{
		menuRow("Components", "/service/CamInfo/Components.asp", "submenu1", selectedMenu == "mnuCamInfoComponents");
		menuRow("Operability Specification", "/service/CamInfo/OpSpec.asp", "submenu1", selectedMenu == "mnuCamInfoOpSpec");
		menuRow("Calibration Protocol", "/service/CamInfo/calibprot.asp", "submenu1", selectedMenu == "mnuCamInfoCalibProt");
		menuRow("Accuracy Protocol", "/service/CamInfo/AccProt.asp", "submenu1", selectedMenu == "mnuCamInfoAccProt");
	}

	menuRow("Date &amp; Time", "/service/DateNTime.asp", "mainmenu", selectedMenu == "mnuDateNTime");

	menuRow("Production problem report", "/service/ppr.asp", "mainmenu", selectedMenu == "mainmenu");

	menuRow("EEPROM", "/service/EEPROM/index.asp", "mainmenu", selectedMenu == "mnuEEPROM");
	if ((expandedMenu == "mnuEEPROM") || (expandedMenu=="ALL"))
	{
		menuRow("Edit Camera Information", "/service/EEPROM/EdCamInfo.asp", "submenu1", selectedMenu == "mnuEEPROMEdCamInfo");
		menuRow("Edit Components", "/service/EEPROM/EdComp.asp", "submenu1", selectedMenu == "mnuEEPROMEdComp");
		if ( CamType != "X" && CamType != "X2" && CamType != "Z" )
			menuRow("Edit Lens", "/service/EEPROM/EdLens.asp", "submenu1", selectedMenu == "mnuEEPROMEdLens");
	}

	menuRow("Drift Compensation", "/service/TDrift/index.asp", "mainmenu", selectedMenu == "mnuTDRIFT");
	if ((expandedMenu == "mnuTDRIFT") || (expandedMenu=="ALL"))
	{
		if ( ShowUnImplemented )
			menuRow("Control parameters", "/service/TDRIFT/CtrPar.asp", "submenu1", selectedMenu == "mnuTDRIFTCtrPar");
		menuRow("Temperature Sensors", "/service/TDRIFT/Sensors.asp", "submenu1", selectedMenu == "mnuTDRIFTSensors");
		menuRow("Current compensation", "/service/TDRIFT/CurComp.asp", "submenu1", selectedMenu == "mnuTDRIFTCurComp");
		if ( CamType != "G" ) {
			menuRow("Logging", "/service/TDRIFT/Logging.asp", "submenu1", selectedMenu == "mnuTDRIFTLogging");
		}
	}
	menuRow("Image Correction", "/service/ImgCorr/index.asp", "mainmenu", selectedMenu == "mnuImgCorr");
	if ((expandedMenu == "mnuImgCorr") || (expandedMenu=="ALL"))
	{
		if ( CamType != "X" && CamType != "Z" )
		{
			if ( CamType != "G" ) {
				menuRow("Select Case", "/service/ImgCorr/ImgCorrSelCase.asp", "submenu1", selectedMenu == "mnuImgCorrSelCase");
			} else {
				menuRow("Select Range", "/service/ImgCorr/ImgCorrSelCase.asp", "submenu1", selectedMenu == "mnuImgCorrSelCase");
			}
			menuRow("Gain Mapping", "/service/ImgCorr/GainMap.asp", "submenu1", selectedMenu == "mnuImgCorrGainMap");
			menuRow("Warm Image", "/service/ImgCorr/GainMapWarm.asp", "submenu2", selectedMenu == "mnuImgCorrGainMapWarm");
			menuRow("Cold Image", "/service/ImgCorr/GainMapCold.asp", "submenu2", selectedMenu == "mnuImgCorrGainMapCold");
			if ( CamType != "G" ) {
				menuRow("Calc map", "/service/ImgCorr/GainMapCalc.asp", "submenu2", selectedMenu == "mnuImgCorrGainMapCalc");
			} else {
				menuRow("Calc map", "/service/ImgCorr/GainMapCalcGF.asp", "submenu2", selectedMenu == "mnuImgCorrGainMapCalc");
			}
		}
		else 
		{
			menuRow("Gain Mapping", "/service/ImgCorr/StaticMap.asp", "submenu1", selectedMenu == "mnuImgCorrStaticMap");
			menuRow("Prepare", "/service/ImgCorr/StaticMapPrepare.asp", "submenu2", selectedMenu == "mnuImgCorrStaticMapPrepare");
			menuRow("Warm Image", "/service/ImgCorr/StaticMapWarm.asp", "submenu2", selectedMenu == "mnuImgCorrStaticMapWarm");
			menuRow("Cold Image", "/service/ImgCorr/StaticMapCold.asp", "submenu2", selectedMenu == "mnuImgCorrStaticMapCold");
			menuRow("Calc map", "/service/ImgCorr/StaticMapCalc.asp", "submenu2", selectedMenu == "mnuImgCorrStaticMapCalc");
		}
		if ( CamType == "G" ) {
			menuRow("Shutter map", "/service/ImgCorr/shuttermap.asp", "submenu1", selectedMenu == "mnuImgCorrStaticMapCalc");
		}
		menuRow("Pixel replacement", "/service/ImgCorr/PixKill.asp", "submenu1", selectedMenu == "mnuImgCorrPixKill");
		menuRow("Operability check", "/service/ImgCorr/Operability.asp", "submenu1", selectedMenu == "mnuImgCorrOperability");
		menuRow("Operability result", "/service/ImgCorr/OperabilityLog.asp", "submenu2", selectedMenu == "mnuImgCorrOperabilityLog");
		if ( ShowUnImplemented )
		{
			menuRow("Noise Reduction", "/service/ImgCorr/Noise.asp", "submenu1", selectedMenu == "mnuImgCorrNoise");
		}
	}

	menuRow("Calibration", "/service/Calib/index.asp", "mainmenu", selectedMenu == "mnuCalib");
	if ((expandedMenu == "mnuCalib") || (expandedMenu=="ALL"))
	{
		menuRow("System Recalibration", "/service/Calib/SysCalib.asp", "submenu1", selectedMenu == "mnuCalibSysCalib");
		if ( CamType != "X" && CamType != "Z" )
			menuRow("Enable/Disable Cases", "/service/Calib/SysCalibEnaDisa.asp", "submenu2", selectedMenu == "mnuCalibSysCalibEnaDisa");
		if ( CamType == "G" )
			menuRow("Enable/Disable Ranges", "/service/Calib/syscalibRangeEnaDisa.asp", "submenu2", selectedMenu == "mnuCalibSysCalibRangeEnaDisa");	
		menuRow("Edit Case Limits", "/service/Calib/SysCalibEditLimits.asp", "submenu2", selectedMenu == "mnuCalibSysCalibEditLimits");
		if ( CamType != "X" && CamType != "X2" && CamType != "Z" )
			menuRow("Add Lens Cases", "/service/Calib/SysCalibAddLensCase.asp", "submenu2", selectedMenu == "mnuCalibSysCalibAddLensCase");
		if ( CamType == "A" )
			menuRow("Set Far Focus", "/service/Calib/SysCalibFarFocus.asp", "submenu2", selectedMenu == "mnuCalibSysCalibFarFocus");	
		menuRow("Select Cases", "/service/Calib/SysCalibSelect.asp", "submenu2", selectedMenu == "mnuCalibSysCalibSelect");
		menuRow("Measure Signal", "/service/Calib/SysCalibMeasure.asp", "submenu2", selectedMenu == "mnuCalibSysCalibMeasure");
		menuRow("Edit Measurements", "/service/Calib/SysCalibEditMeas.asp", "submenu2", selectedMenu == "mnuCalibSysCalibEditMeas");
		menuRow("Calculate RBF", "/service/Calib/SysCalibCalculate.asp", "submenu2", selectedMenu == "mnuCalibSysCalibCalculate");
		menuRow("Save or Activate RBF", "/service/Calib/SysCalibActivate.asp", "submenu2", selectedMenu == "mnuCalibSysCalibActivate");
		menuRow("Show Cal Protocol", "/service/Calib/SysCalibProtocol.asp", "submenu2", selectedMenu == "mnuCalibSysCalibProtocol");
		menuRow("Switch Calibration", "/service/Calib/SysCalibSwitch.asp", "submenu2", selectedMenu == "mnuCalibSysCalibSwitch");
		menuRow("Lens transmission", "/service/Calib/transmission.asp", "submenu2", selectedMenu == "mnuCalibTransM");

		menuRow("Accuracy Measurement", "/service/Calib/AccMeas.asp", "submenu1", selectedMenu == "mnuCalibAccMeas");
		menuRow("Select Cases", "/service/Calib/AccMeasSelect.asp", "submenu2", selectedMenu == "mnuCalibAccMeasSelect");
		menuRow("Set Object Parameters", "/service/Calib/AccMeasSetObjpar.asp", "submenu2", selectedMenu == "mnuCalibAccMeasSetObjpar");
		menuRow("Measure Temperature", "/service/Calib/AccMeasMeasure.asp", "submenu2", selectedMenu == "mnuCalibAccMeasMeasure");
		menuRow("Remove Temperature", "/service/Calib/AccMeasRemove.asp", "submenu2", selectedMenu == "mnuCalibAccMeasRemove");
		menuRow("Show Acc Protocol", "/service/Calib/AccMeasProtocol.asp", "submenu2", selectedMenu == "mnuCalibAccMeasProtocol");
		if ( CamType == "E3" || CamType == "Pt" )
			menuRow("Calibrate Accelerometer", "/service/Calib/CalibAcc.asp", "submenu1", selectedMenu == "mnuCalibAccMeasProtocol");
	}


	if ( CamType == "E" || CamType == "P"|| CamType == "Pt" || CamType == "X2" || CamType == "A2" || CamType == "E2" || CamType == "E3" || CamType == "Z3" ) {
		var article = "";
		if ( CamType == "E" ) {
			restree.path = "";
			article = restree.getResourceValue( "version.hw.mainboard.article" );
		}
		menuRow("Focusing", "/service/Focus/index.asp", "mainmenu", selectedMenu == "mnuFocus");
		if ((expandedMenu == "mnuFocus") || (expandedMenu=="ALL")) {
			if( CamType == "Z3" ) {
				menuRow("Alignment", "/service/Focus/AlignMentPt.asp", "submenu1", selectedMenu == "mnuFocusAlignmentPt");
				menuRow("LensDistortion", "/service/Focus/LensDist.asp", "submenu1", selectedMenu == "mnuFocusLensDist");
			}
			else if( CamType == "Pt" || CamType == "E3" || CamType == "E2" ) {
				menuRow("Alignment", "/service/Focus/AlignMentPt.asp", "submenu1", selectedMenu == "mnuFocusAlignment");
				menuRow("Laser Calibration", "/service/Focus/Laser.asp", "submenu1", selectedMenu == "mnuFocusLaser");
			}
			else {
				menuRow("Alignment", "/service/Focus/AlignMent.asp", "submenu1", selectedMenu == "mnuFocusAlignment");
				if ( CamType == "P" || CamType == "X2" || CamType == "G" || article == "T197383" )
					menuRow("Laser Calibration", "/service/Focus/Laser.asp", "submenu1", selectedMenu == "mnuFocusLaser");
			}
			if( CamType == "A2" || CamType == "Pt" || CamType == "E2" || CamType == "E3" ) {
				menuRow("Focus(single distance)", "/service/Focus/FocusSD.asp", "submenu1", selectedMenu == "mnuFocusSD");
				menuRow("Focus", "/service/Focus/Focus.asp", "submenu1", selectedMenu == "mnuFocusDD");
				if( CamType == "Pt" ) {
					menuRow("Vis-Vis(cont autofocus)", "/service/Focus/alignmentvisvis.asp", "submenu1", selectedMenu == "mnuVisVis");
				}
			}
		}
	}

	menuRow("Diagnostics", "/service/Diag/index.asp", "mainmenu", selectedMenu == "mnuDiag");
	if ((expandedMenu == "mnuDiag") || (expandedMenu=="ALL"))
	{
		menuRow("Power-On Test", "/service/Diag/POST.asp", "submenu1", selectedMenu == "mnuDiagPost");
		menuRow("Power-On Test Log", "/service/Diag/POSTLog.asp", "submenu2", selectedMenu == "mnuDiagPostLog");
		menuRow("Built-In Test", "/service/Diag/BIT.asp", "submenu1", selectedMenu == "mnuDiagBIT");
		menuRow("Self Test", "/service/Diag/BITSelfTest.asp", "submenu2", selectedMenu == "mnuDiagBITSelfTest");
		menuRow("Interactive Test", "/service/Diag/BITInteractive.asp", "submenu2", selectedMenu == "mnuDiagBITInteractive");
		if ( CamType == "G" )
			menuRow("Cooler Test", "/service/Diag/BITCooler.asp", "submenu2", selectedMenu == "mnuDiagBITCooler");
		menuRow("Noise Tests", "/service/Diag/Noise.asp", "submenu1", selectedMenu == "mnuDiagNoise");
		menuRow("Noise Measurements", "/service/Diag/NoiseMeasure.asp", "submenu2", selectedMenu == "mnuDiagNoiseMeasure");
		menuRow("Noise Results", "/service/Diag/NoiseResults.asp", "submenu2", selectedMenu == "mnuDiagNoiseResults");
		menuRow("Usage statistics", "/service/Diag/Statistics.asp", "submenu1", selectedMenu == "mnuDiagStatistics");
		if ( CamType == "Z" || CamType == "P" || CamType == "P" || CamType == "X2" || CamType == "G" )
			menuRow("Service Due", "/service/Diag/ServiceDue.asp", "submenu1", selectedMenu == "mnuDiagServiceDue");
		if ( CamType == "E" || CamType == "X2" || CamType == "E2" )
			menuRow("Activate Service Mode", "/service/Diag/HighRes.asp", "submenu1", selectedMenu == "mnuDiagResolution");
		if ( CamType == "Z" )
			menuRow("Activate Service Mode", "/service/Diag/Reconfig.asp", "submenu1", selectedMenu == "mnuDiagReconfig");

	}
	Response.Write("<li></li>");
	menuRow("User Menu", "/index.asp", "mainmenu", selectedMenu == "mnuUserWeb");	

	Response.Write("</ul></div>");
}

%>
